local skillCfg = {}

local cellNum = {}
local reader = TFReader:create('skill_cell_num.txt')
for k = 1, reader:GetItemCount() do
	local cfg = {}
	cfg.lv = reader:Read(k, 'lv', 0)
	cfg.cellNum = reader:Read(k, 'cellNum', 0)
	cellNum[#cellNum + 1] = cfg
end

local skills = {{},{},{}}
local reader = TFReader:create('skills.txt')
for k = 1, reader:GetItemCount() do
	local cfg = {}
	cfg.id = reader:Read(k, 'id', 0)
	cfg.race = reader:Read(k, 'race', 0)
	cfg.name = reader:Read(k, 'name', '')
	cfg.icon = reader:Read(k, 'icon', '')
	cfg.desc = reader:Read(k, 'effect', '')
	cfg.costMp = reader:Read(k, 'costMp', 0)
	cfg.openLv = reader:Read(k, 'skillsLv', 0)
	cfg.mecuse = reader:Read(k, 'mecuse', false)
	skillCfg[cfg.id] = cfg
	local races = skills[cfg.race + 1]
	races[#races + 1] = cfg.id
end

function skillCfg.GetSkillCellNum(lv)
	local num = 0
	for k, v in ipairs(cellNum) do
		if v.lv > lv then break end
		num = v.cellNum
	end
	return num
end

function skillCfg.GetSkillList(race)
	return skills[race + 1]
end

--------------------------------
--------------------------------
-- buff config
local buffCfg = {}
local reader = TFReader:create('buff.txt')
for k = 1, reader:GetItemCount() do
	local id = reader:Read(k, 'id', 0)
	local cfg = {}
	cfg.name = reader:Read(k, 'name', '')
	buffCfg[id] = cfg
end

function skillCfg.GetBuffCfg(id)
	return buffCfg[id]
end

return skillCfg