local proto = require'protocol'
local sceneCfg = require'config.scene'
local actionMgr = require'action'

local tcast = tolua.cast

local cVer = BattleMap
BattleMap = class('BattleMap', CppUI)
local super = BattleMap.__super

function BattleMap:init()
	local sceneId = PLAYER_BASE_DATA.sceneId
	local lv = self:seekWidgetByName('map_list')
	local children = lv:getChildren()
	for k = 1, children:count() do
		local w = tcast(children:objectAtIndex(k), 'Widget')
		local btnLook = UIHO:seekWidgetByName(w, 'btn_Lookgive')
		local btnBoss = UIHO:seekWidgetByName(w, 'btn_pkBoss')
		local tag = btnBoss:getTag()
		
		w:setName(tostring(tag))
		
		self:addLuaHandler(btnLook, function ()
			BattleMap_ItemsPanel:Show(self:GetRootLayer(), tag)
		end)
		self:addLuaHandler(btnBoss, function ()
			local msg = proto.C2S_RequestFight.new()
			msg.battleType = FIGHT_BATTLE_TYPE_FBT_MONSTERBOSS
			msg.parm = tag
			g_SendMsg(msg)
			local label = self:GetRootLayer():seekWidgetByName('lbl_state')
			label = tcast(label, 'UIStaticRichText')
			label:setEnabled(true)
			label:setText(SSFmt(TDGETSTRCS('SD_NextToCB'), sceneCfg[tag].name))
			self:close()
		end)
		
		if tag == sceneId then
			if MAIN_PLAYER.m_winRate > 0 then
				btnBoss:runAction(actionMgr.create(
					'RepeatForever', {
						'Sequence',
						{'ScaleTo', 0.8, 0.8},
						{'ScaleTo', 0.8, 1.0},
					}
				))
			end
		end
	end
end

function BattleMap:Show(...)
	cVer:Show(...)
end


local cVer = BattleMap_ItemsPanel
BattleMap_ItemsPanel = class('BattleMap_ItemsPanel', CppUI)
local super = BattleMap_ItemsPanel.__super

function BattleMap_ItemsPanel:init()
	self:addLuaHandler('btn_close', function () self:close() end)
end

function BattleMap_ItemsPanel:Show(...)
	cVer:Show(...)
end