local type = type
local ttype = tolua.type
local guideMgr = require'guide'

local function doNothing() end

g_CppUI = g_CppUI or {}
local allCppUI = g_CppUI

local temp = {
	'PopupPlayerChangeName',
	'PopupCreateChar',
	'PopupSelectServerEx',
	'PopupSelectServer',
	'PopupSelectServerBase',
	'PopupServerNotice',
	'PopupCheckUpdate',
	'PopupGameUpdater',
	'PopupApkDownloader',
}
local uiFilter = {}
for _, v in ipairs(temp) do
	uiFilter[v] = true
end
function InitUI(name, ui)
	if name == 'UILayerEx::UIPopupLayer' then
		return
	end
	if not uiFilter[name] and
		ttype(ui) == 'UIPopupLayer' then
		ui:OutClickClose()
	end
	ui:addLuaHandler('btn_help', doNothing)
	local cls = _G[name]
	if type(cls) ~= 'table' or
		cls.__cname ~= name then
		cls = CppUI
	end
	local c = cls.new(ui)
	c:init()
	guideMgr.CheckGuideUI(name, c)
end

local function _create_UI_(ui)
	return ui
end

CppUI = class('CppUI', _create_UI_)

function CppUI:init()
	self:registerScriptHandler(function (event)
		if event == 'enter' then
			if ttype(self) == 'UILayerEx' then
				g_CurLayer = self
			end
			allCppUI[self] = true
			g_Player:regItemSyncHandler(self, self.OnItemUpdate)
			g_Player:regPropSyncHandler(self, self.OnPropUpdate)
			g_Player:regRuneItemSyncHandler(self, self.OnRuneItemUpdate)
			self:onEnter()
		elseif event == 'exit' then
			self:onExit()
			g_Player:unregItemSyncHandler(self)
			g_Player:unregPropSyncHandler(self)
			g_Player:unregRuneItemSyncHandler(self)
			self:unregAllMsgHandler()
			self:unregAllJMsgHandler()
			self:unregAllCMsgHandler()
			allCppUI[self] = nil
		elseif event == 'enterTransitionFinish' then
			self:onEnterDidFinish()
		elseif event == 'exitTransitionStart' then
			self:onExitDidStart()
		end
	end)
	return true
end

function CppUI:onEnter()
end
function CppUI:onExit()
end
function CppUI:onEnterDidFinish()
end
function CppUI:onExitDidStart()
end

function CppUI:regMsgHandler(proto, f)
	regMsgHandler(proto, self, f)
end

function CppUI:unregAllMsgHandler()
	unregAllMsgHandler(self)
end

function CppUI:regJMsgHandler(proto, f)
	regJMsgHandler(proto, self, f)
end

function CppUI:unregAllJMsgHandler()
	unregAllJMsgHandler(self)
end

function CppUI:regCMsgHandler(proto, f)
	regCMsgHandler(proto, self, f)
end

function CppUI:unregAllCMsgHandler()
	unregAllCMsgHandler(self)
end

function CppUI:OnItemUpdate()
end
function CppUI:OnPropUpdate()
end
function CppUI:OnRuneItemUpdate()
end