require'luaui.luaui'
require'luaui.abysschallenge'

DlgBattleList = class('DlgBattleList', CppUI)
local super = DlgBattleList.__super

local imageShow = {'Img_battleground', 'Img_team', 'Img_jdsy'}

function DlgBattleList:onEnterDidFinish()
	performWithDelay(self, function ()
		local listitem = self:seekWidgetByName('listitem')
		while listitem:getItems():count() > 0 do
			listitem:removeLastItem()
		end
		
		local widgetTemplate = LOADWIDGET('battleground_item.json')
		for k = 0, 2 do
			local widget = widgetTemplate:clone()
			widget:setTag(k)
			local img = UIHO:seekWidgetByName(widget, imageShow[k+1])
			if img ~= nil then img:setVisible(true) end
			widget:addTouchEventListener(function (s, e)
				if e == TOUCH_EVENT_ENDED then
					self:Onbtn_click(k, e)
				end
			end)
			listitem:pushBackCustomItem(widget)
		end
	end, 0.001)
end

function DlgBattleList:Onbtn_click(tag, _type)
	if tag == 1 then
		if PLAYER_STATUS_DATA.abilityData[ABILITY_TYPE_BATTLE_POWER+1] < 1500 then
			LShowMessage(string.format(getString('GF_BATTLEPOWER_NEED1'), 1500), nil, nil, MBT_OK)
			return
		end
	end
	
	local layer = self:GetRootLayer()
	self:close()
	if tag == 0 then
		g_SendMsg({ptype = 'bfopen'})
	elseif tag == 1 then
		LayerGroupFight:Show(layer)
	elseif tag == 2 then
		AbyssChallenge:Show(layer)
	end
end
