local MakeItemDetail = require'makeitemdetail'
local tcast = tolua.cast
local SSFmt = string.format

SelectEquipmentForRemake = class('SelectEquipmentForRemake', CppUI)
local super = SelectEquipmentForRemake.__super

function SelectEquipmentForRemake:init()
	if not super.init(self) then return false end
	
	-- 保存所有可选择装备
	local array, allEquip = CCArray:create(), {}
	local children = self:seekWidgetByName('equip_list'):getChildren()
	for k = 1, children:count() do
		local w = tcast(children:objectAtIndex(k), 'Widget')
		local iiv = UIHO:seekWidgetByName(w, 'itemView')
		if iiv ~= nil then 
			MakeItemDetail:ChangelScore(UIHO:seekWidgetByName(w, 'pnl_equip_props'), iiv:GetUniqueId())
		end
		local c = UIHO:seekWidgetByName(w, 'chk_box')
		c:addEventListenerCheckBox(function () self:CheckSelCount() end)
		array:addObject(w)
		allEquip[#allEquip + 1] = w
	end
	self:setUserObject(array)
	self.allEquip = allEquip
	
	-- 全部、白、绿、蓝、紫、橙
	self:addLuaHandler('btn_all', function () self:SetColorFilter(-1) end)
	self:addLuaHandler('btn_white', function () self:SetColorFilter(0) end)
	self:addLuaHandler('btn_green', function () self:SetColorFilter(1) end)
	self:addLuaHandler('btn_blue', function () self:SetColorFilter(2) end)
	self:addLuaHandler('btn_purple', function () self:SetColorFilter(3) end)
	self:addLuaHandler('btn_orange', function () self:SetColorFilter(4) end)
	
	self:addLuaHandler('btn_close', function () self:AssignRemakeItems() end)
	self:addLuaHandler(self, function () self:AssignRemakeItems() end)
	
	return true
end

function SelectEquipmentForRemake:SetColorFilter(color)
	local lv = self:seekWidgetByName('equip_list')
	local lvi = lv:getItems()
	while lvi:count() > 0 do
		lv:removeLastItem()
	end
	
	for k, w in ipairs(self.allEquip) do
		local iiv = UIHO:seekWidgetByName(w, 'itemView')
		if color == -1 or iiv:GetDummyItem():getColorIdx() == color then
			lv:pushBackCustomItem(w)
		end
	end
end

function SelectEquipmentForRemake:CheckSelCount()
	local count = 0
	for k, w in ipairs(self.allEquip) do
		local c = UIHO:seekWidgetByName(w, 'chk_box')
		if c:getSelectedState() then
			count = count + 1
		end
	end
	for k, w in ipairs(self.allEquip) do
		local c = UIHO:seekWidgetByName(w, 'chk_box')
		c:setEnabled(c:getSelectedState() or count < 6)
	end
end

function SelectEquipmentForRemake:AssignRemakeItems()
	local items = {}
	for k, w in ipairs(self.allEquip) do
		local c = UIHO:seekWidgetByName(w, 'chk_box')
		if c:getSelectedState() then
			local iiv = UIHO:seekWidgetByName(w, 'itemView')
			items[#items + 1] = iiv:GetDummyItem()
		end
	end
	local parent = self:GetParent()
	for k = 1, 6 do
		local iv = parent:seekWidgetByName(SSFmt('item_img_%d:item', k))
		local iv2 = tcast(iv:getParent(), 'CCNodeRGBA')
		iv:removeAllChildren()
		if not items[k] then
			iv:setVisible(false)
			iv2:setColor(ccc3(255, 255, 255))
		else
			iv:setVisible(true)
			iv:addChild(UIItemImageView:create(items[k], TLT_Null, PACKAGE_TYPE_BACKPACK))
			iv2:setColor(items[k]:getColor())
		end
	end
	self:close()
end