local util = require'util'
local proto = require'protocol'

local cVer = DlgFactionBattle
DlgFactionBattle = class('DlgFactionBattle', CppUI)
local super = DlgFactionBattle.__super

function DlgFactionBattle:init()
	if not super.init(self) then return false end
	-- 
	self:addLuaHandler('Button_power', function ()
		self:ShowProppertyVal(1)
	end)
	-- 
	self:addLuaHandler('Button_agility', function ()
		self:ShowProppertyVal(2)
	end)
	-- 
	self:addLuaHandler('Button_intell', function ()
		self:ShowProppertyVal(3)
	end)
	-- 
	self:addLuaHandler('Button_enduran', function ()
		self:ShowProppertyVal(4)
	end)
	self:addLuaHandler('btn_join', function (sender)
		util.UpdateNotify(sender, false)
		g_SendMsg(proto.C2S_FactionBattleJoin.new())
	end)
	self:addLuaHandler('btn_bigwar', function ()
		DlgFactionLeague:Show(self:GetRootLayer())
	end)
	
	local btnHelp = self:seekWidgetByName('btn_help')
	if not btnHelp then
		btnHelp = self:seekWidgetByName('btn_help2')
	end
	if btnHelp then
		btnHelp:setName('btn_help2')
		local t = btnHelp:getTag()
		self:addLuaHandler(btnHelp, function ()
			LShowMessage(TDGETSTRCS('SD_HELP_'..t),
				TDGETSTRCS('SD_HELP_TITLE_'..t))
		end)
	end
end

function DlgFactionBattle:onEnter()
	self:regMsgHandler('fb_home', self.OnRecvFBHome)
	self:regCMsgHandler(proto.S2C_GAME_SERVER.eS2C_SyncFactionBattleHome, self.OnRecvFBHomeC)
end

function DlgFactionBattle:OnRecvFBHome(msg)
	self.prop = msg.prop
	local btnJoin = self:seekWidgetByName('btn_join')
	if btnJoin then
		util.UpdateNotify(btnJoin, msg.canJoin)
	end
end

function DlgFactionBattle:OnRecvFBHomeC(msg)
	performWithDelay(self, function ()
		local career = MAIN_PLAYER_DATA.factionCareer
		if career == proto.FACTION_CAREER_PRESIDENT or
			career == proto.FACTION_CAREER_VICE_PRESIDENT then
			self:seekWidgetByName('btn_uppower'):setEnabled(true)
			self:seekWidgetByName('btn_upagility'):setEnabled(true)
			self:seekWidgetByName('btn_upintell'):setEnabled(true)
			self:seekWidgetByName('btn_upenduran'):setEnabled(true)
			if msg.status == proto.FACTION_MANOR_STATUS_NONE then
				self:seekWidgetByName('btn_refurbish'):setEnabled(true)
			elseif msg.status == proto.FACTION_MANOR_STATUS_SEARCH then
				self:seekWidgetByName('btn_refurbish'):setEnabled(true)
				self:seekWidgetByName('btn_challenge'):setEnabled(true)
			end
		end
	end, 0.001)
end

function DlgFactionBattle:ShowProppertyVal(k)
	if not self.prop then return end
	local prop = self.prop[k]
	LShowMessage(string.format(getString('SD02_FACTION_PROP_DESC_'..k), prop[1], prop[2]))
end

function DlgFactionBattle:Show(...)
	cVer:Show(...)
end