local gemCfg = require'config.gem'
local itemCfg = require'config.item'

GemLevelup = class('GemLevelup', CppUI)
local super = GemLevelup.__super

function GemLevelup:init(uid)
	if not super.init(self) then return false end
	
	self:addLuaHandler('btn_up', function () self:onClickUp(false) end)
	self:addLuaHandler('btn_luckup', function () self:onClickUp(true) end)
	self:seekWidgetByName('lab_jrgem'):setVisible(false)
	
	self:regJMsgHandler('gem_lv', self.onRecvGemLv)
	g_SendMsg({ptype = 'gem_lv'})
	
	return true
end

function GemLevelup:onRecvGemLv(bRep)
	self.bRep = bRep
	if bRep then
		self:seekWidgetByName('lab_jrgem'):setVisible(true)
		self:addLuaHandler('cbox_gemhd', function () end)
		self:update()
		schedule(self, function () self:update() end, 0.001)
	end
end

function GemLevelup:update()
	local iiv = self:seekWidgetByName('item_img_main:itemView')
	local id = iiv:GetItemTemplateId()
	
	local cfg = gemCfg[id]
	if not cfg then return end
	
	local cfg2 = itemCfg[cfg.costid2]
	if not cfg2 then
		self:seekWidgetByName('lab_jrgem'):setVisible(false)
		return
	end
	
	self:seekWidgetByName('lab_jrgem'):setVisible(true)
	self:seekWidgetByName('lab_jrgem'):setText(SSFmt(TDGETSTRCS('SD_GEM_REPLACE_FIRST'), cfg2.name))
	self:seekWidgetByName('lab_gemhd'):setText(SSFmt(TDGETSTRCS('SD_GEM_REPLACE_COUNT'), cfg2.name, g_Player:GetItemCount(cfg.costid2)))
end

function GemLevelup:onClickUp(cri)
	local iiv = self:seekWidgetByName('item_img_main:itemView')
	local id = iiv:GetItemTemplateId()
	local cfg = gemCfg[id]
	if not cfg then return end
	local rep = self.bRep and self:seekWidgetByName('cbox_gemhd'):getSelectedState()
	
	local function realSend()
		g_SendMsg({ptype='gem_lv', id=id, cri=cri, rep=rep})
	end
	if cri then
		LShowMessage(SSFmt(TDGETSTRCS('SD_GEM_LUCKLVUPCOM'), cfg.cricost, cfg.fluck2/cfg.fluck), nil, nil, MBT_OKCANCEL, realSend)
	else
		realSend()
	end
end