local cVer = LayerBattle
LayerBattle = class('LayerBattle', CppUI)
local super = LayerBattle.__super

local batPanelName = {
	'pnl_player',
	'pnl_hire',
	'pnl_hire1',
	'pnl_enemy1',
	'pnl_enemy2',
	'pnl_enemy3',
};

function LayerBattle:onEnterDidFinish()
	self:addLuaHandler('button_changemap', function ()
		BattleMap:Show(self)
	end)
end

function LayerBattle:onEnter()
	g_Player.fightMgr.panel = self
	self:FightBegin(g_Player.fightMgr)
end

function LayerBattle:onExit()
	g_Player.fightMgr.panel = nil
	for k, v in pairs(g_Player.fightMgr.fodMap) do
		v.panel = nil
	end
end

function LayerBattle:init()
	if not super.init(self) then return false end
	--self:InitBattle()
	return true
end


function LayerBattle:FightBegin(fds)
	local msg = fds:GetFightMsg()
	if msg == nil then
		msg = fds:GetPrevFightMsg()
		if not msg then return end
	end
	if #msg.objsLeft == 0 then
		return
	end
	
	local pnl_boss = self:seekWidgetByName("pnl_boss" ) 
	
	if pnl_boss then
		pnl_boss:removeFromParent()
	end
	
	local widget = self:seekWidgetByName('battle')
	InitFightObjectDetails(widget, 'pnl_player', fds.fodMap[msg.objsLeft[1].id])
	
	if #msg.objsLeft == 1 then
		InitFightObjectDetails(widget, 'pnl_hire', nil)
		InitFightObjectDetails(widget, 'pnl_hire1', nil)
	elseif #msg.objsLeft == 2 then
		InitFightObjectDetails(widget, 'pnl_hire', fds.fodMap[msg.objsLeft[2].id])
		InitFightObjectDetails(widget, 'pnl_hire1', nil)
	elseif #msg.objsLeft == 3 then
		InitFightObjectDetails(widget, 'pnl_hire', fds.fodMap[msg.objsLeft[2].id])
		InitFightObjectDetails(widget, 'pnl_hire1', fds.fodMap[msg.objsLeft[3].id])
	end
	
	local rightCount = #msg.objsRight
	for k = 1, 3 do
		if k > rightCount then
			InitFightObjectDetails(widget, SSFmt( 'pnl_enemy%d',k), nil)
		else
			InitFightObjectDetails(widget, SSFmt( 'pnl_enemy%d',k), fds.fodMap[msg.objsRight[k].id])
		end
	end
	
	local startBattle = self:seekWidgetByName("img_type")
	
	if startBattle then
		startBattle:stopAllActions();
		startBattle:setVisible(false);
		if (fds:getCurFrame() == 0)  then
			startBattle:setVisible(true);
			startBattle:setScale(0);			
			startBattle:runAction(CPSequence:create(
				CCEaseBackOut:create(CPScaleTo:create(0.5, 1)),
				CPFadeOut:create(1),
				CPHide:create(),
				NULL));
		end
	end
	
	local findEnemy =self:seekWidgetByName("img_stat" ) 
	if findEnemy then
		findEnemy:setEnabled( false );
	end
	
	local lbl_state = self:seekWidgetByName("lbl_state")
	if lbl_state then
		lbl_state:setEnabled( false );
	end
	
end

function LayerBattle:InitBattle()
	for k = 1, 6 do
		local panel = self:seekWidgetByName(batPanelName[k])
		if panel then
			local bar = UIHO:seekWidgetByName(panel, 'bar_hp')
			if bar then
				local ebar = UIEnergyBar:create()
				bar:getParent():addChild(ebar, 10)
				local label = UIHO:seekWidgetByName(bar, 'text_hp')
				if label then
					label:retain()
					label:removeFromParent()
					ebar:addChild(label, 10)
					label:release()
				end
				local iv = UIHO:seekWidgetByName(bar, 'img_dead')
				if iv then
					iv:retain()
					iv:removeFromParent()
					ebar:addChild(iv, 11)
					iv:release()
				end
				ebar:setName('bar_hp')
				ebar:cloneFromLoadingBar(bar)
				bar:removeFromParent()
				if k <= 3 then ebar:setDirection(LoadingBarTypeRight) end
				--??
				if k == 1 then
					local mpbar = UIHO:seekWidgetByName(panel, 'bar_mp')
					if mpbar then
						local empbar = UIEnergyBar:create()
						mpbar:getParent():addChild(empbar, 10)
						
						local label = UIHO:seekWidgetByName(bar, 'text_mp')
						if label then
							label:retain()
							label:removeFromParent()
							empbar:addChild(label, 10)
							label:release()
						end
						
						empbar:setName('bar_mp')
						empbar:cloneFromLoadingBar(mpbar)
						empbar:setDirection(LoadingBarTypeRight)
						mpbar:removeFromParent()
					end
				end
			end
		end
	end
end

function LayerBattle:sharedLayerBattle()
	return cVer:sharedLayerBattle()
end