DlgEliteBattleField = class('DlgEliteBattleField', CppUI)
local super = DlgEliteBattleField.__super

local batPanelName = {
	'pnl_hire_0',
	'pnl_hire_1',
	'pnl_hire_2',
	'pnl_hire_3',
	'pnl_hire_4',
	'pnl_hire_5',
	'pnl_hire_6',
	'pnl_hire_7',
	'pnl_hire_8',
	'pnl_enemy1',
};

function DlgEliteBattleField:init()
	if not super.init(self) then return false end
	self.m_isEnd = false
	--self:InitBattle()
	return true
end

function DlgEliteBattleField:SetMapName(name)
	local lbl_map = self:seekWidgetByName('lbl_map')
	if lbl_map then lbl_map:setText(name) end
end

function DlgEliteBattleField:SetChatMode(enabled)
	local w = self:seekWidgetByName('pan_fight')
	if w then w:setEnabled(enabled) end
end

function DlgEliteBattleField:InitBattle()
	for k = 1, 10 do
		local panel = self:seekWidgetByName(batPanelName[k])
		if panel then
			local bar = UIHO:seekWidgetByName(panel, 'bar_hp')
			if bar then
				local ebar = UIEnergyBar:create()
				bar:getParent():addChild(ebar, 10)
				local label = UIHO:seekWidgetByName(bar, 'text_hp')
				if label then
					label:retain()
					label:removeFromParent()
					ebar:addChild(label, 10)
					label:release()
				end
				local iv = UIHO:seekWidgetByName(bar, 'img_dead')
				if iv then
					iv:retain()
					iv:removeFromParent()
					ebar:addChild(iv, 11)
					iv:release()
				end
				ebar:setName('bar_hp')
				ebar:cloneFromLoadingBar(bar)
				bar:removeFromParent()
				if k <= 9 then ebar:setDirection(LoadingBarTypeRight) end
			end
		end
	end
end

function DlgEliteBattleField:FightBegin(fds)
	local msg = fds:GetFightMsg()
	if msg == nil then
		msg = fds:GetPrevFightMsg()
		if not msg then return end
	end
	if #msg.objsLeft == 0 then return end
	
	local widget = self:seekWidgetByName('team_battle')
	for k = 1, 9 do
		local fod
		if #msg.objsLeft >= k then fod = fds.fodMap[msg.objsLeft[k].id] end
		InitFightObjectDetails(widget, batPanelName[k], fod)
	end
	local fod
	if #msg.objsRight >= 1 then fod = fds.fodMap[msg.objsRight[1].id] end
	InitFightObjectDetails(widget, batPanelName[10], fod)
end

function DlgEliteBattleField:onEnter()
	g_Player.eliteFightMgr.panel = self
	self:FightBegin(g_Player.eliteFightMgr)
end

function DlgEliteBattleField:onExit()
	g_Player.eliteFightMgr.panel = nil
	for k, v in pairs(g_Player.eliteFightMgr.fodMap) do
		v.panel = nil
	end
end