LayerEquip = class('LayerEquip', CppUI)
local super = LayerEquip.__super

local slotConvert = {1, 2, 3, 5, 7, 10, 14, 12, 6, 8}

function LayerEquip:onEnterDidFinish()
	self:addLuaHandler('btn_changeAllEquip', function ()
		g_Player:ChangeAllBetterEquip()
	end)
	self:addLuaHandler('btn_fuwen', function ()
		if PLAYER_STATUS_DATA.abilityData[ABILITY_TYPE_BATTLE_POWER+1] < 3000 then
			LShowMessage(string.format(getString('GF_BATTLEPOWER_NEED1'), 3000), nil, nil, MBT_OK, self._nil, self._nil, self._nil)
		else
			EquipRune:Show(self)
		end
	end)
	self:updateBetterEquipState()
end

function LayerEquip:updateBetterEquipState()
	local hasBetter = false
	for k = EQUIPMENT_TYPE_MAIN_WEAPON, EQUIPMENT_TYPE_BOOTS do
		local better = g_Player.betterEquip[k]
		local e = self:seekWidgetByName('equip_'..slotConvert[k+1])
		local effect = e:getNodeByTag(-100)
		if effect then e:removeNode(effect) end
		if better then
			hasBetter = true
			local spr = CPSprite:createWithSpriteFrameName('icon_img_N.png')
			local effectSpr = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10)
			local size = spr:getContentSize()
			effectSpr:setPosition(size.width/2, size.height/2)
			spr:addChild(effectSpr, 10, -100)
			e:addNode(spr, 10, -100)
		end
	end
	local btnChangeAll = self:seekWidgetByName('btn_changeAllEquip')
	btnChangeAll:setVisible(hasBetter)
	btnChangeAll:setEnabled(hasBetter)
end

function LayerEquip:OnPropUpdate(tp, pre, cur)
	if tp == SYNC_PROP_TYPE_cristal then
		local label = self:seekWidgetByName('lbm_zuanshi')
		local img = self:seekWidgetByName('img_zs')
		if cur >= 10000 then
			label:setText(SSFmt('%u', cur/10000))
			img:setPositionX(label:getContentSize().width + 10)
			img:setVisible(true)
		else
			label:setText(SSFmt('%u', cur))
			img:setVisible(false)
		end
	end
end