DlgBattleField = class('DlgBattleField', CppUI)
local super = DlgBattleField.__super

local batPanelName = {
	'pnl_self1',
	'pnl_self2',
	'pnl_self3',
	'pnl_enemy1',
	'pnl_enemy2',
	'pnl_enemy3',
};

function DlgBattleField:init()
	if not super.init(self) then return false end
	return true
end

function DlgBattleField:FightBegin(fds)
	local msg = fds:GetFightMsg()
	if msg == nil then
		msg = fds:GetPrevFightMsg()
		if not msg then return end
	end
	if #msg.objsLeft == 0 then
		return
	end
	local widget = self:seekWidgetByName('battleground_battle')
	
	for k = 1, 3 do
		local fod
		if #msg.objsLeft >= k then fod = fds.fodMap[msg.objsLeft[k].id] end
		InitFightObjectDetails(widget, batPanelName[k], fod)
	end
	
	for k = 1, 3 do
		local fod
		if #msg.objsRight >= k then fod = fds.fodMap[msg.objsRight[k].id] end
		InitFightObjectDetails(widget, batPanelName[k+3], fod)
	end
end

function DlgBattleField:onEnter()
	g_Player.batFightMgr.panel = self
	self:FightBegin(g_Player.batFightMgr)
end

function DlgBattleField:onExit()
	g_Player.batFightMgr.panel = nil
	for k, v in pairs(g_Player.batFightMgr.fodMap) do
		v.panel = nil
	end
end