LayerPet = class('LayerPet', CppUI)
local super = LayerPet.__super

local idxConvert = {
	EQUIPMENT_TYPE_MAIN_WEAPON,
	EQUIPMENT_TYPE_SUB_WEAPON,
	EQUIPMENT_TYPE_BODY,
	EQUIPMENT_TYPE_LEG,
}

function LayerPet:onEnterDidFinish()
	self:addLuaHandler('btn_changeAllEquip', function ()
		g_Player:ChangeAllBetterEquipMerc(self:GetMercIdx())
	end)
	self:updateBetterEquipStateMerc()
	local lastIdx = self:GetMercIdx()
	schedule(self, function ()
		local idx = self:GetMercIdx()
		if idx ~= lastIdx then
			self:updateBetterEquipStateMerc()
			lastIdx = idx
		end
	end, 0.001)
end

function LayerPet:GetMercIdx()
	local x = self:seekWidgetByName('img_selected'):getPositionX()
	for k = 1, 3 do
		if self:seekWidgetByName('head_back_'..k):getPositionX() == x then
			if g_Player.mercenaries[k] then
				return k
			end
			return 0
		end
	end
	return 0
end

function LayerPet:GetMercID()
	local idx = 0
	local x = self:seekWidgetByName('img_selected'):getPositionX()
	for k = 1, 3 do
		if self:seekWidgetByName('head_back_'..k):getPositionX() == x then
			idx = k
			break
		end
	end
	if idx >= 1 and idx <= #PLAYER_MERCENARY then
		return PLAYER_MERCENARY[idx].baseData.id
	end
	return 0
end

function LayerPet:updateBetterEquipStateMerc()
	local idx = self:GetMercIdx()
	local betterEquip = g_Player.betterEquipMerc[idx] or {}
	local hasBetter = false
	for k, v in ipairs(idxConvert) do
		local better = betterEquip[v]
		local e = self:seekWidgetByName('equip_'..k)
		local effect = e:getNodeByTag(-100)
		if effect then e:removeNode(effect) end
		if better then
			hasBetter = true
			local spr = CPSprite:createWithSpriteFrameName('icon_img_N.png')
			local effectSpr = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10)
			local size = spr:getContentSize()
			effectSpr:setPosition(size.width/2, size.height/2)
			spr:addChild(effectSpr, 10, -100)
			e:addNode(spr, 10, -100)
		end
	end
	local btnChangeAll = self:seekWidgetByName('btn_changeAllEquip')
	btnChangeAll:setVisible(hasBetter)
	btnChangeAll:setEnabled(hasBetter)
end