local proto = require'protocol'
local util = require'util'
local actionMgr = require'action'
local isnull = tolua.isnull
local tcast = tolua.cast
local sfCache = CCSpriteFrameCache:sharedSpriteFrameCache()

local cVer = LayerRoot
LayerRoot = class('LayerRoot', CppUI)
local super = LayerRoot.__super

local s_LayerRoot

function LayerRoot:init()
	if not super.init(self) then return false end
	
	s_LayerRoot = self
	
	--起量宝
	if  CCFileUtils:sharedFileUtils():isFileExist("qlbbtn.png") then
		local iv = self:seekWidgetByName('qlbbtn')
		if iv == nil then
			iv = ImageView:create();
			iv:loadTexture("qlbbtn.png");
			iv:setTouchEnabled(true);
			iv:setAnchorPoint(ccp(0, 1));
			iv:setName("qlbbtn");
			iv:setZOrder(10);
			self:addWidget(iv);
		end
		iv:setPosition(ccp(640 - iv:getContentSize().width, 960))
		iv:addTouchEventListener(function (s, e)
			if e == TOUCH_EVENT_ENDED then
				showQLB()
			end
		end)
	end
	
	return true
end

function LayerRoot:onEnterDidFinish()
	local btnCT = self:seekWidgetByName('btn_charge_tree')
	btnCT:runAction(actionMgr.create(
		'RepeatForever', {
			'Sequence',
			{'ScaleTo', 0.8, 0.8},
			{'ScaleTo', 0.8, 1.0},
		}
	))
	self:onRecvDLGift(g_Player.hasDLGift)
	
	local btnHelp = self:seekWidgetByName('btn_help')
	if btnHelp then
		btnHelp:setName('btn_help2')
	else
		btnHelp = self:seekWidgetByName('btn_help2')
	end
	self:addLuaHandler(btnHelp, function ()
		g_SendMsg({ptype='contact'})
	end)
	
	self:addLuaHandler('btn_charge_tree', function ()
		Charge:Show(self)
		if not MAIN_PLAYER:isVipGiftStateAllGetd() then
			local iv = self:seekWidgetByName('img_viplvchanged')
			iv:setVisible(true)
			local effect = iv:getNodeByTag(-9528)
			if effect then
				iv:removeNode(effect)
			end
			
			local effectSpr = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10)
			iv:addNode(effectSpr, 999, -9528)
		else
			local iv = self:seekWidgetByName('img_viplvchanged')
			iv:setVisible(false)
			local effect = iv:getNodeByTag(-9528)
			if effect then
				iv:removeNode(effect)
			end
		end
	end)
	self:addLuaHandler('btn_feedback', function ()
	
	     print("ptype =actlist")
	
		g_SendMsg({ptype = 'actlist'})
	end)
	-- self:addLuaHandler('btn_sign', function (sender)
		-- util.UpdateNotify(sender, false)
		-- SignActivity:Show(self)
	-- end)
	-- self:addLuaHandler('btn_daily', function (sender)
		-- util.UpdateNotify(sender, false)
		-- DailyTask:Show(self)
	-- end)
	self:addLuaHandler('btn_reward', function (sender)
		util.UpdateNotify(sender, false)
		MainAward:Show(self)
		g_SendMsg(proto.C2S_RequestAchievementList.new())
	end)
	self:addLuaHandler('btn_olineReward', function ()
		OnlineGiftActivity:Show(self)
	end)
	self:addLuaHandler('btn_ronglian', function ()
		RemakeEquipment:Show(self)
	end)
	self:addLuaHandler('btn_stope', function (sender)
		--LShowMessage(TDGETSTRCS('SD_MODEL_NOOPEN'));
		util.UpdateNotify(sender, false)
		g_SendMsg({ptype = 'quarry_sync'})
	end)
	self:addLuaHandler('btn_main', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_battle', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_equip', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_bag', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_skill', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_hire', function (s)
		self:ClickMainBtn(s)
	end)
	self:addLuaHandler('btn_package', function (sender)
		g_SendMsg({ptype='dl_gift'})
	end)
	self.mainBtn = self:seekWidgetByName('main_btn')
	local imgEquipNew = UIHO:seekWidgetByName(self.mainBtn, 'img_new_equip')
	if imgEquipNew then imgEquipNew:setName('img_new_equip2') end
	self:updateBetterEquipState(g_Player:HasBetterEquip())
	local imgMercNew = UIHO:seekWidgetByName(self.mainBtn, 'img_new_Mercenary')
	if imgMercNew then imgMercNew:setName('img_new_Mercenary2') end
	self:updateBetterEquipStateMerc(g_Player:HasBetterEquipMerc(g_Player.baseData.activeMercenary))
	
	self:regJMsgHandler('quarry_sync', function (self, msg)
		if not IsLuaUIShow('DlgQuarry') then
			DlgQuarry:Show(self, msg)
			if g_Player:IsQuarryFighting() then
				DlgQuarryFight:Show(self)
			end
		end
	end)
	self:regJMsgHandler('fc_show', self.onRecvFCShow)
	self:regJMsgHandler('new_list', self.onRecvNewList)
	self:regJMsgHandler('dl_gift', self.onRecvDLGift)
	self:regJMsgHandler('actlist', self.onRecvActList)
	self:regJMsgHandler('contact', self.onRecvContact)
	self:regJMsgHandler('oltime_time', self.UpOnlineTime)
	self:regJMsgHandler('skip_fight', self.SkipFight)
	g_SendMsg({ptype='new_list', showActivity=true})
	g_SendMsg({ptype='oltime_time'})
	
	self:regCMsgHandler(proto.S2C_GAME_SERVER.eS2C_AnswerStatistics, self.OnRecvMsgAnswerStatistics)
	self:regCMsgHandler(proto.S2C_GAME_SERVER.eS2C_SyncAchievementCounter, self.OnRecvSyncGift)
	
	self:updatePlayerBaseData()
end

function LayerRoot:OnRecvSyncGift(msg)
	if msg.slot == 1 then self._gift = true end
	
	return true
end

function LayerRoot:SkipFight(data)
	g_Player.fightMgr:GetFightMsg().frameList = {}
	g_Player.fightMgr.idfList = {};
	g_Player.fightMgr:GetFightMsg().fightResult.sleepTime = 10
	g_Player.baseData.skipFight = g_Player.baseData.skipFight-1
end

function LayerRoot:UpOnlineTime(data)
	local btn_olineReward = self:seekWidgetByName('btn_olineReward')
	if btn_olineReward ~= nil then
		local txt = UIHO:seekWidgetByName(btn_olineReward, 'label_onlinetime')
		if txt ~= nil then
			local c = txt:clone()
			btn_olineReward:removeChild(txt, true)
			btn_olineReward:addChild(c)
			
			self:updateTime(data.oltime)
			if data.oltime > 0 then
				schedule(c, function ()
					data.oltime = data.oltime - 1
					if data.oltime < 0 then return end
					self:updateTime(data.oltime)
				end, 1)
			end
		end
	end
	return true
end

function LayerRoot:GetTime(tm)
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return h, m, tm
end

function LayerRoot:updateTime(onlinetime)
	local btn_olineReward = self:seekWidgetByName('btn_olineReward')
	if btn_olineReward ~= nil then
		util.UpdateNotify(btn_olineReward, onlinetime == 0 and true or false, 0, 0.25)
		local txt = UIHO:seekWidgetByName(btn_olineReward, 'label_onlinetime')
		if txt ~= nil then
			if onlinetime == -1 then onlinetime = 0 end
			txt:setText(string.format(getString("ONLINE_GIFT_TIME_EX"), self:GetTime(onlinetime)))
		end
	end
end

g_S2C_AnswerStatisticsMsg = nil
function LayerRoot:OnRecvMsgAnswerStatistics(msg)
	g_S2C_AnswerStatisticsMsg =msg
end

local btnState = {
	btn_main = MSS_Root,
	btn_battle = UILayerBattleShow,
	btn_equip = UILayerEquipShow,
	btn_bag = UILayerBagShow,
	btn_skill = UILayerSkillShow,
	btn_hire = UILayerPetShow,
}
function LayerRoot:ClickMainBtn(btn)
	btn = tcast(btn, 'Button')
	local btnName = btn:getName()
	SceneMain:sharedSceneMain():ChangeState(btnState[btnName])
	if btnName == 'btn_main' then
		g_CurLayer = LayerRoot:sharedLayerRoot()
	end
	self:ShowMainBtnEff(btnName)
	local showNewEquip = g_Player:HasBetterEquip()
	local showNewMerc = g_Player:HasBetterEquipMerc(g_Player.baseData.activeMercenary)
	if btnName == 'btn_equip' then
		showNewEquip = false
	elseif btnName == 'btn_hire' then
		showNewMerc = false
	end
	g_SendMsg({ptype='new_list', showActivity=false})
	self:updateBetterEquipState(showNewEquip)
	self:updateBetterEquipStateMerc(showNewMerc)
end

function LayerRoot:updateBetterEquipState(better)
	if g_CurLayer and g_CurLayer.__cname == 'LayerEquip' then
		g_CurLayer:updateBetterEquipState()
		better = false
	end
	local iv = UIHO:seekWidgetByName(self.mainBtn, 'img_new_equip2')
	if not iv then iv = UIHO:seekWidgetByName(self.mainBtn, 'img_new_equip') end
	if not iv then return end
	local eff = iv:getNodeByTag(-100)
	if eff then iv:removeNode(eff) end
	if better then
		eff = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10)
		iv:addNode(eff, 10, -100)
	end
	iv:setVisible(better)
end

function LayerRoot:updateBetterEquipStateMerc(better)
	if g_CurLayer and g_CurLayer.__cname == 'LayerPet' then
		g_CurLayer:updateBetterEquipStateMerc()
		better = false
	end
	local iv = UIHO:seekWidgetByName(self.mainBtn, 'img_new_Mercenary')
	if not iv then iv = UIHO:seekWidgetByName(self.mainBtn, 'img_new_Mercenary2') end
	if not iv then return end
	local eff = iv:getNodeByTag(-100)
	if eff then iv:removeNode(eff) end
	if better then
		eff = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10)
		iv:addNode(eff, 10, -100)
	end
	iv:setVisible(better)
end

function LayerRoot:OnPropUpdate(tp, pre, cur)
	if tp == SYNC_PROP_TYPE_level then
		self:updatePlayerBaseData()
	end
end

function LayerRoot:updatePlayerBaseData()
	if g_Player.baseData.level >= 20 then
		local btn_stope = self:seekWidgetByName('btn_stope')
		--if btn_stope ~= nil then 
		--	util.UpdateNotify(btn_stope, true, 0, 0.25) 
		--end
	end
end

local btnNames = {
	'btn_main',
	'btn_battle',
	'btn_equip',
	'btn_bag',
	'btn_skill',
	'btn_hire'
}
function LayerRoot:ShowMainBtnEff(e)
	-- for k, v in ipairs(btnNames) do
	-- 	if v ~= e then
	-- 		local btn = UIHO:seekWidgetByName(self.mainBtn, v..':Image_BG')
	-- 		if btn then
	-- 			local p = btn:getParent()
	-- 			local c = btn:clone()
	-- 			p:removeChild(btn, true)
	-- 			p:addChild(c)
	-- 		end
	-- 	end
	-- end
	
	-- btn = UIHO:seekWidgetByName(self.mainBtn, e)
	-- local p = btn:getParent()
	-- local c = btn:clone()
	-- p:removeChild(btn, true)
	-- p:addChild(c)
	-- self:addLuaHandler(c, function (s) self:ClickMainBtn(s) end)
	
	-- btn = UIHO:seekWidgetByName(c, 'Image_BG')
	-- if btn then
	-- 	sfCache:addSpriteFramesWithFile('main_effect_0.plist')
	-- 	sfCache:addSpriteFramesWithFile('main_effect_1.plist')
	-- 	local aniName = SSFmt('main_%s_effect_', e)
	-- 	aniName = aniName..'%02u.png'
	-- 	local ani = CreateAnimateOnly(aniName, 'xx', 2.0 / 20, 20)
	-- 	local effectSpr = CPSprite:create()
	-- 	effectSpr:runAction(CPRepeatForever:create(ani))
	-- 	effectSpr:setAnchorPoint(ccp(0.5, 0.5))
	-- 	btn:addNode(effectSpr, 999, -200)
	-- end
end

function LayerRoot:onRecvFCShow(msg)
	self:seekWidgetByName('btn_charge_tree'):setEnabled(msg)
end

function LayerRoot:onRecvNewList(list)
	local tmp = {}
	for k, v in ipairs(list) do tmp[v] = true end
	self:seekWidgetByName('btn_charge_tree'):setEnabled(tmp['charge'])
	-- util.UpdateNotify(self:seekWidgetByName('btn_sign'), tmp['sign'], 0, 0.2)
	-- util.UpdateNotify(self:seekWidgetByName('btn_daily'), tmp['daily'], 0, 0.2)
	
	self._sign = tmp['sign'] ~= nil and true or false
	self._gift = tmp['gift'] ~= nil and true or false
	self._vipdaily = tmp['vipdaily'] ~= nil and true or false
	self._daily = tmp['daily'] ~= nil and true or false
	
	util.UpdateNotify(self:seekWidgetByName('btn_reward'), self._sign or self._gift or self._vipdaily or self._daily, 0, 0.25)
end

function LayerRoot:onRecvDLGift(show)
	local btnDLG = self:seekWidgetByName('btn_package')
	btnDLG:setEnabled(show)
	btnDLG:setVisible(show)
	
	btnDLG:stopAllActions()
	if show then
		btnDLG:runAction(actionMgr.create(
			'RepeatForever', {
				'Sequence',
				{'ScaleTo', 0.8, 0.8},
				{'ScaleTo', 0.8, 1.0},
			}
		))
	end
end

function LayerRoot:onRecvActList(lst)
	DlgActivityList:Show(self, lst)
end

function LayerRoot:onRecvContact(info)
	LShowMessage(SSFmt(TDGETSTRCS('SD_CONTACT'), info)..TDGETSTRCS('SD_HELP'), TDGETSTRCS('SD_HELP_TITLE'))
end

function LayerRoot:sharedLayerRoot()
	if isnull(s_LayerRoot) then
		return nil
	end
	return s_LayerRoot
end
