local lvCfg = require'config.playerlv'

local _class = class
local function class(name, ...)
	local cVer = _G[name]
	local ret = _class(name, ...)
	if cVer then
		if not cVer.__cname then
			function ret:Show(...)
				cVer:Show(...)
			end
		else
			ret.Show = cVer.Show
		end
	end
	return ret
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end


----------累计充值天数老版本----------
DlgPayActivity = class('DlgPayActivity', CppUI)
local super = DlgPayActivity.__super

function DlgPayActivity:onEnter()
	self:regMsgHandler('payact', self.setActTime)
end

function DlgPayActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgPayActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------累计充值天数强化版本----------
DlgPayActivityEx = class('DlgPayActivityEx', CppUI)
local super = DlgPayActivityEx.__super

function DlgPayActivityEx:onEnter()
	self:regMsgHandler('payactex', self.setActTime)
end

function DlgPayActivityEx:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgPayActivityEx:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end


----------消费砸金蛋----------
DlgGoldEgg = class('DlgGoldEgg', CppUI)
local super = DlgGoldEgg.__super

function DlgGoldEgg:onEnter()
	self:regMsgHandler('goldegg', self.setActTime)
end

function DlgGoldEgg:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgGoldEgg:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end


----------累计登录----------
DlgLoginActivity = class('DlgLoginActivity', CppUI)
local super = DlgLoginActivity.__super

function DlgLoginActivity:onEnter()
	self:regMsgHandler('loginact', self.setActTime)
end

function DlgLoginActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgLoginActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end


----------指定日期登录----------
DlgLoginDateActivity = class('DlgLoginDateActivity', CppUI)
local super = DlgLoginDateActivity.__super

function DlgLoginDateActivity:onEnter()
	self:regMsgHandler('logindateact', self.setActTime)
end

function DlgLoginDateActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgLoginDateActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------累计充值金额----------
DlgChargeActivity = class('DlgChargeActivity', CppUI)
local super = DlgChargeActivity.__super

function DlgChargeActivity:onEnter()
	self:regMsgHandler('chargeact', self.setActTime)
end

function DlgChargeActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgChargeActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------累计消耗钻石----------
DlgConsumeActivity = class('DlgConsumeActivity', CppUI)
local super = DlgConsumeActivity.__super

function DlgConsumeActivity:onEnter()
	self:regMsgHandler('consumeact', self.setActTime)
end

function DlgConsumeActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgConsumeActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------佣兵培养返钻----------
DlgYBFZActivity = class('DlgYBFZActivity', CppUI)
local super = DlgYBFZActivity.__super

function DlgYBFZActivity:onEnter()
	self:regMsgHandler('YBFZActivity_List', self.setActTime)
end

function DlgYBFZActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgYBFZActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------疯狂猜大小----------
DlgBetBSActivity = class('DlgBetBSActivity', CppUI)
local super = DlgBetBSActivity.__super

function DlgBetBSActivity:onEnter()
	self:regMsgHandler('BetBSActivity_List', self.setActTime)
end

function DlgBetBSActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function DlgBetBSActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------ActivityGeneral_%s----------
ActivityInfo_general = class('ActivityInfo_general', CppUI)
local super = ActivityInfo_general.__super

function ActivityInfo_general:onEnter()
	self:regMsgHandler('activity_general', self.setActTime)
end

function ActivityInfo_general:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function ActivityInfo_general:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------王者之争----------
ChargeRankActivity = class('ChargeRankActivity', CppUI)
local super = ChargeRankActivity.__super

function ChargeRankActivity:onEnter()
	self:regMsgHandler('cra_list', self.setActTime)
end

function ChargeRankActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function ChargeRankActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------极品道具拿不停----------
ConsumeRankActivity = class('ConsumeRankActivity', CppUI)
local super = ConsumeRankActivity.__super

function ConsumeRankActivity:onEnter()
	self:regMsgHandler('conra_list', self.setActTime)
end

function ConsumeRankActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function ConsumeRankActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end



----------前七天冲级活动----------
LevelActivity = class('LevelActivity', CppUI)
local super = LevelActivity.__super

function LevelActivity:onEnter()
	self:regMsgHandler('lv_act', self.setActTime)
end

function LevelActivity:setActTime(msg)
	local bt, et, nt = msg.bt, msg.et, msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function LevelActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end
--统计数据溢出--
BattelStatistics = class('BattelStatistics', CppUI)
function BattelStatistics:onEnter()
	if g_S2C_AnswerStatisticsMsg then
	    local si = g_S2C_AnswerStatisticsMsg.si;
		if  si.fightTimes == 0 then
			si.fightTimes = 1;
		end
		local avgBattleTicks = si.totalBattleTime / si.fightTimes;
		if ( avgBattleTicks == 0 ) then
			avgBattleTicks = 1;
		end
		local fightTimesPerHour = 3600 / avgBattleTicks;

		local expPerBattle = si.expGet / si.fightTimes;
		local moneyPerBattle = si.moneyGet / si.fightTimes;
		local itemPerBattle = si.itemGet / si.fightTimes;
		
		local needExpPoints = lvCfg[PLAYER_BASE_DATA.race * 100000 + PLAYER_BASE_DATA.level]
		local needExp = needExpPoints - PLAYER_BASE_DATA.exp:tonumber()
		local dev = (expPerBattle * fightTimesPerHour):tonumber()
		if dev == 0 then
			dev = 1
		end
		local needMinute = needExp * 60 / dev;
		local needMinute = needMinute:tonumber();
		local lbl_lvup = self:seekWidgetByName( "lbl_lvup" ) 
		if lbl_lvup then
			if ( needMinute < 60 ) then
				lbl_lvup:setText(string.format(getString( "SD_LevelDetail_0" ), PLAYER_BASE_DATA.level + 1, needExp, needMinute ) );
			else 
				lbl_lvup:setText(string.format(getString( "SD_LevelDetail_1" ), PLAYER_BASE_DATA.level + 1, needExp, needMinute / 60, needMinute % 60 ) );
			end
		end
	end
end
