local proto = require'protocol'

local cVer = RemakeEquipment
RemakeEquipment = class('RemakeEquipment', CppUI)
local super = RemakeEquipment.__super

function RemakeEquipment:init()
	if not super.init(self) then return false end
	
	self:addLuaHandler('btn_newequip', function ()
		local msg = proto.C2S_BuildEquip.new()
		msg.state = 0
		g_SendMsg(msg)
	end)
	self:addLuaHandler('btn_rlvip', function ()
		RemakeBatchEquip:Show(self:GetRootLayer())
	end)
	self:addLuaHandler('btn_ronglian', function ()
		local msg = proto.C2S_RemakeEquip.new()
		local isStar = false
		for k = 1, 6 do
			local w = self:seekWidgetByName(SSFmt('item_img_%d:itemView', k))
			local item = w and w:GetDummyItem()
			if item then
				if item:GetStarNum() > 0 then
					isStar = true
				end
				table.insert(msg.uniqueIds, item.uniqueId)
			end
		end
		if isStar then
			LShowMessage(TDGETSTRCS('RONGLIAN_STAR_TIPS'), nil, nil, MBT_OKCANCEL, function () g_SendMsg(msg) end)
		else
			g_SendMsg(msg)
		end
	end)
	self:regJMsgHandler('remake_changeequips', self.onRecvRemakeRet)
	
	return true
end

local i32Max = i64.new(0x10000)*0x10000
function RemakeEquipment:onRecvRemakeRet(msg)
	local uids = msg.uids
	local temp = {}
	for k, v in pairs(g_Player.inventory) do
		temp[v:GetConfig().equipType] = v
	end
	local temp2 = table.copy(temp)
	for k, v in ipairs(uids) do
		v = i32Max*v[1]+v[2]
		local item = g_Player.backpack[v]
		g_Player:checkBetterEquip(item, temp)
	end
	local ids = {}
	for k, v in pairs(temp) do
		if v ~= temp2[k] then
			ids[#ids + 1] = v.uniqueId
		end
	end
	if #ids > 0 then
		ChangeGoodEquipment:Show(self:GetRootLayer(), ids)
	end
end

function RemakeEquipment:Show(...)
	cVer:Show(...)
end


MakeEquipment = class('MakeEquipment', CppUI)
local super = MakeEquipment.__super

function MakeEquipment:init()
	if not super.init(self) then return false end
	
	self:addLuaHandler('btn_dazao', function ()
		local remakeVal = PLAYER_BASE_DATA.remakeValue
		if g_Player.buildEquipCost > remakeVal then
			local crystal = (g_Player.buildEquipCost-remakeVal)/MAIN_PLAYER.CristalScaling + 0.9999
			LShowMessage(SSFmt(TDGETSTRCS('SD_Remake_Build_cristal'), crystal), nil, nil, MBT_OKCANCEL, function ()
				local msg = proto.C2S_BuildEquip.new()
				msg.state = 3
				g_SendMsg(msg)
			end)
			return
		end
		local msg = proto.C2S_BuildEquip.new()
		msg.state = 2
		g_SendMsg(msg)
	end)
end