local proto = require'protocol'
local vipCfg = require'config.vip'

DlgToBStronger = class('DlgToBStronger', CppUI)
local super = DlgToBStronger.__super

local function quickFight()
	local msg = proto.C2S_RequestFight.new()
	msg.battleType = FIGHT_BATTLE_TYPE_FBT_QUICKFIGHT
	msg.parm = 0
	g_SendMsg(msg)
end

function DlgToBStronger:init()
	if not super.init(self) then return false end
	
	self:addLuaHandler('btn_kssd', function ()
		self:close()
		if PLAYER_BASE_DATA.quickFightTimes == 0 then
			LShowMessage(
				SSFmt(TDGETSTRCS('QUICK_FIGHT_TIP_0'), MAIN_PLAYER.m_quickBattleCost),
				nil,
				nil,
				MBT_OKCANCEL,
				quickFight)
		else
			local vipLevel = MAIN_PLAYER:getCurrentVipLevel(0, 0, 0)
			local cfg = vipCfg[vipLevel]
			if cfg then
				local num = cfg.quickBattle - PLAYER_BASE_DATA.quickFightTimes
				if num <= 0 then
					LShowMessage(TDGETSTRCS('QUICK_FIGHT_TIP_2'))
				else
					LShowMessage(SSFmt(TDGETSTRCS('QUICK_FIGHT_TIP_1'), MAIN_PLAYER.m_quickBattleCost, vipLevel, num),
						nil,
						nil,
						MBT_OKCANCEL,
						quickFight)
				end
			end
		end
	end)
	
	local vipLv = MAIN_PLAYER:getCurrentVipLevel(0, 0, 0)
	if vipLv == 0 then
		self:addLuaHandler('btn_sclcz', function ()
			local layer = self:GetRootLayer()
			self:close()
			Charge:Show(layer)
		end)
		
		local btnsclcz = self:seekWidgetByName('btn_sclcz')
		local anim = CreateAnimation('e_guide_shou_%02u.png', 'e_mainben.plist', 0.15, 3)
		anim:setAnchorPoint(ccp(0.2, 0.8))
		anim:setPosition(80, 0)
		btnsclcz:addNode(anim)
	else
		local lbl = self:seekWidgetByName('btn_sclcz')
		if lbl ~= nil then lbl:setVisible(false) end
		
		local btnQuickFight = self:seekWidgetByName('btn_kssd')
		local anim = CreateAnimation('e_guide_shou_%02u.png', 'e_mainben.plist', 0.15, 3)
		anim:setAnchorPoint(ccp(0.2, 0.8))
		btnQuickFight:addNode(anim);
	end

	return true
end