local vipCfg = require'config.vip'

local SSFmt = string.format

VIPDetail = class('VIPDetail', CppUI)
local super = VIPDetail.__super

local curLevel = 0

function VIPDetail:init()
	if not super.init(self) then return false end
	
	self:UpdateDetails(MAIN_PLAYER:getCurrentVipLevel(0, 0, 0))
	
	self:addLuaHandler('btn_next', function () self:Onbtn_next() end)
	self:addLuaHandler('btn_prev', function () self:Onbtn_prev() end)
	
	self:regJMsgHandler('vipgift_state', self.updateGiftGoNext)
	
	return true
end

function VIPDetail:updateGiftGoNext()
	performWithDelay(self, function ()
		if MAIN_PLAYER:isCanGetVipGift(curLevel+1) then
			self:UpdateDetails(curLevel + 1)
		else
			self:UpdateGiftBen()
			self:UpdateDetails(curLevel)
		end
	end, 0.001)
end

function VIPDetail:Onbtn_next()
	self:UpdateDetails(curLevel + 1)
end

function VIPDetail:Onbtn_prev()
	self:UpdateDetails(curLevel - 1)
end

function VIPDetail:UpdateDetails(lv)
	if ( lv < 1 ) then
		lv = 1
	elseif ( lv > 20 ) then
		lv = 20
	end
--	if ( lv == curLevel ) then return false end
	
	curLevel = lv
	
	local pnl = self:seekWidgetByName('pnl_vip_0')
	if pnl == nil then return false end
	
	local cfg = vipCfg[curLevel]
	
	local info = SSFmt(TDGETSTRCS('VIP_STRINGS'), cfg.diamond, curLevel, cfg.vipgift, cfg.eliteChallenge, cfg.quickBattle, 
			cfg.bossChallenge, cfg.buyGold, cfg.additionalBossAward, cfg.mercenaryCulture, cfg.remark, 
			cfg.tenmercenaryCulture == 1 and TDGETSTRCS("PLAYER_HAVE_FUNCTION") or TDGETSTRCS("PLAYER_NO_FUNCTION"),
			cfg.remarkessence, cfg.functionboss, cfg.arenaaward, cfg.labaMan, cfg.labaHero, cfg.labaCity, 
			cfg.battleexpextra, cfg.duorenfbenfreetimes, cfg.shopfreetime, cfg.bossgxextra, cfg.dropextra)
	
	local lbl_vip = self:seekWidgetByName('lbl_vip')
		lbl_vip:removeFromParent()
	local title = UIStaticRichText:createWithString(SSFmt( TDGETSTRCS( "VIP_TITLE" ), curLevel ))
		title:setPosition(ccp(pnl:getSize().width / 2, pnl:getSize().height - 40))
		title:setName("lbl_vip")
		pnl:addChild(title)
	
	local lv = UIHO:seekWidgetByName(pnl, 'List_des')
	local lblinfo = UIHO:seekWidgetByName(lv, 'lbl_info')
	if (lblinfo ~= nil) then lblinfo:removeFromParent() end
	local name_ = UIStaticRichText:createWithString(info, lv:getSize().width - 20, 3)
		name_:setPosition(ccp(lv:getSize().width / 2, lv:getSize().height / 2))
		name_:setName('lbl_info')
		lv:addChild(name_)
	
	self:UpdateGiftBen()
end

function VIPDetail:UpdateGiftBen()
	local btn = self:seekWidgetByName('btn_charge_receive')
	if btn ~= nil then
		if not MAIN_PLAYER:isCanGetVipGift(curLevel) then
			btn:setEnabled(false)
		else
			btn:setEnabled(true)
			local img = UIHO:seekWidgetByName(btn, 'img_viplvchanged')
			if iv ~= nil then
				iv:setVisible(true)
				local iiv = img:getChildByTag(-9528)
				if (iiv ~= nil) then
					iiv:removeFromParent()
				end
				local effectSpr = CreateAnimation('new_%02u.png', 'new.plist', 0.1, 10);
				effectSpr:setPosition(ccp(0, 0));
				iv:addNode(effectSpr, 999, -9528);
			end
		end
	end
end
