local tnull = tolua.isnull

local guideMgr = {}
local guideCfg = require'config.guide'

local function setGuide(btn, cfg)
	local spr = btn:getNodeByTag(-9875)
	if spr then btn:removeNode(spr) end
	
	spr = CreateAnimation('e_guide_shou_%02u.png', 'e_mainben.plist', 0.15, 3)
	spr:setAnchorPoint(ccp(0, 1))
	spr:setScale(1.5)
	spr:setPosition(ccp(cfg.x, cfg.y))
	btn:addNode(spr, 999, -9875)
	
	btn.guide = cfg
end

local uiGuide = {}
function guideMgr.ShowGuide(cfg)
	if cfg.ui then
		uiGuide[cfg.ui] = cfg
	end
	for ui in pairs(g_CppUI) do
		if not tnull(ui) then
			local btn = ui:seekWidgetByName(cfg.btn)
			if btn then
				setGuide(btn, cfg)
				return
			end
		end
	end
	for ui in pairs(g_LuaUI) do
		if not tnull(ui) then
			local btn = ui:seekWidgetByName(cfg.btn)
			if btn then
				setGuide(btn, cfg)
				return
			end
		end
	end
end

function guideMgr.CheckGuideUI(name, ui)
	local cfg = uiGuide[name]
	if not cfg then return end
	uiGuide[name] = nil
	
	local btn = ui:seekWidgetByName(cfg.btn)
	if btn then
		setGuide(btn, cfg)
	end
end

return guideMgr