if _is_script_loaded then
	return
end
_is_script_loaded = true

local pcall = pcall
local unpack = unpack
local print = print
local tostring = tostring
local sfmt = string.format
local tcast = tolua.cast

local _require = require
function require(m)
	local r = {pcall(_require, m)}
	if not r[1] then
		print(r[2])
		return
	end
	
	return unpack(r, 2)
end

CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile('2Mgui/2M_icon_img_war.plist')
CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile('widgets/activity.plist')
CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile('widgets/widgets.plist')
CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile('equipment4.plist')

local guideMgr = require'guide'

local function getHandler(f)
	return function (s, e)
		s = tcast(s, 'Widget')
		
		local spr = s:getNodeByTag(-9875)
		if spr then s:removeNode(spr) end
		
		local r, info = pcall(f, s, e)
		if not r then print(info) end
		
		local guide = s.guide
		if guide and guide.next then
			s.guide = nil
			guideMgr.ShowGuide(guide.next)
		end
	end
end
g_GetLuaHandler = getHandler

local oldF = UIPopupLayer.addLuaHandler
function UIPopupLayer:addLuaHandler(w, f)
	oldF(self, w, getHandler(f))
end

local oldF = UILayerEx.addLuaHandler
function UILayerEx:addLuaHandler(w, f)
	oldF(self, w, getHandler(f))
end

local meta = getmetatable(i64.new(0))
meta.encode = meta.__tostring
function isi64(n)
	return getmetatable(n) == meta
end
--local x = i64.new(0x10000)*0x10000
--meta.encode = function (i)
--	return sfmt('[%u,%u]', (i/x):tonumber(), (i%x):tonumber())
--end

require'main'
