
require "Cocos2d"

-- cclog
local cclog = function(...)
    print(string.format(...))
end


local abyssCfg = require'config.abyss'
local json = require('json')  


AbyssChallenge = class('AbyssChallenge', LuaUI)
local super = AbyssChallenge.__super
local g_fisrt = {}
local g_battleStatus = 0
local g_force = 0
local g_endTime = false
local g_countDownAction = nil


local bit1 = require("bit1")

local function unicode_to_utf8(convertStr)
    if type(convertStr)~="string" then
return convertStr
    end

local resultStr=""
    local i=1
while true do

        local num1=string.byte(convertStr,i)
        local unicode

        if num1~=nil and string.sub(convertStr,i,i+1)=="\\u" then
            unicode=tonumber("0x"..string.sub(convertStr,i+2,i+5))
            i=i+6
elseif num1~=nil then
            unicode=num1
            i=i+1
        else
            break
        end


        print(unicode)
		
		print(bit1)

        if unicode <= 0x007f then
            resultStr=resultStr..string.char(bit.band(unicode,0x7f))
        elseif unicode >= 0x0080 and unicode <= 0x07ff then

            resultStr=resultStr..string.char(bit.bor(0xc0,bit.band(bit.rshift(unicode,6),0x1f)))

            resultStr=resultStr..string.char(bit.bor(0x80,bit.band(unicode,0x3f)))


        elseif unicode >= 0x0800 and unicode <= 0xffff then


            resultStr=resultStr..string.char(bit.bor(0xe0,bit.band(bit.rshift(unicode,12),0x0f)))

            resultStr=resultStr..string.char(bit.bor(0x80,bit.band(bit.rshift(unicode,6),0x3f)))

            resultStr=resultStr..string.char(bit.bor(0x80,bit.band(unicode,0x3f)))


        end

    end

resultStr=resultStr..'\0'

    print(resultStr)
return resultStr
end



function AbyssChallenge:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('pve_syjd.json', true) then return false end
	
	self:addLuaHandler('btn_one', function () self:onChangelv(1) end)
	self:addLuaHandler('btn_two', function () self:onChangelv(2) end)
	self:addLuaHandler('btn_three', function () self:onChangelv(3) end)
	
	self:addLuaHandler('btn_start', function () g_SendMsg({ptype = 'abyss_challenge', abysslv = self._abyssSelectlv}) end)
	self:addLuaHandler('btn_force', function () g_SendMsg({ptype = 'abyss_force'}) end)
	self:addLuaHandler('btn_buy', function () g_SendMsg({ptype = 'abyss_buy'}) end)
	self:addLuaHandler('btn_sd', function () g_SendMsg({ptype = 'abyss_mop'}) end)
	self:addLuaHandler('btn_zdzd_jd', function () g_SendMsg({ptype = 'abyss_automatic'}) end)
	
	self:addLuaHandler('btn_left', function () self:onUpdateBossInfo(-1) end)
	self:addLuaHandler('btn_right', function () self:onUpdateBossInfo(1) end)
	
	self:addLuaHandler('btn_help_', function ()
		LShowMessage(getString('ABYSS_HELP'), nil, nil, MBT_OK, self._nil, self._nil, self._nil)
	end)
	self:addLuaHandler('btn_close', function () self:close() end)
	self:OutClickClose()
	
	self._abysslv = 101
	self._abyssSelectlv = 101
	
	self:seekWidgetByName('btn_two'):setTouchEnabled(false)
	self:seekWidgetByName('btn_three'):setTouchEnabled(false)
	self:seekWidgetByName('btn_force'):setTouchEnabled(false)
	self:seekWidgetByName('btn_force'):setVisible(false)
	self:seekWidgetByName('lab_endTime'):setVisible(false)
	
	self:regJMsgHandler('abyss_open', self.onRecvAbysslv)
	self:regJMsgHandler('abyss_refresh', self.onRecvRefresh)
	self:regJMsgHandler('abyss_buy', self.onRecvAbyssBuy)
	self:regJMsgHandler('abyss_mop', self.onRecvAbyssMop)
	self:regJMsgHandler('abyss_battle', self.AbyssBattleInfo)
	self:regJMsgHandler('abyss_battlestatus', self.AbyssBattleStatus)
	self:regJMsgHandler('abyss_sleep', self.AbyssSleep)
	self:regJMsgHandler('abyss_force', self.AbyssForce)
	self:regJMsgHandler('abyss_buymoptimes', self.onRecvAbyssBuyEnd)
	self:regJMsgHandler('abyss_firsts', self.onFirsts)
	self:regJMsgHandler('abyss_lvstatus', self.onChangeLvStatus)
	self:regJMsgHandler('abyss_showmail', self.onShowMail)
	self:regJMsgHandler('abyss_automatic', self.onAutomatic)
	
	g_SendMsg({ptype = 'abyss_open'})
	
	return true
end

function AbyssChallenge:onAutomatic(msg)
	self:seekWidgetByName('btn_zdzd_jd:img_txt'):loadTexture(msg and 'icon_txt_stoptz.png' or 'icon_txt_zdzd_jd.png', UI_TEX_TYPE_PLIST)
end


require "lc"

function AbyssChallenge:onFirsts(msg)
	 print("AbyssChallenge:onFirsts===11=")
	 print(msg)
	-- local result = json.decode(msg)   --json转table
	-- for key, value in ipairs(result) do
	 
	 --  local ss=value.gate_name
	  -- print(ss)
	  -- ss = string.gsub(ss,"\\u","\\\\u")
	  -- print(ss)
	   --ss=unicode_to_utf8(ss)
	   
	-- ss=w2u(msg)
	-- print(ss)
	-- g_fisrt[value.gate_chID_seId]=ss
	 
	 --local name1=string.format("哈哈%d",key)
	 --g_fisrt[value.gate_chID_seId]=name1
	 --print(value.gate_chID_seId)
	 --print(value.gate_name)
	 --print("    ")
	 
g_fisrt["gate_1_1"] = msg.gate_1_1
g_fisrt["gate_1_2"] = msg.gate_1_2
g_fisrt["gate_1_3"] = msg.gate_1_3
g_fisrt["gate_1_4"] = msg.gate_1_4
g_fisrt["gate_1_5"] = msg.gate_1_5
g_fisrt["gate_1_6"] = msg.gate_1_6
g_fisrt["gate_1_7"] = msg.gate_1_7
g_fisrt["gate_1_8"] = msg.gate_1_8
g_fisrt["gate_1_9"] = msg.gate_1_9
g_fisrt["gate_1_10"] = msg.gate_1_10
g_fisrt["gate_1_11"] = msg.gate_1_11
g_fisrt["gate_1_12"] = msg.gate_1_12
g_fisrt["gate_1_13"] = msg.gate_1_13
g_fisrt["gate_1_14"] = msg.gate_1_14
g_fisrt["gate_1_15"] = msg.gate_1_15
g_fisrt["gate_1_16"] = msg.gate_1_16
g_fisrt["gate_1_17"] = msg.gate_1_17
g_fisrt["gate_1_18"] = msg.gate_1_18
g_fisrt["gate_1_19"] = msg.gate_1_19
g_fisrt["gate_1_20"] = msg.gate_1_20

g_fisrt["gate_2_1"] = msg.gate_2_1
g_fisrt["gate_2_2"] = msg.gate_2_2
g_fisrt["gate_2_3"] = msg.gate_2_3
g_fisrt["gate_2_4"] = msg.gate_2_4
g_fisrt["gate_2_5"] = msg.gate_2_5
g_fisrt["gate_2_6"] = msg.gate_2_6
g_fisrt["gate_2_7"] = msg.gate_2_7
g_fisrt["gate_2_8"] = msg.gate_2_8
g_fisrt["gate_2_9"] = msg.gate_2_9
g_fisrt["gate_2_10"] = msg.gate_2_10
g_fisrt["gate_2_11"] = msg.gate_2_11
g_fisrt["gate_2_12"] = msg.gate_2_12
g_fisrt["gate_2_13"] = msg.gate_2_13
g_fisrt["gate_2_14"] = msg.gate_2_14
g_fisrt["gate_2_15"] = msg.gate_2_15
g_fisrt["gate_2_16"] = msg.gate_2_16
g_fisrt["gate_2_17"] = msg.gate_2_17
g_fisrt["gate_2_18"] = msg.gate_2_18
g_fisrt["gate_2_19"] = msg.gate_2_19
g_fisrt["gate_2_20"] = msg.gate_2_20

g_fisrt["gate_3_1"] = msg.gate_3_1
g_fisrt["gate_3_2"] = msg.gate_3_2
g_fisrt["gate_3_3"] = msg.gate_3_3
g_fisrt["gate_3_4"] = msg.gate_3_4
g_fisrt["gate_3_5"] = msg.gate_3_5
g_fisrt["gate_3_6"] = msg.gate_3_6
g_fisrt["gate_3_7"] = msg.gate_3_7
g_fisrt["gate_3_8"] = msg.gate_3_8
g_fisrt["gate_3_9"] = msg.gate_3_9
g_fisrt["gate_3_10"] = msg.gate_3_10
g_fisrt["gate_3_11"] = msg.gate_3_11
g_fisrt["gate_3_12"] = msg.gate_3_12
g_fisrt["gate_3_13"] = msg.gate_3_13
g_fisrt["gate_3_14"] = msg.gate_3_14
g_fisrt["gate_3_15"] = msg.gate_3_15
g_fisrt["gate_3_16"] = msg.gate_3_16
g_fisrt["gate_3_17"] = msg.gate_3_17
g_fisrt["gate_3_18"] = msg.gate_3_18
g_fisrt["gate_3_19"] = msg.gate_3_19
g_fisrt["gate_3_20"] = msg.gate_3_20
	 
end

function AbyssChallenge:onRecvAbyssBuy(msg)
	LShowMessage(string.format(getString('ABYSS_MOP_CHALLENGE'), msg.times, msg.cost), nil, nil, MBT_OKCANCEL,
		function()
			g_SendMsg({ptype = 'abyss_buymoptimes'})
		end)
end

function AbyssChallenge:AbyssForce(msg)
	LShowMessage(string.format(getString('ABYSS_FORCE_CHALLENGE'), msg), nil, nil, MBT_OKCANCEL,
		function()
			g_SendMsg({ptype = 'abyss_forcefight', abysslv = self._abyssSelectlv})
		end)
end

function AbyssChallenge:onChangeLvStatus(msg)
	if msg.asklv ~= self._abyssSelectlv then return false end
	
	self:AbyssBtnStatus(msg.status)
end

function AbyssChallenge:AbyssBattleStatus(msg)
	if msg.map == self._abyssSelectlv then
		self:AbyssBtnStatus(msg.status)
	else
		g_SendMsg({ptype = 'abyss_asklv', asklv = self._abyssSelectlv})
	end
end

function AbyssChallenge:AbyssBtnStatus(status)
	if self._abysslv < self._abyssSelectlv then
		self:seekWidgetByName('btn_start:img_txt'):loadTexture('icon_txt_bntz.png', UI_TEX_TYPE_PLIST)
		self:seekWidgetByName('btn_start'):setTouchEnabled(false)
		self:seekWidgetByName('lab_endTime'):setVisible(false)
		self:seekWidgetByName('btn_force'):setTouchEnabled(false)
		self:seekWidgetByName('btn_force'):setVisible(false)
	else
		if status == 0 then
			self:seekWidgetByName('btn_start:img_txt'):loadTexture('icon_txt_kstz.png', UI_TEX_TYPE_PLIST)
			self:seekWidgetByName('btn_start'):setTouchEnabled(true)
			self:seekWidgetByName('btn_zdzd_jd'):setTouchEnabled(true)
			self:seekWidgetByName('lab_endTime'):setVisible(false)
			self:seekWidgetByName('btn_force'):setTouchEnabled(false)
			self:seekWidgetByName('btn_force'):setVisible(false)
		elseif status == 1 then
			self:seekWidgetByName('btn_start:img_txt'):loadTexture('icon_zztz.png', UI_TEX_TYPE_PLIST)
			self:seekWidgetByName('btn_start'):setTouchEnabled(true)
			self:seekWidgetByName('btn_zdzd_jd'):setTouchEnabled(true)
		elseif status == 2 then
			self:seekWidgetByName('btn_start:img_txt'):loadTexture('icon_txt_xxzz.png', UI_TEX_TYPE_PLIST)
			self:seekWidgetByName('btn_start'):setTouchEnabled(false)
			self:seekWidgetByName('btn_zdzd_jd'):setTouchEnabled(false)
			if g_endTime then
				self:seekWidgetByName('lab_endTime'):setVisible(true)
				self:seekWidgetByName('btn_force'):setTouchEnabled(true)
				self:seekWidgetByName('btn_force'):setVisible(true)
			end
		elseif status == 4 then
			self:seekWidgetByName('btn_start:img_txt'):loadTexture('icon_ytz.png', UI_TEX_TYPE_PLIST)
			self:seekWidgetByName('btn_start'):setTouchEnabled(false)
		end
	end
end

function AbyssChallenge:onShowMail(show)
	if show == true then
		DlgMailBox:Show(self:GetRootLayer())
	end
end

function AbyssChallenge:onRecvAbyssMop(msg)
	self:seekWidgetByName('lbl_buycount'):setText(string.format(getString('ABYSS_MOP_TIMES'), msg))
end

function AbyssChallenge:onRecvAbyssBuyEnd(msg)
	self:seekWidgetByName('lbl_buycount'):setText(string.format(getString('ABYSS_MOP_TIMES'), msg))
end

function AbyssChallenge:AbyssBattleInfo(msg)
	if not msg then
		if not self:ShowBattleInfo() then
			LShowMessage(getString('ABYSS_CHALLENGE_TIPS'), nil, nil, MBT_OK, self._nil, self._nil, self._nil)
		end
	else
		self:ShowBattleInfo()
	end
end

function AbyssChallenge:ShowBattleInfo()
	-- if g_Player:IsAbyssFighting() then
		local ui = GetLuaUI('AbyssChallenge')
		if ui ~= nil then
			DlgAbyssFight:Show(ui:GetRootLayer())
		end
		return true
	-- end
	-- return false
end

function AbyssChallenge:onChangelv(lv)
	local _lv = math.floor(self._abysslv / 100)
	if _lv < lv then return end
	
	self._abyssSelectlv = lv * 100 + 1
	self:onUpdateBossInfo(0)
end

function AbyssChallenge:onChangeMainBtnStatus(lv)
	if lv == 1 then
		self:seekWidgetByName('btn_one:img'):setVisible(true)
		self:seekWidgetByName('btn_two:img'):setVisible(false)
		self:seekWidgetByName('btn_three:img'):setVisible(false)
	elseif lv == 2 then
		self:seekWidgetByName('btn_one:img'):setVisible(false)
		self:seekWidgetByName('btn_two:img'):setVisible(true)
		self:seekWidgetByName('btn_three:img'):setVisible(false)
	elseif lv == 3 then
		self:seekWidgetByName('btn_one:img'):setVisible(false)
		self:seekWidgetByName('btn_two:img'):setVisible(false)
		self:seekWidgetByName('btn_three:img'):setVisible(true)
	end
end

function AbyssChallenge:onUpdateBossInfo(direction, status)
	local cfg = abyssCfg[self._abyssSelectlv + direction]
	if cfg ~= nil then
		self._abyssSelectlv = self._abyssSelectlv + direction
		
		local m = math.floor(self._abyssSelectlv / 100)
		local n = math.floor(self._abyssSelectlv - m * 100)
		
		self:onChangeMainBtnStatus(m)
		
		self:seekWidgetByName('lbl_levelnum'):setText(string.format(getString(string.format('ABYSS_TITLE_%d', m)), n))
		self:seekWidgetByName('img_monheader'):loadTexture(string.format("mon_(%d).png", cfg.boss), UI_TEX_TYPE_PLIST)
		self:seekWidgetByName('lbl_bossname'):setText(cfg.bossname)
		self:seekWidgetByName('lbl_bossAttr1'):setText(cfg.bosskind)
		self:seekWidgetByName('lbl_bossAttr2'):setText(cfg.bossskill)
		self:seekWidgetByName('lbl_reward'):setText(cfg.awardinfo)
	
	    
		local gate = string.format('gate_%d_%d',m,n)
		print(gate)
		print(g_fisrt[gate])
		local gatestr=g_fisrt[gate];
		if gatestr==nil  then
		gatestr="无"
		end
		
		self:seekWidgetByName('lbl_fistplayer'):setText(gatestr)
		self:seekWidgetByName('btn_left'):setVisible(abyssCfg[self._abyssSelectlv - 1] and true or false)
		self:seekWidgetByName('btn_left'):setTouchEnabled(abyssCfg[self._abyssSelectlv - 1] and true or false)
		self:seekWidgetByName('btn_right'):setVisible(abyssCfg[self._abyssSelectlv + 1] and true or false)
		self:seekWidgetByName('btn_right'):setTouchEnabled(abyssCfg[self._abyssSelectlv + 1] and true or false)
		
		g_SendMsg({ptype = 'abyss_asklv', asklv = self._abyssSelectlv})
	end
end

function AbyssChallenge:onRecvAbysslv(msg)
	self:onRecvAbyssBuyEnd(msg.mop)
	self:onUpdateBossInfo(0)
end

function AbyssChallenge:onRecvRefresh(msg)
	self:seekWidgetByName('btn_two'):setTouchEnabled(false)
	self:seekWidgetByName('btn_two:img_lock'):setVisible(true)
	self:seekWidgetByName('btn_three'):setTouchEnabled(false)
	self:seekWidgetByName('btn_three:img_lock'):setVisible(true)
	g_force = msg.force
	self._abysslv = msg.lv
	self._abyssSelectlv = msg.lv
	local lv = math.floor(self._abysslv / 100)
	if lv > 1 then 
		self:seekWidgetByName('btn_two'):setTouchEnabled(true)
		self:seekWidgetByName('btn_two:img_lock'):setVisible(false)
	end
	if lv > 2 then 
		self:seekWidgetByName('btn_three'):setTouchEnabled(true)
		self:seekWidgetByName('btn_three:img_lock'):setVisible(false)
	end
	self:onUpdateBossInfo(0)
end

local function getTime(tm)
	local m = math.floor(tm / 60)
	tm = tm % 60
	return m, tm
end

function AbyssChallenge:AbyssSleep(msg)
	local et, nt = msg.et, msg.nt
	if nt < et then
		self:seekWidgetByName('lab_endTime'):setVisible(true)
		self:seekWidgetByName('btn_force'):setTouchEnabled(true)
		self:seekWidgetByName('btn_force'):setVisible(true)
		
		if g_countDownAction ~= nil then 
			self:stopAction(g_countDownAction)
			g_countDownAction = nil
		end
		
		self:updateTime(et, nt)
		g_countDownAction = schedule(self, function ()
			nt = nt + 1
			self:updateTime(et, nt)
		end, 1)
	else
		if g_countDownAction ~= nil then 
			self:stopAction(g_countDownAction)
			g_countDownAction = nil
		end
		
		self:updateTime(et, nt)
	end
	
end

function AbyssChallenge:updateTime(et, nt)
	if nt < et then
		local tip = string.format(getString('ABYSS_SLEEP_TIME'), getTime(et - nt))
		self:seekWidgetByName('lab_endTime'):setText(string.format('%s\n', tip))
		g_endTime = true
	else
		g_endTime = false
		self:seekWidgetByName('lab_endTime'):setVisible(false)
		self:seekWidgetByName('btn_force'):setTouchEnabled(false)
		self:seekWidgetByName('btn_force'):setVisible(false)
		
		g_SendMsg({ptype = 'abyss_asklv', asklv = self._abyssSelectlv})
	end
end

function AbyssChallenge:_nil()
end