

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

----------ActivityGeneral_%s----------
ActivityInfo = class('ActivityInfo', LuaUI)
local super = ActivityInfo.__super
ActivityGeneral_hefu = ActivityInfo
ActivityGeneral_xilian = ActivityInfo

local m_activityNames = ''
local s_mapActivityInfo_general = {}
	
function ActivityInfo:init(name)
	if not super.init(self) then return false end
	
	if not self:initRootWidget('activity_generalex.json', true) then return false end
	
	local listitem = self:seekWidgetByName('listitem')
	if listitem == nil then return false end
	
	m_activityNames = name
	
	s_mapActivityInfo_general["ActivityGeneral_hefu"] = "icon_txt_hfjh.png";
	s_mapActivityInfo_general["ActivityGeneral_gem"] = "icon_txt_smbs.png";
	s_mapActivityInfo_general["ActivityGeneral_xilian"] = "icon_txt_gjxlbj.png";
	s_mapActivityInfo_general["ActivityGeneral_abyss"] = "icon_txt_hd_jdsy.png";
	s_mapActivityInfo_general["ActivityGeneral_quarry"] = "icon_txt_kgbj1.png";
	
	g_SendMsg({ ptype = 'activity_general', asktype = m_activityNames, })
	
	self:OutClickClose()
	self:addLuaHandler('btn_close', function () 
		self:close() 
	end)
	
	return true
end

function ActivityInfo:onEnter()
	self:regMsgHandler('activity_general', self.setActTime)
end

function ActivityInfo:setActTime(msg)
	local info, bt, et, nt = msg.info, msg.bt, msg.et, msg.nt
	
	local img_title = self:seekWidgetByName("img_nameTitle")
	if (img_title ~= nil) then
	
		img_title:loadTexture(s_mapActivityInfo_general[m_activityNames], UI_TEX_TYPE_PLIST);
	end
	
	local listitem = self:seekWidgetByName("listitem")
	if (listitem ~= nil) then
		listitem:removeAllItems()
		
		local srt = UIStaticRichText:createWithString(info, listitem:getSize().width - 20, 3);
		srt:setPosition(ccp(listitem:getSize().width / 2, listitem:getSize().height / 2));
		listitem:pushBackCustomItem(srt);
	end
	
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end
	
function ActivityInfo:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end


