local json = require'json'
require'uifunc'

local SSFmt = string.format

AllConsumeActivity = class('AllConsumeActivity', LuaUI)
local super = AllConsumeActivity.__super

local g_sitem_version = 0 --版本
local g_isloaditem = false --是否正在加载数据

function AllConsumeActivity:init()

	if not super.init(self) then
		return false
	end
	
	if not self:initRootWidget('activity_christmas_cost.json', true) then
		return false
	end
	
	self:OutClickClose()
	
	self:addLuaHandler('btn_close', function ()
		self:close()
	end)
	
	self:addLuaHandler('btn_rlue', function ()
		LShowMessage(getString('ALLCOLLECTION_TIP_EXP'), nil, nil,MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	g_SendMsg({
		ptype = 'allconsumeact',
		flag = g_sitem_version,
	})
	
	return true
end

function AllConsumeActivity:onEnter()
	self:regJMsgHandler('allconsumeact', self.UpdateUI)
end

function AllConsumeActivity:UpdateUI(data)
	local listitem = self:seekWidgetByName('listitem')
	while (listitem:getItems():count() > 0) do
		listitem:removeLastItem()
	end
	
	g_sitem_version = data.flag
	g_isloaditem = false
	
	local txt = self:seekWidgetByName('lab_total')
	txt:setText(string.format(getString('ALLCOLLECTION_TITLE_TOTAL'), data.total))
	
	local rank = self:seekWidgetByName('rank')
	-- rank:setText(SSFmt(TDGETSTRCS('ALLCOLLECTION_LV_LIMIT'),
		-- data.lv, data.no1, data.no11, data.no2, data.no22, data.no3, data.no33))
	rank:setText(SSFmt(TDGETSTRCS('ALLCOLLECTION_LV_LIMIT'), data.lv))
	
	local widgetTemplate = LOADWIDGET("activity_item.json")
	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()		
		local canGet = _item.canGet --能否领取
		local chargeDay =_item.chargeDay
		local idx =_item.idx --所在索引
		
		wgtclone:setTag(idx)
		
		local ImageTitle = UIHO:seekWidgetByName(wgtclone, 'ImageTitle')
		ImageTitle:setText(string.format(getString('ALLCOLLECTION_TITLE'), chargeDay))
		
		--取奖励
		local j = 1
		for v,award in  ipairs(_item.itemList) do	
			local image = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:itemImg', j))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:lab_dec', j))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(award.type, award.value, award.parm, image)
				lab_dec:setText(dec)
			end
			j =j+1
		end
		
		--隐藏其他的
		for n=j,3 do 
			local itemAward = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d',n))
			if itemAward ~= nil then
				itemAward:setEnabled(false)
			end
		end
		
		--设置按钮
		local btn_click = UIHO:seekWidgetByName(wgtclone, 'btn_click')
		
		self:addLuaHandler(btn_click, function ()
				g_SendMsg({
					ptype = 'allconsumeactaward',
					index = _item.idx,
				})
			end)
		
		btn_click:setTouchEnabled(canGet == 1)
		if (canGet == 1) then
			btn_click:loadTextureDisabled("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTextureNormal("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTexturePressed("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
		elseif (canGet == 2) then
			btn_click:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
		else
			btn_click:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
		end
			
		listitem:pushBackCustomItem(wgtclone)
	end
	
	--倒计时
	local bt = data.bt
	local et = data.et
	local nt = data.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function AllConsumeActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function AllConsumeActivity:_nil()
end