local itemConfig = require'config.item'
local json = require'json'
require'uifunc'
local actionMgr = require'action'

BuyLimitsActivity = class('BuyLimitsActivity', LuaUI)
local super = BuyLimitsActivity.__super

function BuyLimitsActivity:init()

	if not super.init(self) then
		return false
	end
	
	if not self:initRootWidget('activity_buy.json', true) then
		return false
	end
	self:OutClickClose()
	
	self:addLuaHandler('btn_rlue', function ()
		LShowMessage(getString('BUYLIMITS_DES'), nil, nil,MBT_OK,self._nil,self._nil,self._nil)
	end)
	
	self:addLuaHandler('btn_charge', function ()
		local layer = self:GetRootLayer()
		self:close()
		Charge:Show(layer)
	end)
	
	g_SendMsg({ptype = 'blact_list',})
	return true
end

function BuyLimitsActivity:onEnter()
	self:regJMsgHandler('blact_list', self.UpdateUI)
	self:regJMsgHandler('blact_buy', self.UpdateUI_Buy)
end
local colorStr = {'888888', '88ff88', '8888ff', 'ff88ff', 'ff8800', 'ff0000'}
local function getColorName(id, color)
	local cfg = itemConfig[id]
	if not cfg then return 'null' end
	
	if cfg.itemClass ~= ITEM_CLASS_EQUIPMENT then
		return SSFmt(TDGETSTRCS("SD02_MAIL_AWARD_ITEM"), cfg.name, color)
	end
	
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then color = 8 end
	
	local nameEx = ''
	if star > 0 then
		nameEx = nameEx..SSFmt(TDGETSTRCS('EQUIP_STAR_NAME'), star)
	end
	if color >= 6 and color <= 8 then
		nameEx = nameEx..TDGETSTRCS('EQUIP_SQ_NAME_'..color)
	end
	if nameEx ~= '' then nameEx = '['..nameEx..']' end
	
	if color > 6 then color = 6 end
	return SSFmt('<c=%s>%s%s</>', colorStr[color], cfg.name, nameEx)
end
local function getColor(color)
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then return 8 end
	
	if color >= 6 and color <= 8 then return color end
	
	return color
end
function BuyLimitsActivity:AddEffect(img, value)
	local star = math.floor(value / 100)
	AddStarLevel(img, star, 9, -9874)
	
	local itemcolor = getColor(value)
	if itemcolor == 6 then
		local spr = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr, 999, -9875)
	elseif itemcolor == 7 then
		local spr = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr, 999, -9876)
	elseif itemcolor == 8 then
		local spr1 = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr1, 998, -9875)
		local spr2 = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr2, 999, -9876)
	end
end
function BuyLimitsActivity:UpdateUI_Buy(msg)
	if msg.tp == 1 then
		local pnl_globel = self:seekWidgetByName('pnl_globel')
		local wgtclone = UIHO:seekWidgetByName(pnl_globel, 'ImgItem_clone_'..msg.id)
		local lbl_number = UIHO:seekWidgetByName(wgtclone, "lbl_number")
		lbl_number:setText(tostring(msg.count))
		local img_isbuyed = UIHO:seekWidgetByName(wgtclone, "img_isbuyed")
		img_isbuyed:setVisible(true)
	elseif msg.tp == 2 then
		local pnl_personal = self:seekWidgetByName('pnl_personal')
		local wgtclone = UIHO:seekWidgetByName(pnl_personal, 'ImgItem_clone_'..msg.id)
		local lbl_number = UIHO:seekWidgetByName(wgtclone, "lbl_number")
		lbl_number:setText(tostring(msg.count))
	end
end

function BuyLimitsActivity:setItemImg(wgtclone, index, tp, _item)

	if wgtclone ~= nil then
		if type(_item) ~= 'nil' then
			wgtclone:setVisible(true)
			local img_buy = UIHO:seekWidgetByName(wgtclone, "img_buy")
			img_buy:setVisible(true)
			local itemImg = UIHO:seekWidgetByName(wgtclone, "item_img")
			local lbl_name = UIHO:seekWidgetByName(wgtclone, "lbl_name")
			
			local icon_cost2 = UIHO:seekWidgetByName(wgtclone, "icon_cost2")
			icon_cost2:setVisible(false)
			local txt_cost = UIHO:seekWidgetByName(wgtclone, "txt_cost")
			txt_cost:setText(tostring(_item.cristal))
			
			local img_cheap_1 = UIHO:seekWidgetByName(wgtclone, "img_cheap_1")
			img_cheap_1:setVisible(false)
			local img_cheap_5 = UIHO:seekWidgetByName(wgtclone, "img_cheap_5")
			img_cheap_5:setVisible(false)
			local img_cheap_8 = UIHO:seekWidgetByName(wgtclone, "img_cheap_8")
			img_cheap_8:setVisible(false)
			
			local lbl_number = UIHO:seekWidgetByName(wgtclone, "lbl_number")
			
			lbl_number:setText(tostring(_item.max))
			local img_isbuyed = UIHO:seekWidgetByName(wgtclone, "img_isbuyed")
			if _item.isget then
				img_isbuyed:setVisible(true)
			else
				img_isbuyed:setVisible(false)
			end

			if itemImg ~= nil then
				if _item.itemtp == 1 then --金币
					itemImg:loadTexture('img_bg_money.png', UI_TEX_TYPE_PLIST)
					lbl_name:setText(getString('BUYLIMITS_COUNT')..tostring(_item.p1))
				elseif _item.itemtp == 2 then --钻石
					itemImg:loadTexture('img_bg_zs.png', UI_TEX_TYPE_PLIST)
					lbl_name:setText(getString('BUYLIMITS_COUNT')..tostring(_item.p1))
				elseif _item.itemtp == 3 then --道具
					local cfg = itemConfig[_item.p1]
					if not cfg then return 'null' end
					if cfg.itemClass ~= ITEM_CLASS_EQUIPMENT then
						itemImg:loadTexture(cfg.texture, UI_TEX_TYPE_PLIST)
						itemImg:setScale(0.8)
						lbl_name:setText(string.format(getString('ITEM_TOTAL_INFO'), tostring(cfg.name), _item.p2))
					end
				elseif _item.itemtp == 4 then --装备
					local cfg = itemConfig[_item.p1]
					if not cfg then return 'null' end
					if cfg.itemClass == ITEM_CLASS_EQUIPMENT then
						itemImg:loadTexture(cfg.texture, UI_TEX_TYPE_PLIST)
						itemImg:setScale(0.8)
						self:AddEffect(itemImg,_item.p2)
						lbl_name:setText(tostring(cfg.name))
					end
				end
			end
			
			local btn_buy = UIHO:seekWidgetByName(wgtclone, "btn_buy")
			if btn_buy ~= nil then
				self:addLuaHandler(btn_buy, function ()
					g_SendMsg({
						ptype = 'blact_get',
						_tp = tp,
						_index = index,
					})
				end)
			end
		else
			wgtclone:setVisible(false)
		end
	end
end
function BuyLimitsActivity:UpdateUI(msg)

	local data = msg
	local widgetTemplate = LOADWIDGET("shop_item.json")
	
	--全局
	local next_g_time = self:seekWidgetByName('next_g_time')
	if msg.next_g == nil then
		next_g_time:setText( getString('BUYLIMITS_NEXT') .. getString('BUYLIMITS_END') )
	else
		next_g_time:setText(getString('BUYLIMITS_NEXT') .."\n".. msg.next_g)
	end
	local pnl_globel = self:seekWidgetByName('pnl_globel')
	for index=0,2 do
		local wgtclone = widgetTemplate:clone()
		wgtclone:setTag(index)
		wgtclone:setName('ImgItem_clone_'..index)
		local _x = index * 175
		local _y = 0
		wgtclone:setPosition(ccp(_x, _y))
		
		--注册按钮事件，还是显示已领取
		self:setItemImg(wgtclone,index,1,msg.items_g[index+1])
		pnl_globel:addChild(wgtclone)
	end
		
	--个人
	local next_p_time = self:seekWidgetByName('next_p_time')
	if msg.next_p == nil then
		next_p_time:setText( getString('BUYLIMITS_NEXT') .. getString('BUYLIMITS_END') )
	else
		next_p_time:setText(getString('BUYLIMITS_NEXT') .."\n".. msg.next_p)
	end
	local pnl_personal = self:seekWidgetByName('pnl_personal')
	for index=0,2 do
		local wgtclone = widgetTemplate:clone()
		wgtclone:setTag(index)
		wgtclone:setName('ImgItem_clone_'..index)
		local _x = index * 175
		local _y = 0
		wgtclone:setPosition(ccp(_x, _y))
		
		--注册按钮事件，还是显示已领取
		self:setItemImg(wgtclone,index,2,msg.items_p[index+1])
		pnl_personal:addChild(wgtclone)
	end
	
--倒计时
	local bt = msg.bt
	local et = msg.et
	local nt = msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function BuyLimitsActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function BuyLimitsActivity:_nil()
end