local proto = require'protocol'

local cVer = DlgClubDonate
DlgClubDonate = class('DlgClubDonate', LuaUI)
local super = DlgClubDonate.__super

function DlgClubDonate:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('club-donate.json', true) then return false end
	
	self:OutClickClose()
	self:addLuaHandler('btn_close', function() self:close() end)
	self:addLuaHandler('btn_rule', function ()
		LShowMessage(getString('CLUB_DONATE_HELP_TIPS'), nil, nil, MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	self:addLuaHandler('CheckBox_0', function()
		local bSelect = self:seekWidgetByName('CheckBox_0'):getSelectedState()
		if not bSelect then
			self:seekWidgetByName('CheckBox_1'):setSelectedState(bSelect)
			self:seekWidgetByName('CheckBox_2'):setSelectedState(bSelect)
		end
	end)
	
	self:addLuaHandler('CheckBox_1', function()
		local bSelect = self:seekWidgetByName('CheckBox_1'):getSelectedState()
		if not bSelect then
			self:seekWidgetByName('CheckBox_0'):setSelectedState(bSelect)
			self:seekWidgetByName('CheckBox_2'):setSelectedState(bSelect)
		end
	end)
	
	self:addLuaHandler('CheckBox_2', function()
		local bSelect = self:seekWidgetByName('CheckBox_2'):getSelectedState()
		if not bSelect then
			self:seekWidgetByName('CheckBox_0'):setSelectedState(bSelect)
			self:seekWidgetByName('CheckBox_1'):setSelectedState(bSelect)
		end
	end)
	
	self:addLuaHandler('btn_donate', function ()
		if self:seekWidgetByName('CheckBox_0'):getSelectedState() then value = 1 end
		if self:seekWidgetByName('CheckBox_1'):getSelectedState() then value = 2 end
		if self:seekWidgetByName('CheckBox_2'):getSelectedState() then value = 3 end
		
		if value == 0 then 
			LShowMessage(string.format(getString('CLUB_DONATE_TIPS')), nil, nil, MBT_OK)
		else
			g_SendMsg({ptype = 'club_donate', donateType = value})
		end
	end)
	
	return true
end

function DlgClubDonate:_nil()
end