local json = require'json'
require'uifunc'

CollectionActivity = class('CollectionActivity', LuaUI)
local super = CollectionActivity.__super

function CollectionActivity:init()

	if not super.init(self) then
		return false
	end
	
	if not self:initRootWidget('activity_collection.json', true) then
		return false
	end
	self:OutClickClose()
	self:addLuaHandler('btn_close', function ()
		self:close()
	end)
	
	self:addLuaHandler('btn_gzsm', function ()
		LShowMessage(getString('COLLECTION_TIP_EXP'), nil, nil,MBT_OK,self._nil,self._nil,self._nil)
	end)
	
	g_SendMsg({ptype = 'coll_act',})
		
	return true
end

function CollectionActivity:onEnter()
	self:regMsgHandler('coll_act', self.UpdateUI)
end

function CollectionActivity:UpdateUI(msg)
	
	local jsondata = msg.data
	local data = json.decode(jsondata)
	local isend = data.isend
	
	local listitem = self:seekWidgetByName('listitem')
	while (listitem:getItems():count() > 0) do
		listitem:removeLastItem()
	end	
	local widgetTemplate = LOADWIDGET("activity_collection_item.json")
	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()
		local indextag = 1
--------------------需求--------------------
		local isCando = true
		--金币
		if _item.need_money > 0 then 
			local image = UIHO:seekWidgetByName(wgtclone, string.format("img_item%d", indextag))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_itemname%d", indextag))
			if image ~= nil and lab_dec ~= nil then 
				local dec ,retValue = LoadAwardImageEx(0, _item.need_money, 0, image ,0);
				lab_dec:setText(dec)
				if retValue < _item.need_money then
					isCando = false
				end
			end
			indextag = indextag + 1
		end
		
		--钻石
		if _item.need_crystal > 0 then 
			local image = UIHO:seekWidgetByName(wgtclone, string.format("img_item%d", indextag))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_itemname%d", indextag))
			if image ~= nil and lab_dec ~= nil then 
				local dec ,retValue = LoadAwardImageEx(1, _item.need_crystal, 0, image ,0);
				lab_dec:setText(dec)
				if retValue < _item.need_crystal then
					isCando = false
				end
			end
			indextag = indextag + 1
		end
		--道具
		if string.len(_item.need_item_id) > 0 and string.len(_item.need_item_count) > 0 then 
			local item_id_tab = GetSplitTableByString(_item.need_item_id)
			local item_count_tab = GetSplitTableByString(_item.need_item_count)
			for index=1,table.getn(item_id_tab) do
				if item_id_tab[index] > 0 and item_count_tab[index] > 0 then
					local image = UIHO:seekWidgetByName(wgtclone, string.format("img_item%d", indextag))
					local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_itemname%d", indextag))
					if image ~= nil and lab_dec ~= nil then 
						local dec ,retValue = LoadAwardImageEx(2, item_id_tab[index], item_count_tab[index], image ,0);
						lab_dec:setText(dec)
						if retValue < item_count_tab[index] then
							isCando = false
						end
					end
					indextag = indextag + 1
				end
			end
		end
		if indextag <= 4 then
			for  j = indextag, 4 do
				local image = UIHO:seekWidgetByName(wgtclone, string.format("img_item%d", j))
				local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_itemname%d", j))
				image:setEnabled(false)
				lab_dec:setEnabled(false)
			end
		end
--------------------兑换--------------------
		indextag = 1
		--金币
		if _item.give_money > 0 then 
			local image = UIHO:seekWidgetByName(wgtclone, string.format("img_rewarditem%d", indextag))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_rewitem%d", indextag))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(0, _item.give_money, 0, image);
				lab_dec:setText(dec)
			end
			indextag = indextag + 1
		end
		--钻石
		if _item.give_crystal > 0 then 
			local image = UIHO:seekWidgetByName(wgtclone, string.format("img_rewarditem%d", indextag))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_rewitem%d", indextag))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(1, _item.give_crystal, 0, image);
				lab_dec:setText(dec)
			end
			indextag = indextag + 1
		end
		--道具
		if string.len(_item.give_item_id) > 0 and string.len(_item.give_item_count) > 0 then 
			local item_id_tab = GetSplitTableByString(_item.give_item_id)
			local item_count_tab = GetSplitTableByString(_item.give_item_count)
			for index=1,table.getn(item_id_tab) do
				if item_id_tab[index] > 0 and item_count_tab[index] > 0 then
					local image = UIHO:seekWidgetByName(wgtclone, string.format("img_rewarditem%d", indextag))
					local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_rewitem%d", indextag))
					if image ~= nil and lab_dec ~= nil then 
						local dec = LoadAwardImage(2, item_id_tab[index], item_count_tab[index], image);
						lab_dec:setText(dec)
					end
					indextag = indextag + 1
				end
			end
		end
		--装备
		if string.len(_item.give_equip_id) > 0 and string.len(_item.give_equip_lv) > 0 then 
			local euiqp_id_tab = GetSplitTableByString(_item.give_equip_id)
			local equip_lv_tab = GetSplitTableByString(_item.give_equip_lv)
			for index=1,table.getn(euiqp_id_tab) do
				if euiqp_id_tab[index] > 0 and equip_lv_tab[index] > 0 then
					local image = UIHO:seekWidgetByName(wgtclone, string.format("img_rewarditem%d", indextag))
					local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_rewitem%d", indextag))
					if image ~= nil and lab_dec ~= nil then 
						local dec = LoadAwardImage(2, euiqp_id_tab[index], equip_lv_tab[index], image);
						lab_dec:setText(dec)
					end
					indextag = indextag + 1
				end
			end
		end
		if indextag <= 2 then
			for  j = indextag, 2 do
				local image = UIHO:seekWidgetByName(wgtclone, string.format("img_rewarditem%d", j))
				local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format("txt_rewitem%d", j))
				image:setEnabled(false)
				lab_dec:setEnabled(false)
			end
		end
		local btn = UIHO:seekWidgetByName(wgtclone, "btn_gesj_lq")
		if btn ~= nil then
			
			self:addLuaHandler(btn, function ()
				g_SendMsg({
					ptype = 'coll_act',
					index = _item.id,
				})
			end)
			
			if isCando == true and isend ~= true then
				btn:loadTextureDisabled("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
				btn:loadTextureNormal("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
				btn:loadTexturePressed("btn_lqjl_1.png", UI_TEX_TYPE_PLIST)
				btn:setTouchEnabled(true)
			else
				btn:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
				btn:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
				btn:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
				btn:setTouchEnabled(false)
			end
		end
		listitem:pushBackCustomItem(wgtclone)
	end
	
--倒计时
	local bt = msg.bt
	local et = msg.et
	local nt = msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function CollectionActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function CollectionActivity:_nil()
end