local proto = require'protocol'
local tcast = tolua.cast

DlgGift = class('DlgGift', LuaUI)
local super = DlgGift.__super

function DlgGift:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('dialog-gift.json', true) then return false end
	
	self:addLuaHandler('btn_close', function() self:close() end)
	self:OutClickClose()
	
	g_SendMsg(proto.C2S_RequestAchievementList.new())
	
	return true
end

function DlgGift:onEnter()
	self:regCMsgHandler(proto.S2C_GAME_SERVER.eS2C_SyncAchievementAward, self.OnRecvSyncAchievementAward)
	self:regCMsgHandler(proto.S2C_GAME_SERVER.eS2C_SyncSAchievementItem, self.OnRecvSyncAchievementItem)
	
	return true
end

function DlgGift:OnRecvSyncAchievementAward(msg)
	local listView = self:seekWidgetByName("scv_list")
	for k = 0, listView:getItems():count() do
		local widget = listView:getItem(k)
		if widget ~= nil and widget:getTag() == msg.achievementId then
			listView:removeItem(k)
			break
		end
	end
end

function DlgGift:OnRecvSyncAchievementItem(msg)
	local listView = self:seekWidgetByName("scv_list")
	local widgetTemplate = LOADWIDGET("dialog-gift-item.json")

	for k = 1, #msg.achList do
		local it = msg.achList[k]
		local id = it.id
		local race = PLAYER_BASE_DATA.race
		local widget = widgetTemplate:clone()
		widget:setTag(id)

		local label1 = UIHO:seekWidgetByName(widget, "pnl_info1:txt")
		if label1 ~= nil then label1:setText(it.name) end
		local label2 = UIHO:seekWidgetByName(widget, "pnl_info2:txt")
		if label2 ~= nil then label2:setText(it.tip) end
		
		local iv = UIHO:seekWidgetByName(widget, "img_icon")
		iv:removeAllChildren()
		if it.iconid ~= 0 then
			iv:addChild(UIItemImageView:create(it.iconid))
		end

		local btnGet = UIHO:seekWidgetByName(widget, "btn_get")
		local lbl_notok = UIHO:seekWidgetByName(widget, "lbl_notok")
		if it.canget ~= 0 then
			btnGet:setTag(id)
			btnGet:setEnabled(true)
			btnGet:setVisible(true)
			lbl_notok:setVisible(false)
			self:addLuaHandler(btnGet, function(sender)
				local msg = proto.C2S_RequestAchievementAward.new()
				msg.id = id
				g_SendMsg(msg)
			end)
		else
			btnGet:setVisible(false)
			lbl_notok:setVisible(true)
		end

		listView:pushBackCustomItem(widget)
	end
end

function DlgGift:_nil()
end