local sfmt = string.format
local starCfg = require'config.star'

EquipCulture = class('EquipCulture', LuaUI)
local super = EquipCulture.__super

function EquipCulture:init(uid)
	if not super.init(self) then return false end
	if not self:initRootWidget('equip_culture.json', true) then return false end
	
	self:addLuaHandler('btn_help_', function ()
		LShowMessage(getString('EQUIP_CULTURE_HELP_TIP'), nil, nil,MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	local item = g_Player:GetItem(uid)
	if not item then return false end
	if item.m_randomPropertyCount == 0 then
		LShowMessage(TDGETSTRCS('SYNC_EQ_CAN_NOT_CULTURE'))
		return false
	end
	
	if item.m_starNum == 0 then
		self:seekWidgetByName('Label_119_0'):setVisible(false)
		self:seekWidgetByName('checkbox_max'):setEnabled(false)
		self:seekWidgetByName('leb_star'):setVisible(false)
		self:seekWidgetByName('Label_62'):setVisible(false)
		self:seekWidgetByName('leb_star1'):setVisible(false)
		self:seekWidgetByName('Label_119'):setVisible(false)
		self:seekWidgetByName('checkbox_star'):setEnabled(false)
	end
	self.uid = uid
	self:updateDetail()
	
	self:seekWidgetByName('Button_124'):setEnabled(false)
	self:seekWidgetByName('btn_canel'):setEnabled(false)
	
	local chkRand = self:seekWidgetByName('checkbox_max')
	local chkStar = self:seekWidgetByName('checkbox_star')
	self:addLuaHandler(chkRand, function ()
		chkStar:setEnabled(chkRand:getSelectedState())
	end)
	self:addLuaHandler(chkStar, function ()
		chkRand:setEnabled(chkStar:getSelectedState())
	end)
	self:addLuaHandler('btn_close', function () self:close() end)
	self:OutClickClose()
	
	self:addLuaHandler('btn_culturegold', function ()
		if self:isPropFull() then
			LShowMessage(TDGETSTRCS('SYNC_EQ_CULTURE_MAX'))
			return
		end
		g_SendMsg({ptype='eq_culture', uid = self.uid,
			money = true,
			rand = chkRand:getSelectedState(),
			star = chkStar:getSelectedState()})
	end)
	self:addLuaHandler('btn_culture', function ()
		if self:isPropFull() then
			LShowMessage(TDGETSTRCS('SYNC_EQ_CULTURE_MAX'))
			return
		end
		g_SendMsg({ptype='eq_culture', uid = self.uid,
			money = false,
			rand = chkRand:getSelectedState(),
			star = chkStar:getSelectedState()})
	end)
	self:addLuaHandler('Button_124', function ()
		g_SendMsg({ptype='eq_culture', uid = 0})
	end)
	self:addLuaHandler('btn_canel', function ()
		self:seekWidgetByName('Button_124'):setEnabled(false)
		self:seekWidgetByName('btn_canel'):setEnabled(false)
		self:seekWidgetByName('btn_culturegold'):setEnabled(true)
		self:seekWidgetByName('btn_culture'):setEnabled(true)
	end)
	self:regJMsgHandler('eq_culture', self.onRecvEquipCulture)
	g_SendMsg({ptype = 'eq_culture'})
	
	return true
end

function EquipCulture:onRecvEquipCulture(msg)
	if msg then
		self.freeCnt = msg.freeCnt
		self.moneyCnt = msg.moneyCnt
	end
	self:updateDetail(msg)
	if msg and msg.uniqueId ~= 0 then
		self:seekWidgetByName('Button_124'):setEnabled(true)
		self:seekWidgetByName('btn_canel'):setEnabled(true)
		self:seekWidgetByName('btn_culturegold'):setEnabled(false)
		self:seekWidgetByName('btn_culture'):setEnabled(false)
	else
		self:seekWidgetByName('Button_124'):setEnabled(false)
		self:seekWidgetByName('btn_canel'):setEnabled(false)
		self:seekWidgetByName('btn_culturegold'):setEnabled(true)
		self:seekWidgetByName('btn_culture'):setEnabled(true)
	end
end

function EquipCulture:updateDetail(prop)
	local item = g_Player:GetItem(self.uid)
	if not item then return end
	
	local cfg
	if item.m_starNum > 0 then
		cfg = starCfg[item.m_starNum]
	end
	
	-- 
	local propCnt, propSum, propNew = 0, 0, 0
	local newProp = prop and prop.propVal
	for k, v in ipairs(item.m_randomProperty) do
		-- ǰ
		if v == 0 then
			self:seekWidgetByName('lbl_'..k):setText('--')
		else
			propCnt = propCnt + 1
			propSum = propSum + v
			self:seekWidgetByName('lbl_'..k):setText(tostring(v))
		end
		-- 
		local lbl = self:seekWidgetByName('lbl_'..k..'_new')
		local newV = newProp and newProp[k]
		if not newV or newV == 0 then
			lbl:setText('--')
			lbl:setColor(ccc3(255, 255, 255))
		else
			propNew = propNew + newV
			local str, color
			if newV > v then
				str = sfmt('%u(+%d)', newV, newV - v)
				color = ccc3(0, 255, 0)
			elseif newV < v then
				str = sfmt('%u(-%d)', newV, v - newV)
				color = ccc3(255, 0, 0)
			else
				str = tostring(newV)
				color = ccc3(255, 255, 255)
			end
			lbl:setText(str)
			lbl:setColor(color)
		end
	end
	
	local lblCur = self:seekWidgetByName('leb_time')
	lblCur:setText(sfmt(TDGETSTRCS('SYNC_EQ_RAND_PROP_CUR'), propSum))
	local propMax = propCnt*3*item:GetConfig().level
	if cfg then propMax = math.floor(propMax * (1 + cfg.xilian_attr / 10000)) end
	local lblMax = self:seekWidgetByName('leb_max')
	lblMax:setText(sfmt(TDGETSTRCS('SYNC_EQ_RAND_PROP_MAX'), propMax))
	local str, color
	if propNew == 0 or propNew == propSum then
		str = '(0)'
		color = ccc3(255, 255, 255)
	elseif propNew > propSum then
		str = sfmt('(+%d)', propNew - propSum)
		color = ccc3(0, 255, 0)
	elseif propNew < propSum then
		str = sfmt('(-%d)', propSum - propNew)
		color = ccc3(255, 0, 0)
	else
	end
	local lblChg = self:seekWidgetByName('leb_change')
	lblChg:setText(str)
	lblChg:setColor(color)
	lblChg:setPositionX(lblCur:getRightInParent())
	
	if cfg then
		local lblCur = self:seekWidgetByName('leb_star')
		local strCur = buildStarAttrDesc(item.m_starAttrType, item.m_starAttrValue)
		lblCur:setText(sfmt(TDGETSTRCS('SYNC_EQ_STAR_PROP_CUR'), item.m_starNum, strCur))
		local lblMax = self:seekWidgetByName('leb_star1')
		local strMax = buildStarAttrDesc(item.m_starAttrType, cfg.attr[item.m_starAttrType][2])
		lblMax:setText(sfmt(TDGETSTRCS('SYNC_EQ_STAR_PROP_MAX'), item.m_starNum, strMax))
		local newVal, str, color = prop and prop.starVal
		if not newVal or newVal == 0 or newVal == item.m_starAttrValue then
			str = '(0)'
			color = ccc3(255, 255, 255)
		elseif newVal > item.m_starAttrValue then
			str = sfmt('(+%.2f%%)', (newVal - item.m_starAttrValue) / 100)
			color = ccc3(0, 255, 0)
		elseif newVal < item.m_starAttrValue then
			str = sfmt('(-%.2f%%)', (item.m_starAttrValue - newVal) / 100)
			color = ccc3(255, 0, 0)
		else
		end
		local lblChg = self:seekWidgetByName('Label_62')
		lblChg:setText(str)
		lblChg:setColor(color)
		lblChg:setPositionX(lblCur:getRightInParent())
	end
	local lblCost = self:seekWidgetByName('leb_cucost')
	if self.freeCnt and (self.freeCnt < 3) then
		self:seekWidgetByName('leb_free'):setText(SSFmt(TDGETSTRCS('SYNC_EQ_CULTURE_FT'), 3 - self.freeCnt))
		lblCost:setVisible(false)
	else
		self:seekWidgetByName('leb_free'):setText(' ')
		lblCost:setVisible(true)
		local cnt = math.min((self.moneyCnt or 0) + 1, 10)
		local costMoney = g_Player.baseData.level*1000*cnt*cnt/4
		lblCost:setText(SSFmt(TDGETSTRCS('SYNC_EQ_CULTURE_COST'), costMoney, 30))
	end
end

function EquipCulture:isPropFull()
	local item = g_Player:GetItem(self.uid)
	if not item then return false end
	
	local cfg = starCfg[item.m_starNum]
	if cfg and item.m_starAttrValue < cfg.attr[item.m_starAttrType][2] then
		return false
	end
	
	local propCnt, propSum = 0, 0
	for k, v in ipairs(item.m_randomProperty) do
		if v ~= 0 then
			propCnt = propCnt + 1
			propSum = propSum + v
		end
	end
	local propMax = propCnt*3*item:GetConfig().level
	if cfg then propMax = math.floor(propMax*(1 + cfg.xilian_attr/10000)) end
	if propSum < propMax then return false end
	
	return true
end
