local tcast = tolua.cast
local proto = require'protocol'
local itemCfg = require'config.item'
local starCfg = require'config.star'
local MakeItemDetail = require'makeitemdetail'

----------------------------------------------------------------
----------------------------------------------------------------
-- 传承界面
SQInheritEquip = class('SQInheritEquip', LuaUI)
local super = SQInheritEquip.__super

function SQInheritEquip:init(uid)
	if not super.init(self) then return false end
	if not self:initRootWidget('equip-chuancheng.json', true) then return false end
	self:seekWidgetByName('btn_help'):setTag(7)
	
	local item = g_Player:GetItem(uid)
	local equip = MAIN_PLAYER:GetItem(uid)
	if not item or (
		item:getColorIdx() < 5 and
		item.m_starNum == 0) then
		return false
	end
	
	self:updateDetail('item_img_0:item', equip)
	self:updateDetail('item_img_main:item', nil)
	self:updateAttrDesc()
	self:updateInheritCost()
	
	self:addLuaHandler('btn_close', function () self:close() end)
	self:addLuaHandler('btn_do', function ()
		local iiv1 = self:seekWidgetByName('item_img_0:itemView')
		if not iiv1 then return end
		local iiv2 = self:seekWidgetByName('item_img_main:itemView')
		if not iiv2 then return end
		local msg = proto.C2S_SQInheritEquip.new()
		msg.fromId = iiv1:GetUniqueId()
		msg.targetId = iiv2:GetUniqueId()
		g_SendMsg(msg)
	end)
	self:addLuaHandler('btn_help', function () end)
	self:addLuaHandler('item_img_0:item', function ()
		SelectEquipmentForInherit:Show(self:GetRootLayer(), 0, function (item)
			self:updateDetail('item_img_0:item', item)
			self:updateDetail('item_img_main:item', nil)
			self:updateAttrDesc()
			self:updateInheritCost()
		end)
	end)
	self:addLuaHandler('item_img_main:item', function ()
		local iiv = self:seekWidgetByName('item_img_0:itemView')
		if not iiv then return end
		SelectEquipmentForInherit:Show(self:GetRootLayer(), iiv:GetUniqueId(), function (item)
			self:updateDetail('item_img_main:item', item)
			self:updateAttrDesc()
			self:updateInheritCost()
		end)
	end)
	self:OutClickClose()
	
	return true
end

function SQInheritEquip:updateDetail(name, item)
	local iv = self:seekWidgetByName(name)
	iv:removeAllChildren()
	if not item then
		iv:setVisible(false)
		tcast(iv:getParent(), 'CCNodeRGBA'):setColor(ccc3(255, 255, 255))
	else
		iv:setVisible(true)
		local w = UIItemImageView:create(item, TLT_Null, PACKAGE_TYPE_BACKPACK)
		iv:addChild(w)
		tcast(iv:getParent(), 'CCNodeRGBA'):setColor(item:getColor())
	end
end

function SQInheritEquip:updateAttrDesc()
	local iiv = self:seekWidgetByName('item_img_0:itemView')
	if not iiv then
		self:seekWidgetByName('lbl_adv'):setVisible(false)
	else
		self:seekWidgetByName('lbl_adv'):setVisible(true)
		local equip = iiv:GetDummyItem()
		local iiv2 = self:seekWidgetByName('item_img_main:itemView')
		local equip2 = iiv2 and iiv2:GetDummyItem()
		local item = g_Player:GetItem(equip.uniqueId)
		local cfg = item:GetConfig()
		local desc = ''
		local sqLv = equip:GetSpecialLevel(0)
		local sqLv2 = equip2 and equip2:GetSpecialLevel(0) or 0
		if sqLv > 0 and sqLv2 == 0 then
			desc = desc..buildSqAttrDesc(cfg.equipType, sqLv)
		end
		local sq2Lv = equip:Get2SpecialLevel(0)
		local sq2Lv2 = equip2 and equip2:Get2SpecialLevel(0) or 0
		if sq2Lv > 0 and sq2Lv2 == 0 then
			desc = desc..buildSq2AttrDesc(cfg.equipType, sq2Lv)
		end
		local starNum = equip.m_starNum
		local starNum2 = equip2 and equip2.m_starNum or 0
		if starNum > 0 and starNum2 == 0 then
			desc = desc..buildStarAttrDesc(item.m_starAttrType, item.m_starAttrValue)
		end
		self:seekWidgetByName('lbl_adv'):setText(desc)
	end
end

function SQInheritEquip:updateInheritCost()
	local iiv1 = self:seekWidgetByName('item_img_0:itemView')
	local iiv2 = self:seekWidgetByName('item_img_main:itemView')
	if not iiv1 or not iiv2 then
		self:seekWidgetByName('lbl_coin'):setText(TDGETSTRCS('SD_InheritTips'))
		return
	end
	local equip1 = iiv1:GetDummyItem()
	local item1 = g_Player:GetItem(equip1.uniqueId)
	local equip2 = iiv2:GetDummyItem()
	local item2 = g_Player:GetItem(equip2.uniqueId)
	local lv1 = item1:GetConfig().level
	local lv2 = item2:GetConfig().level
	local money = 0
	if item1:getColorIdx() >= 5 and item2:getColorIdx() < 5 then
		local sqLv = equip1:GetSpecialLevel(0)
		if sqLv > 0 then
			money = money + g_Player.sqinherit*math.pow(2, sqLv)
			if lv2 > lv1 then
				money = money + (lv2-lv1)*g_Player.sqinherit
			end
		end
		local sq2Lv = equip1:Get2SpecialLevel(0)
		if sq2Lv > 0 then
			money = money + g_Player.sq2inherit*math.pow(2, sq2Lv)
			if lv2 > lv1 then
				money = money + (lv2-lv1)*g_Player.sq2inherit
			end
		end
	end
	if item1.m_starNum > 0 and item2.m_starNum == 0 then
		local starNum = equip1.m_starNum
		if starNum > 0 then
			money = money + g_Player.starinherit*math.pow(2, starNum)
			if lv2 > lv1 then
				money = money + (lv2-lv1)*g_Player.starinherit
			end
		end
	end
	self:seekWidgetByName('lbl_coin'):setText(SSFmt(TDGETSTRCS('SD_MONEY_NEED'), money, g_Player.baseData.money))
end

----------------------------------------------------------------
----------------------------------------------------------------
-- 选择界面
SelectEquipmentForInherit = class('SelectEquipmentForInherit', LuaUI)
local super = SelectEquipmentForInherit.__super

function SelectEquipmentForInherit:init(uid, cb)
	if not super.init(self) then return false end
	if not self:initRootWidget('bag-select.json', true) then return false end
	
	local children = self:seekWidgetByName('pnl_head'):getChildren()
	for k = 1, children:count() do
		local w = tcast(children:objectAtIndex(k), 'Widget')
		local iiv = UIHO:seekWidgetByName(w, 'itemView')
		if iiv ~= nil then 
			MakeItemDetail:ChangelScore(UIHO:seekWidgetByName(w, 'pnl_equip_props'), iiv:GetUniqueId())
		end
	end
	
	self:seekWidgetByName('btn_all'):setEnabled(false)
	self:seekWidgetByName('btn_white'):setEnabled(false)
	self:seekWidgetByName('btn_green'):setEnabled(false)
	self:seekWidgetByName('btn_blue'):setEnabled(false)
	self:seekWidgetByName('btn_purple'):setEnabled(false)
	self:seekWidgetByName('btn_orange'):setEnabled(false)
	
	local pnlHead = self:seekWidgetByName('pnl_head')
	local pnlBody = self:seekWidgetByName('pnl_body')
	local lv = self:seekWidgetByName('equip_list')
	pnlHead:setVisible(false)
	local sz = pnlHead:getSize()
	local sz1 = pnlBody:getSize()
	pnlBody:setSize(CCSizeMake(sz1.width, sz1.height + sz.height + 60))
	local sz2 = lv:getSize()
	lv:setSize(CCSizeMake(sz2.width, sz2.height + sz.height + 60))
	lv:setDirection(SCROLLVIEW_DIR_VERTICAL)
	lv:removeAllItems()
	
	local checkEquip
	if uid == 0 then
		checkEquip = function (equip)
			return equip:GetColor() >= 5 or
				equip.m_starNum > 0
		end
	else
		local equip = g_Player:GetItem(uid)
		if not equip then return false end
		if equip:GetColor() < 5 and
			equip.m_starNum == 0 then
			return false
		end
		local eqTp = equip:GetConfig().equipType
		
		-- 传承装备筛选规则：
		-- 神器、星星
		-- 源装备任意一条属性目标不存在即可传承
		local checkSq
		if equip:getColorIdx() >= 5 then
			checkSq = function (equip)
				return equip:getColorIdx() < 5
			end
		end
		local checkStar
		if equip.m_starNum > 0 then
			checkStar = function (equip)
				return equip.m_starNum == 0
			end
		end
		checkEquip = function (equip)
			if equip.uniqueId == uid then
				return false
			end
			if equip:GetConfig().equipType ~= eqTp then
				return false
			end
			if checkSq and checkSq(equip) then
				return true
			end
			if checkStar and checkStar(equip) then
				return true
			end
			return false
		end
	end
	local allChkBox = {}
	local function addEquip (k, equip)
		if not checkEquip(equip) then return end
		local item = MAIN_PLAYER:GetItem(k)
		local w = UIItemImageView:createDetail(item, TLT_InheritSelect, PACKAGE_TYPE_BACKPACK)
		local iiv = UIHO:seekWidgetByName(w, 'itemView')
		if iiv ~= nil then 
			MakeItemDetail:ChangelScore(UIHO:seekWidgetByName(w, 'pnl_equip_props'), iiv:GetUniqueId())
		end
		local c = UIHO:seekWidgetByName(w, 'chk_box')
		self:addLuaHandler(w, function ()
			if c:isEnabled() then
				local chk = not c:getSelectedState()
				c:setSelectedState(chk)
				for k, v in ipairs(allChkBox) do
					v:setEnabled(not chk or v == c)
				end
			end
		end)
		c:setTouchEnabled(false)
		lv:pushBackCustomItem(w)
		allChkBox[#allChkBox + 1] = c
	end
	-- 将角色身上、佣兵身上、角色背包中的装备全部筛出来
	for k, v in pairs(g_Player.inventory) do
		addEquip(k, v)
	end
	for k, v in pairs(g_Player.mercenaryEuqip) do
		addEquip(k, v)
	end
	for k, v in pairs(g_Player.backpack) do
		addEquip(k, v)
	end
	self:seekWidgetByName('lbl_message'):setVisible(#allChkBox == 0)
	
	self:addLuaHandler('btn_close', function () self:SelEquip() end)
	self:OutClickClose()
	
	self.cb = cb
	
	return true
end

function SelectEquipmentForInherit:SelEquip()
	local lv = self:seekWidgetByName('equip_list')
	local items = lv:getItems()
	for k = 1, items:count() do
		local pnl = tcast(items:objectAtIndex(k), 'Widget')
		local c = UIHO:seekWidgetByName(pnl, 'chk_box')
		if c:getSelectedState() then
			local iiv = UIHO:seekWidgetByName(pnl, 'item_img:itemView')
			self:close()
			self.cb(iiv:GetDummyItem())
			return
		end
	end
end