local proto = require'protocol'

local equipIcon = {
	'icon_txt2_zswq.png',
	'icon_txt2_fswq.png',
	'icon_txt2_tk.png',
	'icon_txt2_xj.png',
	'icon_txt2_ht.png',
	'icon_txt2_st.png',
	'icon_txt2_jz.png',
	'icon_txt2_xl.png',
	'icon_txt2_yd.png',
	'icon_txt2_xz.png',
}

ChangeGoodEquipment = class('ChangeGoodEquipment', LuaUI)
local super = ChangeGoodEquipment.__super

function ChangeGoodEquipment:init(uids)
	if not uids or #uids == 0 then return false end
	if not super.init(self) then return false end
	if not self:initRootWidget('equip-ronglian-haozb.json', true) then return false end
	
	local lv = self:seekWidgetByName('listzb')
	lv:removeAllItems()
	
	local w = LOADWIDGET('equip-ronglian-haozb-item.json')
	for k, v in ipairs(uids) do
		local item = MAIN_PLAYER:GetItem(v)
		local equip = g_Player:GetItem(v)
		if not item then return false end
		local cfg = equip:GetConfig()
		if not cfg then return false end
		
		local iiv = UIItemImageView:create(item)
		local widget = w:clone()
		local iv = UIHO:seekWidgetByName(widget, 'item_img')
		iv:removeAllChildren()
		iv:addChild(iiv)
		
		local propPanel = UIHO:seekWidgetByName(widget, 'pnl_equip_props')
		local itemType = UIHO:seekWidgetByName(widget, 'img_type')
		local itemBoarder = UIHO:seekWidgetByName(widget, 'item_img')
		local equipInfo = ''
		if item:GetEnhancedLevel() ~= 0 then
			equipInfo = equipInfo..SSFmt('<c=ffcc88><s=30>Lv%u %s+%u</></>\n', cfg.level, item:getColorName(), item:GetEnhancedLevel())
		else
			equipInfo = equipInfo..SSFmt('<c=ffcc88><s=30>Lv%u %s</></>\n', cfg.level, item:getColorName())
		end
		equipInfo = equipInfo..SSFmt('<c=ff00ff><s=20>%s%u</></>\n', TDGETSTRCS('SD_EQUIP_SCORE'), item:GetScore())
		propPanel:removeAllChildren()
		
		local panelSize = propPanel:getSize()
		local srt = UIStaticRichText:createWithString(equipInfo, panelSize.width, 5)
		srt:setPosition(ccp(4 + srt:getSize().width / 2, panelSize.height - srt:getSize().height / 2 - 5))
		propPanel:addChild(srt)
		
		if cfg.equipType >= 0 and cfg.equipType < EQUIPMENT_TYPE_MAX_SIZE then
			itemType:loadTexture(equipIcon[cfg.equipType+1], UI_TEX_TYPE_PLIST)
		end
		lv:pushBackCustomItem(widget)
	end
	
	self:addLuaHandler('btn_dazao', function ()
		local msg = proto.C2S_PutOnEquipment.new()
		for k, v in ipairs(uids) do
			msg.uniqueId = v
			msg.isForce = true
			msg.isRight = false
			g_SendMsg(msg)
		end
		self:close()
	end)
	self:addLuaHandler('btn_refresh', function () self:close() end)
	self:OutClickClose()
	
	return true
end