local proto = require'protocol'

RemakeBatchEquip = class('RemakeBatchEquip', LuaUI)
local super = RemakeBatchEquip.__super

function RemakeBatchEquip:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('equip-ronglian-batch.json', true) then return false end
	
	self:OutClickClose()
	self:addLuaHandler('btn_close', function() self:close() end)
	
	self:addLuaHandler('CheckBox_all', function(s, e)
		local bSelect = not self:seekWidgetByName('CheckBox_all'):getSelectedState()
		self:seekWidgetByName('CheckBox_0'):setSelectedState(bSelect)
		self:seekWidgetByName('CheckBox_1'):setSelectedState(bSelect)
		self:seekWidgetByName('CheckBox_2'):setSelectedState(bSelect)
		self:seekWidgetByName('CheckBox_3'):setSelectedState(bSelect)
		self:seekWidgetByName('CheckBox_4'):setSelectedState(bSelect)
	end)
	
	self:addLuaHandler('btn_ronglian', function ()
		local value = 0
		if self:seekWidgetByName('CheckBox_all'):getSelectedState() then
			value = 31
		else
			if self:seekWidgetByName('CheckBox_0'):getSelectedState() then value = value + 1 end
			if self:seekWidgetByName('CheckBox_1'):getSelectedState() then value = value + 2 end
			if self:seekWidgetByName('CheckBox_2'):getSelectedState() then value = value + 4 end
			if self:seekWidgetByName('CheckBox_3'):getSelectedState() then value = value + 8 end
			if self:seekWidgetByName('CheckBox_4'):getSelectedState() then value = value + 16 end
		end
		
		if value == 0 then 
			LShowMessage(string.format(getString('EQUIP_REMAKE_BATCH_TIPS')), nil, nil, MBT_OK)
		else
			g_SendMsg({ptype = 'remake_batch', color = value})
			self:close()
		end
	end)
	
	return true
end

function RemakeBatchEquip:_nil()
end