DlgFactionLeague = class('DlgFactionLeague', LuaUI)
local super = DlgFactionLeague.__super

function DlgFactionLeague:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('faction_bigwar.json', true) then return false end
	
	self:addLuaHandler('btn_help', function () end)
	self:OutClickClose()
	self:addLuaHandler('btn_close', function ()
		self:close()
	end)
	g_SendMsg({ptype = 'fb_league'})
	
	return true
end

function DlgFactionLeague:onEnter()
	self:regJMsgHandler('fb_league', self.OnRecvFBLeague)
end

function DlgFactionLeague:OnRecvFBLeague(msg)
	local king = msg.king ~= '' and msg.king or getString('SD02_FACTION_LEAGUE_NONE')
	king = string.format(getString('SD02_FACTION_LEAGUE_KING'), king)
	self:seekWidgetByName('txt_bigwarname'):setText(king)
	
	local fight
	if #msg.league ~= 0 then
		fight = getString('SD02_FACTION_LEAGUE_TIME_'..(#msg.league))
	else
		fight = getString('SD02_FACTION_LEAGUE_NOT_OPEN')
	end
	self:seekWidgetByName('txt_startime'):setText(fight)
	
	local listResult = self:seekWidgetByName('list1')
	for _, v in pairs(msg.result) do
		local txt = getString('SD02_FACTION_LEAGUE_RESULT_'..#v.matches)
		local label = UIStaticRichText:createWithString(txt);
		listResult:pushBackCustomItem(label);
		for _, record in pairs(v.matches) do
			local txt = string.format("%s VS %s", record.winnerName, record.loserName)
			local label = UIStaticRichText:createWithString(txt);
			listResult:pushBackCustomItem(label);
		end
	end
	
	local listLeague = self:seekWidgetByName('list2')
	for k = 1, #msg.league, 2 do
		local txt = string.format("%s VS %s", msg.league[k], msg.league[k+1])
		local label = UIStaticRichText:createWithString(txt);
		listLeague:pushBackCustomItem(label);
	end
end