LotteryActivity = class('LotteryActivity', LuaUI)
local super = LotteryActivity.__super

local g_lotteryLv = 0
local g_LotteryActivityTips = ""
function LotteryActivity:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('activity_lottery.json', true) then return false end
	
	self:OutClickClose()
	self:addLuaHandler('btn_close', function () self:close() end)
	
	self:addLuaHandler('btn_one', function () g_SendMsg({ptype = 'lo_act', getlv = g_lotteryLv, gettype = 1}) end)
	self:addLuaHandler('btn_ten', function () g_SendMsg({ptype = 'lo_act', getlv = g_lotteryLv, gettype = 2}) end)
	
	self:addLuaHandler('btn_htbox', function ()
		g_lotteryLv = 1
		self:onChangeBtnStatus(1)
		g_SendMsg({ptype = 'lo_act', getlv = 1}) 
	end)
	self:addLuaHandler('btn_mybox', function () 
		g_lotteryLv = 2
		self:onChangeBtnStatus(2)
		g_SendMsg({ptype = 'lo_act', getlv = 2}) 
	end)
	self:addLuaHandler('btn_hjbox', function () 
		g_lotteryLv = 3
		self:onChangeBtnStatus(3)
		g_SendMsg({ptype = 'lo_act', getlv = 3}) 
	end)
	
	self:addLuaHandler('btn_rule', function ()
		LShowMessage(g_LotteryActivityTips, nil, nil, MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	g_SendMsg({ptype = 'lo_act_info'})
	g_SendMsg({ptype = 'lo_act', getlv = 1})
	
	g_lotteryLv = 1
	
	return true
end

function LotteryActivity:onChangeBtnStatus(lv)
	if lv == 1 then
		self:seekWidgetByName('btn_htbox'):setTouchEnabled(false)
		self:seekWidgetByName('btn_mybox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_hjbox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_htbox:img_lock'):setVisible(true)
		self:seekWidgetByName('btn_mybox:img_lock'):setVisible(false)
		self:seekWidgetByName('btn_hjbox:img_lock'):setVisible(false)
	elseif lv == 2 then
		self:seekWidgetByName('btn_htbox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_mybox'):setTouchEnabled(false)
		self:seekWidgetByName('btn_hjbox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_htbox:img_lock'):setVisible(false)
		self:seekWidgetByName('btn_mybox:img_lock'):setVisible(true)
		self:seekWidgetByName('btn_hjbox:img_lock'):setVisible(false)
	elseif lv == 3 then
		self:seekWidgetByName('btn_htbox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_mybox'):setTouchEnabled(true)
		self:seekWidgetByName('btn_hjbox'):setTouchEnabled(false)
		self:seekWidgetByName('btn_htbox:img_lock'):setVisible(false)
		self:seekWidgetByName('btn_mybox:img_lock'):setVisible(false)
		self:seekWidgetByName('btn_hjbox:img_lock'):setVisible(true)
	end
end

function LotteryActivity:onEnter()
	self:regMsgHandler('lo_act_info', self.UpdateInfo)
	self:regMsgHandler('lo_act', self.UpdateUI)
end

function LotteryActivity:UpdateInfo(msg)
	local bt = msg.bt
	local et = msg.et
	local nt = msg.nt
	
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

function LotteryActivity:UpdateUI(msg)
	local _type = msg.type
	local one = msg.one
	local ten = msg.ten
	g_LotteryActivityTips = msg.utip
	
	self:seekWidgetByName('img_boxleft'):loadTexture('img_box'.._type..'.png', UI_TEX_TYPE_PLIST)
	self:seekWidgetByName('img_boxright'):loadTexture('img_box'.._type..'.png', UI_TEX_TYPE_PLIST)
	
	local txtone = self:seekWidgetByName('leb_one')
	txtone:setText(string.format(getString('LOTTERY_ACTIVITY_NEED'),one))
	
	local txtten = self:seekWidgetByName('leb_ten')
	txtten:setText(string.format(getString('LOTTERY_ACTIVITY_NEED'),ten))
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function LotteryActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function LotteryActivity:_nil()
end