local type = type

g_LuaUI = g_LuaUI or {}
local allLuaUI = g_LuaUI

function IsLuaUIShow(name)
	for ui in pairs(allLuaUI) do
		if ui.__cname == name then
			return true
		end
	end
	return false
end

function GetLuaUI(name)
	for ui in pairs(allLuaUI) do
		if ui.__cname == name then
			return ui
		end
	end
end

function ShowActivity(name)
	local cls = _G[name]
	if type(cls) ~= 'table' or
		not isclass(cls, 'LuaUI') then
		return
	end
	cls:Show(LayerRoot:sharedLayerRoot(), name)
end

local function _create_UI_()
	return UIPopupLayer:create()
end

LuaUI = class('LuaUI', _create_UI_)

function LuaUI:init()
	self:registerScriptHandler(function (event)
		if event == 'enter' then
			allLuaUI[self] = true
			g_Player:regItemSyncHandler(self, self.OnItemUpdate)
			g_Player:regPropSyncHandler(self, self.OnPropUpdate)
			g_Player:regRuneItemSyncHandler(self, self.OnRuneItemUpdate)
			self:onEnter()
		elseif event == 'exit' then
			self:onExit()
			g_Player:unregItemSyncHandler(self)
			g_Player:unregPropSyncHandler(self)
			g_Player:unregRuneItemSyncHandler(self)
			self:unregAllMsgHandler()
			self:unregAllJMsgHandler()
			self:unregAllCMsgHandler()
			allLuaUI[self] = nil
		elseif event == 'enterTransitionFinish' then
			self:onEnterDidFinish()
		elseif event == 'exitTransitionStart' then
			self:onExitDidStart()
		end
	end)
	return true
end

function LuaUI:onEnter()
end
function LuaUI:onExit()
end
function LuaUI:onEnterDidFinish()
end
function LuaUI:onExitDidStart()
end

function LuaUI:regMsgHandler(proto, f)
	regMsgHandler(proto, self, f)
end

function LuaUI:unregAllMsgHandler()
	unregAllMsgHandler(self)
end

function LuaUI:regJMsgHandler(proto, f)
	regJMsgHandler(proto, self, f)
end

function LuaUI:unregAllJMsgHandler()
	unregAllJMsgHandler(self)
end

function LuaUI:regCMsgHandler(proto, f)
	regCMsgHandler(proto, self, f)
end

function LuaUI:unregAllCMsgHandler()
	unregAllCMsgHandler(self)
end

function LuaUI:OnItemUpdate()
end
function LuaUI:OnPropUpdate()
end
function LuaUI:OnRuneItemUpdate()	
end
function LuaUI:Show(layer, ...)
	local popup = self.new()
	if not popup:init(...) then return end
	popup:doModle(layer)
end