local itemConfig = require'config.item'
local json = require'json'
require'uifunc'

LuckyTurnplateActivity = class('LuckyTurnplateActivity', LuaUI)
local super = LuckyTurnplateActivity.__super

local g_runAction = false
local g_ProgressiveDiamond = 0	--奖池总额
local g_nowDiamond = 0	--下一次需要的钻石
local g_nowPoint = 0	--当前的指针角度
local g_nowLight = 0	--当前的选中标识角度
local g_point = {0, 35, 72, 106, 144, 180, 216, 254, 288, 323} 	--指针角度
local g_light = {0, 36, 72, 108, 144, 180, 216, 252, 288, 324} 	--选中标识角度
-- local g_showAction = true


local colorStr = {'888888', '88ff88', '8888ff', 'ff88ff', 'ff8800', 'ff0000'}
local function getColorName(id, color)
	local cfg = itemConfig[id]
	if not cfg then return 'null' end
	
	if cfg.itemClass ~= ITEM_CLASS_EQUIPMENT then
		return SSFmt(TDGETSTRCS("SD02_MAIL_AWARD_ITEM"), cfg.name, color)
	end
	
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then color = 8 end
	
	local nameEx = ''
	if star > 0 then
		nameEx = nameEx..SSFmt(TDGETSTRCS('EQUIP_STAR_NAME'), star)
	end
	if color >= 6 and color <= 8 then
		nameEx = nameEx..TDGETSTRCS('EQUIP_SQ_NAME_'..color)
	end
	if nameEx ~= '' then nameEx = '['..nameEx..']' end
	
	if color > 6 then color = 6 end
	return SSFmt('<c=%s>%s%s</>', colorStr[color], cfg.name, nameEx)
end

local function getColor(color)
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then return 8 end
	
	if color >= 6 and color <= 8 then return color end
	
	return color
end

function LuckyTurnplateActivity:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('activity_luckdraw.json', true) then return false end
	
	self:OutClickClose()
	
	self:addLuaHandler('btn_close', function ()
		self:close()
	end)
	
	self:addLuaHandler('btn_rlue', function ()
		LShowMessage(getString('LUKCY_TURNPLATE_ACTIVITY_TIP'), nil, nil,MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	local btn_draw = self:seekWidgetByName('btn_draw')
	if btn_draw ~= nil then btn_draw:setTouchEnabled(true) end
	
	local img_select = self:seekWidgetByName('img_select')
	if img_select ~= nil then img_select:setVisible(false) end
	
	local actions = CCArray:create()
	actions:addObject(CPRotateTo:create(0, 0))
	local img_pointer = self:seekWidgetByName('img_pointer')
	img_pointer:runAction(CPSequence:create(actions))
	g_nowPoint = 0
	
	g_runAction = false
	self:addLuaHandler('btn_draw', function ()
		if g_runAction then return end
		
		local _btn_draw = self:seekWidgetByName('btn_draw')
		if _btn_draw ~= nil then _btn_draw:setTouchEnabled(false) end
		
		local checkbox = self:seekWidgetByName('checkbox')
		g_SendMsg({
			ptype = 'luckyturnplateaward',
			isshow = checkbox:getSelectedState() == false and 0 or 1,
		})
		
		g_runAction = true
		
		local img_select = self:seekWidgetByName('img_select')
		if img_select ~= nil then img_select:setVisible(false) end
	end)
	
	self:addLuaHandler('btn_charge', function ()
		local layer = self:GetRootLayer()
		self:close()
		Charge:Show(layer)
	end)
	
	g_SendMsg({
		ptype = 'luckyturnplatetime',
	})
	
	g_SendMsg({
		ptype = 'luckyturnplate',
	})
	
	return true
end

function LuckyTurnplateActivity:onEnter()
	self:regJMsgHandler('luckyturnplate_action', self.onFlash)
	self:regJMsgHandler('luckyturnplate_time', self.ActivityTime)
	self:regJMsgHandler('luckyturnplate_activity', self.UpdateUI)
	self:regJMsgHandler('luckyturnplate_diamond', self.UpdateDiamond)
end

function LuckyTurnplateActivity:UpdateDiamond(msg)
	g_ProgressiveDiamond = msg.progressivediamond
	g_nowDiamond = msg.nowdiamond
	
	local lbl_needgold = self:seekWidgetByName('lbl_needgold')
	if lbl_needgold ~= nil then 
		--lbl_needgold:setText(string.format(getString('MERC_CRIS_TXT1'), g_nowDiamond))
		lbl_needgold:setText(string.format('%s%u',getString('MERC_CRIS_TXT'), g_nowDiamond))
	end
	
	local lbl_needfree = self:seekWidgetByName('lbl_needfree')
	if lbl_needfree ~= nil then
		if g_nowDiamond == 0 then 
			lbl_needfree:setVisible(true) 
		else
			lbl_needfree:setVisible(false) 
		end
	end
	
	local lbl_gold = self:seekWidgetByName('lbl_gold')
	if lbl_gold ~= nil then 
		lbl_gold:setText(string.format('%d', g_ProgressiveDiamond))
	end
	
	local label = UIHO:seekWidgetByName(self, "lbm_zuanshi")
	if label ~= nil then
		label:setText(SSFmt("%u", msg.playerdiamonds))
	end
end

function LuckyTurnplateActivity:onFlash(msg)
	local index = msg.index
	if index == -1 then
		local img_selectex = self:seekWidgetByName('img_select')
		if img_selectex ~= nil then 
			g_runAction = false
			img_selectex:setVisible(true)
			LShowMessage(getString('LUKCY_TURNPLATE_ACTIVITY_BAG_FULL'), nil, nil,MBT_OK, self._nil, self._nil, self._nil)
			
			local _btn_draw = self:seekWidgetByName('btn_draw')
			if _btn_draw ~= nil then _btn_draw:setTouchEnabled(true) end
			return
		end
	elseif index == -2 then
		local img_selectex = self:seekWidgetByName('img_select')
		if img_selectex ~= nil then
			g_runAction = false
			img_selectex:setVisible(true)
			
			local _btn_draw = self:seekWidgetByName('btn_draw')
			if _btn_draw ~= nil then _btn_draw:setTouchEnabled(true) end
			return
		end
	end
	
	local tipinfo = nil
	local cfg = itemConfig[msg.itemid]
	if msg.type == 1 then 
		--tipinfo = string.format('%s%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format(getString('MERC_GOLD_TXT1'), msg.total * msg.times))
	    tipinfo = string.format('%s%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format('%s%u',getString('MERC_GOLD_TXT'), msg.total * msg.times))
	elseif msg.type == 2 then
		--tipinfo = string.format('%s%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format(getString('MERC_CRIS_TXT1'), msg.total * msg.times))
		tipinfo = string.format('%s%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format('%s%u',getString('MERC_CRIS_TXT'), msg.total * msg.times))
	elseif msg.type == 3 and cfg ~= nil then 
		tipinfo = string.format('%s%s:%d', getString('LUKCY_TURNPLATE_ACTIVITY'), cfg.name, msg.total * msg.times)
	elseif msg.type == 4 and cfg ~= nil then 
		tipinfo = string.format('%s%s:%d', getString('LUKCY_TURNPLATE_ACTIVITY'), getColorName(cfg.itemId, msg.value), msg.total * msg.times)
	elseif msg.type == 5 then 
		tipinfo = string.format('%s%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format(getString('TEN_TIMES_FREE'), msg.total * msg.times))
	elseif msg.type == 6 then
		tipinfo = string.format('%s:%s', getString('LUKCY_TURNPLATE_ACTIVITY'), string.format(getString('DOUBLE_TIMES'), msg.times))
	end
	
	local actionTime = 0.03
	local actions = CCArray:create()
	local checkbox = self:seekWidgetByName('checkbox')
	local img_pointer = self:seekWidgetByName('img_pointer')
	if checkbox:getSelectedState() == false then 
		actions:addObject(CPRotateBy:create(0.5, 180))
		actions:addObject(CPRotateBy:create(0.5, 360 + g_point[index] - g_nowPoint))
		actions:addObject(CPRotateBy:create(0.5, 360*2))
		actions:addObject(CPRotateBy:create(0.5, 540))
		actions:addObject(CPRotateBy:create(0.5, 200))
		actions:addObject(CPRotateBy:create(0.5, 100))
		actions:addObject(CPRotateBy:create(0.3, 60))
		
		img_pointer:setVisible(true)
		
		actionTime = 3.4
	else
		actions:addObject(CPRotateBy:create(0, g_point[index] - g_nowPoint))
		img_pointer:setVisible(false)
	end
	
	img_pointer:runAction(CPSequence:create(actions))
	
	local actionsex = CCArray:create()
	actionsex:addObject(CPRotateTo:create(0, 0))
	actionsex:addObject(CPRotateBy:create(0.01, g_light[index]))
	
	local img_select = self:seekWidgetByName('img_select')
	img_select:runAction(CPSequence:create(actionsex))
	
	performWithDelay(self, function ()
		g_runAction = false
		
		img_pointer:setVisible(true)
		img_select:setVisible(true)
		
		local _btn_draw = self:seekWidgetByName('btn_draw')
		if _btn_draw ~= nil then _btn_draw:setTouchEnabled(true) end
		
		if tipinfo ~= nil then LShowMessage(tipinfo, nil, nil, MBT_OK, self._nil, self._nil, self._nil) end
		
		g_nowPoint = g_point[index]
	end, actionTime)
end

function LuckyTurnplateActivity:UpdateUI(data)
	local lbl_needgold = self:seekWidgetByName('lbl_needgold')
	--if lbl_needgold ~= nil then lbl_needgold:setText(string.format(getString('MERC_CRIS_TXT1'), g_nowDiamond)) end
	if lbl_needgold ~= nil then lbl_needgold:setText(string.format('%s%u',getString('MERC_CRIS_TXT'), g_nowDiamond)) end
	
	local lbl_needfree = self:seekWidgetByName('lbl_needfree')
	if lbl_needfree ~= nil then
		if g_nowDiamond == 0 then 
			lbl_needfree:setVisible(true) 
		else
			lbl_needfree:setVisible(false) 
		end
	end
	
	local i = 1
	for k,_item in ipairs(data.items) do
		local idx =_item.index 		--所在索引
		local itype = _item.type
		local itemid = _item.itemid
		local total = _item.total
		local value = _item.value	--星级与颜色
		
		local cfg = itemConfig[itemid]
		if cfg ~= nil then
			local img = self:seekWidgetByName(string.format('ImgItem_%d:itemImg', i))
			if img ~= nil then
				img:removeAllChildren()
				img:removeAllNodes()
				
				if itype == 4 then self:AddEffect(img, value) end
				
				img:loadTexture(cfg.texture, UI_TEX_TYPE_PLIST)
				img:setScale(0.65)
			end
		else
			local img = self:seekWidgetByName(string.format('ImgItem_%d:itemImg', i))
			if img ~= nil then
				img:removeAllChildren()
				img:removeAllNodes()
				
				if itype == 1 then
					local nNum = total / 10000
					local label = UIStaticRichText:createWithString(string.format(getString('LUKCY_TURNPLATE_TEXT5'), nNum), img:getSize().width*2, 3)
					label:setScale(0.75)
					img:addChild(label, 995, 9527)
					img:loadTexture('img_bg_money2.png', UI_TEX_TYPE_PLIST)
					img:setScale(1.1)
				elseif itype == 2 then 
					local nNum = total * 100 / 10000
					local label = UIStaticRichText:createWithString(string.format('%d％', nNum), img:getSize().width*2, 3)
					img:addChild(label, 995, 9527)
					img:loadTexture('img_bg_zs.png', UI_TEX_TYPE_PLIST)
					img:setScale(0.9)
				elseif itype == 5 then 
					img:loadTexture('mianfei.jpg', UI_TEX_TYPE_PLIST)
					img:setScale(0.9)
				elseif itype == 6 then
					img:loadTexture('shuangbei.jpg', UI_TEX_TYPE_PLIST)
					img:setScale(0.9)
				else
					img:loadTexture('img_bg_zs.png', UI_TEX_TYPE_PLIST)
					img:setScale(0.9)
				end
			end
		end
		
		i =i+1
	end
end

function LuckyTurnplateActivity:AddEffect(img, value)
	local star = math.floor(value / 100)
	AddStarLevel(img, star, 997, -9874)
	
	local itemcolor = getColor(value)
	if itemcolor == 6 then
		local spr = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr, 998, -9875)
	elseif itemcolor == 7 then
		local spr = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr, 999, -9876)
	elseif itemcolor == 8 then
		local spr1 = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr1, 998, -9875)
		local spr2 = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr2, 999, -9876)
	end
end

function LuckyTurnplateActivity:ActivityTime(data)
	--倒计时
	local bt = data.bt
	local et = data.et
	local nt = data.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function LuckyTurnplateActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function LuckyTurnplateActivity:_nil()
end