local util = require'util'

MainAward = class('MainAward', LuaUI)
local super = MainAward.__super

function MainAward:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('activity_reward.json', true) then return false end
	
	self:addLuaHandler('btn_close', function() self:close() g_SendMsg({ptype='new_list', showActivity=false}) end)
	
	local btn_sign = UIHO:seekWidgetByName(self, 'img_sign:btn_goto')
	self:addLuaHandler(btn_sign, function ()
		util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_sign:img_icon'), false)
		SignActivity:Show(self:GetRootLayer())
	end)
	
	local btn_gift = UIHO:seekWidgetByName(self, 'img_gift:btn_goto')
	self:addLuaHandler(btn_gift, function ()
		util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_gift:img_icon'), false)
		DlgGift:Show(self:GetRootLayer())
	end)
	
	local btn_vipdaily = UIHO:seekWidgetByName(self, 'img_vipdaily:btn_goto')
	self:addLuaHandler(btn_vipdaily, function ()
		util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_vipdaily:img_icon'), false)
		VipDialogGift:Show(self:GetRootLayer())
	end)
	
	local btn_daily = UIHO:seekWidgetByName(self, 'img_daily:btn_goto')
	self:addLuaHandler(btn_daily, function ()
		util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_daily:img_icon'), false)
		DailyTask:Show(self:GetRootLayer())
	end)
	
	self:addLuaHandler('btn_cdk', function ()
		DlgCDKey:Show(self:GetRootLayer())
	end)
	
	g_SendMsg({ptype='new_list', showActivity=false})
	
	return true
end

function MainAward:onEnter()
	self:regJMsgHandler('new_list', self.onRecvNewList)
	self:regJMsgHandler('showCDkey', self.OnDelete)
end

function MainAward:onRecvNewList(list)
	local tmp = {}
	for k, v in ipairs(list) do tmp[v] = true end
	util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_sign:img_icon'), tmp['sign'], 0, 0.2)
	util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_gift:img_icon'), tmp['gift'], 0, 0.2)
	util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_vipdaily:img_icon'), tmp['vipdaily'], 0, 0.2)
	util.UpdateNotify(UIHO:seekWidgetByName(self, 'img_daily:img_icon'), tmp['daily'], 0, 0.2)
end

function MainAward:OnDelete(msg)
	local w = self:seekWidgetByName('btn_cdk')
	if w ~= nil then
		w:setVisible(true)
		w:setEnabled(true)
	end
	return true
end

function MainAward:_nil()
end