local json = require'json'
require'uifunc'
local tcast = tolua.cast
newbilitylist = class('newbilitylist', LuaUI)
local super = newbilitylist.__super

local m_oldid = 0
local m_newid = 0
function newbilitylist:init()

	if not super.init(self) then
		return false
	end
	
	if not self:initRootWidget('newbility.json', true) then
		return false
	end
	--self:OutClickClose()
	self:addLuaHandler('btnClose', function ()
		if m_oldid ~= m_newid then
			g_SendMsg({ptype = 'newbility',data = m_newid})
		end
		
		self:close()
	end)
	
	self:regJMsgHandler('newbilitylist', self.UpdateUI)  
	g_SendMsg({ptype = 'newbilitylist',})
	
	m_oldid = 0
	m_newid = 0
	return true
end

function newbilitylist:onEnter()
	--self:regJMsgHandler('newbilitylist', self.UpdateUI)
--	self:regMsgHandler('newbilitylist', self.UpdateUI)
end

local comebackWords = {
	{[1] = "u003c",[2] = "<"},
	{[1] = "u003e",[2] = ">"},
}
function reComeback( text )
    if #text <= 0  then
        return text
    end
	
	for k,_item in ipairs(comebackWords) do
		text = string.gsub( text, _item[1], _item[2] )
	end
	
    return text
end


local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.ceil(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end


function newbilitylist:OnClickChkBox(chkBox, id)
	if chkBox:getSelectedState() then
		m_newid = 0
	else
		m_newid = chkBox:getTag()
	end
	local lv = self:seekWidgetByName('pvp_list')
	local items = lv:getItems()
	for k = 1, items:count() do
		local w = tcast(items:objectAtIndex(k), 'Widget')
		local curTag = w:getTag()
		local _cBox = UIHO:seekWidgetByName(w, 'checkbox')
		if chkBox ~= _cBox then
			
			if m_newid == _cBox:getTag() then
				_cBox:setSelectedState(true)
			else
				_cBox:setSelectedState(false)
			end
		end
	end
	-- print("m_newid = "..m_newid)
end

function newbilitylist:UpdateUI(msg)
	
	local data = msg

	m_oldid = data.curid
	m_newid = m_oldid;
	
	local listitem = self:seekWidgetByName('pvp_list')
	while (listitem:getItems():count() > 0) do
		listitem:removeLastItem()
	end	
	local widgetTemplate = LOADWIDGET("newbility_item.json")
	
	local yesArray = CCArray:create()
	local noArray = CCArray:create()

	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()
		local indextag = 1
		--id
		local id = _item.id
		wgtclone:setTag(id);
		--是否排第一
		local topItem = false
		if id == m_oldid then
			topItem = true
		end
		--是否达成
		local canuse = _item.canuse
		--名称富文本
		local srt_name = UIStaticRichText:createWithString(reComeback(_item.name))
		srt_name:setAnchorPoint(ccp(0.5, 0.5))
		srt_name:setPosition(ccp(80, 100))
		wgtclone:addChild(srt_name, 999, 9527)
		--说明富文本
		local srt_des = UIStaticRichText:createWithString(reComeback(_item.tip))
		srt_des:setAnchorPoint(ccp(0.5, 0.5))
		srt_des:setPosition(ccp(250, 50))
		wgtclone:addChild(srt_des, 999, 9528)
		--是否达成
		local imgwdc = UIHO:seekWidgetByName(wgtclone, "imgwdc")
		imgwdc:setEnabled(not canuse);
		--选择框
		local checkbox = UIHO:seekWidgetByName(wgtclone, "checkbox")
		checkbox:setEnabled(canuse);
		checkbox:setTouchEnabled(canuse);
		checkbox:setSelectedState(topItem);
		checkbox:setTag(id);
		if canuse then
			self:addLuaHandler(checkbox, function ()
				self:OnClickChkBox(checkbox, id)
			end)
		end
		--倒计时富文本（分钟为单位）
		if type(_item.lefttime) ~= "nil" and _item.lefttime > 0 then
			local d, h, m, tm = getTime(_item.lefttime)
			local ltime = string.format(getString("NEWBILITY_LEFT_TIME"),d,h,m)
			local srt_time = UIStaticRichText:createWithString(ltime)
			srt_time:setAnchorPoint(ccp(0.5, 0.5))
			srt_time:setPosition(ccp(280, 100))
			wgtclone:addChild(srt_time, 999, 9528)
		end
		
		if topItem then 
			yesArray:insertObject(wgtclone, 1)
		elseif canuse then
			yesArray:addObject(wgtclone)
		else 
			noArray:addObject(wgtclone)
		end
		
	end
	
	for k = 1, yesArray:count() do
		local v = yesArray:objectAtIndex(k)
		local w = tcast(v, 'Widget')
		listitem:pushBackCustomItem(w)
	end
	for k = 1, noArray:count() do
		local v = noArray:objectAtIndex(k)
		local w = tcast(v, 'Widget')
		listitem:pushBackCustomItem(w)
	end
	
	yesArray:removeAllObjects();
	noArray:removeAllObjects();
	
--倒计时
--[[
	local bt = msg.bt
	local et = msg.et
	local nt = msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
	--]]
end

function newbilitylist:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function newbilitylist:_nil()
end