local json = require'json'
local itemCfg =require 'config.item'
require'uifunc'

OnlineGiftActivity = class('OnlineGiftActivity', LuaUI)
local super = OnlineGiftActivity.__super
function OnlineGiftActivity:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('activity_onlinegift.json', true) then return false end
	
	self:addLuaHandler('btn_close', function() self:close() end)
	
	self:OutClickClose()
	
	g_SendMsg({ptype = 'oltime_list'})	
	
	self.awardNum = 0
	return true
end


function OnlineGiftActivity:onEnter()
	self:regJMsgHandler('oltime_list', self.UpdateUI)
	self:regJMsgHandler('oltime_award', self.Delete)
end

function OnlineGiftActivity:Delete(data)
	local id = data
	local btn_list = self:seekWidgetByName('listitem')	
	local items = btn_list:getItems()
	for k = 1, items:count() do
		local obj = items:objectAtIndex(k)
		obj = tolua.cast(obj, "CCNode")
		local tag = obj:getTag()
		if tag == id then
			btn_list:removeItem(k)
			break
		end
	end
	
	self.awardNum = items:count()
end

function OnlineGiftActivity:UpdateUI(data)
	local btn_list = self:seekWidgetByName('listitem')
	while (btn_list:getItems():count() > 0) do
		btn_list:removeLastItem()
	end
	
	self.awardNum = #data.items

	self:updateTime(data.oltime)
	schedule(self, function ()
		data.oltime = data.oltime + 1
		self:updateTime(data.oltime)
	end, 1)
	
	local widgetTemplate = LOADWIDGET("activity_item.json")
	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()
		local canGet = _item.canGet --能否领取
		local chargeDay =_item.chargeDay --在线多久可领取
		wgtclone:setTag(chargeDay)
		--标题
		local ImageTitle = UIHO:seekWidgetByName(wgtclone, 'ImageTitle')
		ImageTitle:setText(string.format(getString('ONLINE_GIFT_TIPS'), math.floor(chargeDay / 60)))
		
		--取奖励
		local j = 1
		for v, award in  ipairs(_item.itemList) do	
			local image = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:itemImg', j))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:lab_dec', j))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(award.type, award.value, award.parm, image)
				lab_dec:setText(dec)
			end
			j =j+1
		end
		
		--隐藏其他的
		for n=j,3 do 
			local itemAward = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d',n))
			if itemAward ~= nil then itemAward:setEnabled(false) end
		end
		
		--设置按钮
		local btn_click = UIHO:seekWidgetByName(wgtclone, 'btn_click')		
		btn_click:setTouchEnabled(canGet == 1)
		if (canGet == 1) then
			self:addLuaHandler(btn_click, function ()
				g_SendMsg({ptype = 'oltime_award', data = chargeDay,})
				g_SendMsg({ptype='oltime_time'})
			end)
		else
			btn_click:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
		end

		btn_list:pushBackCustomItem(wgtclone)
	end
	
end

function OnlineGiftActivity:GetTime(tm)
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return h, m, tm
end

function OnlineGiftActivity:updateTime(onlinetime)
	local txt = self:seekWidgetByName('lab_endTime')
	if txt ~= nil then
		if self.awardNum == 0 then
			txt:setText(string.format(getString("ONLINE_GIFT_OVER")))
		else
			txt:setText(string.format(getString("ONLINE_GIFT_TIME"), self:GetTime(onlinetime)))
		end
	end
end

function OnlineGiftActivity:_nil()
end