DlgQuarryFight = class('DlgQuarryFight', LuaUI)
local super = DlgQuarryFight.__super

local batPanelName = {
	'pnl_player',
	'pnl_hire',
	'pnl_hire1',
	'pnl_enemy1',
	'pnl_enemy2',
	'pnl_enemy3',
};

function DlgQuarryFight:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('stope_battle.json', true) then return false end
	
	self:scheduleUpdateWithPriorityLua(
		function () self:update() end, 0)
	self:GetRootWidget():setTouchEnabled(false)
	self:setTouchEnabled(true)
	self:addLuaHandler(self, function ()
		self:GetRootLayer():ClearPopup()
	end)
	self:InitBattle()
	
	return true
end

function DlgQuarryFight:InitBattle()
	for k = 1, 6 do
		local panel = self:seekWidgetByName(batPanelName[k])
		if panel then
			local bar = UIHO:seekWidgetByName(panel, 'bar_hp')
			if bar then
				local ebar = UIEnergyBar:create()
				bar:getParent():addChild(ebar, 10)
				local label = UIHO:seekWidgetByName(bar, 'text_hp')
				if label then
					label:retain()
					label:removeFromParent()
					ebar:addChild(label, 10)
					label:release()
				end
				local iv = UIHO:seekWidgetByName(bar, 'img_dead')
				if iv then
					iv:retain()
					iv:removeFromParent()
					ebar:addChild(iv, 11)
					iv:release()
				end
				ebar:setName('bar_hp')
				ebar:cloneFromLoadingBar(bar)
				bar:removeFromParent()
				if k <= 3 then ebar:setDirection(LoadingBarTypeRight) end
			end
			if k == 1 then
				local mpbar = UIHO:seekWidgetByName(panel, 'bar_mp')
				if mpbar then
					local empbar = UIEnergyBar:create()
					mpbar:getParent():addChild(empbar, 10)
					
					local label = UIHO:seekWidgetByName(bar, 'text_mp')
					if label then
						label:retain()
						label:removeFromParent()
						empbar:addChild(label, 10)
						label:release()
					end
					
					empbar:setName('bar_mp')
					empbar:cloneFromLoadingBar(mpbar)
					empbar:setDirection(LoadingBarTypeRight)
					mpbar:removeFromParent()
				end
			end
		end
	end
end

function DlgQuarryFight:FightBegin(fds)
	local msg = fds:GetFightMsg()
	if msg == nil then
		msg = fds:GetPrevFightMsg()
		if not msg then return end
	end
	if #msg.objsLeft == 0 then return end
	
	local widget = self:seekWidgetByName('stope_battle')
	for k = 1, 3 do
		local fod
		if #msg.objsLeft >= k then fod = fds.fodMap[msg.objsLeft[k].id] end
		InitFightObjectDetails(widget, batPanelName[k], fod)
	end
	for k = 1, 3 do
		local fod
		if #msg.objsRight >= k then fod = fds.fodMap[msg.objsRight[k].id] end
		InitFightObjectDetails(widget, batPanelName[k+3], fod)
	end
end

function DlgQuarryFight:onEnter()
	g_Player.quarryFightMgr.panel = self
	self:FightBegin(g_Player.quarryFightMgr)
end

function DlgQuarryFight:onExit()
	g_Player.quarryFightMgr.panel = nil
	for k, v in pairs(g_Player.quarryFightMgr.fodMap) do
		v.panel = nil
	end
end

function DlgQuarryFight:update()
	if not g_Player:IsQuarryFighting() then
		self:close()
	end
end