local proto = require'protocol'
local itemCfg = require'config.item'
local tcast = tolua.cast

RuneBag = class('RuneBag', LuaUI)
local super = RuneBag.__super

function RuneBag:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('fw_bag.json', true) then return false end
	
	self:addLuaHandler('btn_close', function () self:close() end)
	self:OutClickClose()
	self:initruneitems()
	return true
end

--ʼ
function RuneBag:initruneitems()
	--
	local scv_fwList = self:seekWidgetByName('scv_fwList')
	scv_fwList:removeAllChildren()
	--ѭɵ
	for k=1, #g_Player.runebackpackSort do 
		local v = g_Player:GetRuneItem(g_Player.runebackpackSort[k])
		if v then
			local w = self:MakeBagItemIcon(v,TLT_BAG)
			if w then 
				w:setScale(0.8)
				scv_fwList:addChild(w) 
			end
		end
	end
	--λ
	self:RelayoutItems(scv_fwList)
end

function RuneBag:RelayoutItems(scv_fwList)
	if not scv_fwList then return end
	local size = scv_fwList:getSize()
	local array = scv_fwList:getChildren()
	
	local iconSize = 85
	local iconMargin = 24
	local countPreLine = 5
	
	local lines = 0
	local arrcount = array:count()
	if arrcount > 0 then
		lines = arrcount + countPreLine -1
		lines = lines / countPreLine
	end
	local newSizeH =lines*(iconSize + iconMargin) + iconMargin
	local newSize = CCSizeMake(size.width,newSizeH)
	
	if newSize.height > size.height then
		scv_fwList:setInnerContainerSize(newSize)
		size = newSize;
	else
		scv_fwList:setInnerContainerSize(size)
	end
	
	for k = 1, array:count() do
		local iiv = array:objectAtIndex(k)
		local x = iconMargin + iconSize/2 + ((k-1)%countPreLine)*(iconMargin+iconSize)
		local y = size.height - iconMargin - iconSize/2 - (math.floor((k -1)/countPreLine))*(iconMargin+iconSize)
		iiv:setPosition(ccp(x,y))
	end
end

--ͼ
function RuneBag:MakeBagItemIcon(item,tiptype)
	w = UIItemImageView:create(item.templateId, tiptype, PACKAGE_TYPE_BACKPACK)
	w:SetUserData(item.uniqueId)
	w:UpdateUI(w:GetDummyItem())
	return w
end

--_type ߿:1(BUGʱ)2Բ
function RuneBag:MakeBagItemIconEx(item,tiptype,_type)
	local ids = itemCfg[item.templateId]
	if ids == nil then return end
	
	local w = ImageView:create()
	if w == nil then return end
	
	local lv = item:Level()
	if _type == 2 then 
		w:loadTexture(ids.texture, UI_TEX_TYPE_PLIST)
		w:setTouchEnabled(true)
		
		local spr = CPSprite:createWithSpriteFrameName('img_circle2.png')
		if spr ~= nil then
			spr:setScale(1.05)
			spr:setColor(ccc3(EquipRuneColors[lv][1],EquipRuneColors[lv][2],EquipRuneColors[lv][3]))
			w:addNode(spr, 1, -99)
		end
		
		-- local srt = CCStaticRichText:createWithString(string.format("Lv.%u", lv), "simhei", 25)
		local srt = CCStaticRichText:createWithString(item:getRuneColorName(), "simhei", 25)
		if srt ~= nil then
			srt:setScale(0.8)
			srt:setColor(ccc3(EquipRuneColors[lv][1],EquipRuneColors[lv][2],EquipRuneColors[lv][3]))
			srt:setPositionY(-w:getContentSize().height / 2)
			srt:setPositionX(3)
			w:addNode(srt, 10, -101)
		end
	else 
		w:loadTexture('equip_frame_01.png', UI_TEX_TYPE_PLIST)
		w:setColor(ccc3(EquipRuneColors[lv][1],EquipRuneColors[lv][2],EquipRuneColors[lv][3]))
		w:setTouchEnabled(true)
		
		local spr = CPSprite:createWithSpriteFrameName(ids.texture)
		if spr ~= nil then
			spr:setScale(1.05)
			w:addNode(spr, 1, -99)
		end
		
		local srt = CCStaticRichText:createWithString(string.format("Lv.%u", lv), "simhei", 25)
		if srt ~= nil then
			srt:setColor(ccc3(EquipRuneColors[lv][1],EquipRuneColors[lv][2],EquipRuneColors[lv][3]))
			srt:setPositionY(-w:getContentSize().height / 2)
			w:addNode(srt, 10, -101)
		end
	end
	
	w:addTouchEventListener(function (s, e)
		if e == TOUCH_EVENT_ENDED then
			EquipRuneDetail:Show(g_CurLayer,item.uniqueId,ids.itemId)
		end
	end)
	
	return w
end

function RuneBag:UpdateItem(uniqueId)
	local scv_fwList = self:seekWidgetByName('scv_fwList')
	local array = scv_fwList:getChildren()
	for k = 1, array:count() do
		local iiv = array:objectAtIndex(k)
		local uid = iiv:GetUserData()
		if uid == uniqueId then
			iiv:UpdateUI(iiv:GetDummyItem())
			break
		end
	end
end

function RuneBag:RemoveItem(uniqueId)
	local scv_fwList = self:seekWidgetByName('scv_fwList')
	local array = scv_fwList:getChildren()
	for k = 1, array:count() do
		local iiv = array:objectAtIndex(k)
		local uid = iiv:GetUserData()
		if uid == uniqueId then
			iiv:removeFromParent()
			break
		end
	end
	self:RelayoutItems(scv_fwList)
end

function RuneBag:OnRuneItemUpdate(_type, where, uniqueId, item, prevItem,source)
	if  proto.PACKAGE_TYPE_RUNEBACKPACK == where then
		if _type==IUEVENT_REMOVE then
			self:RemoveItem(uniqueId)
		elseif  _type==IUEVENT_UPDATE then 
			self:UpdateItem(uniqueId)
		elseif _type== IUEVENT_ADD then
			self:initruneitems()
		end
	end
end