local proto = require'protocol'
local runeCfg = require'config.rune'
local itemCfg = require'config.item'
local runeSkillCfg = require'config.runeskill'
--local skillCfg = require'config.skill'
--local tcast = tolua.cast

EquipRuneDetail = class('EquipRuneDetail', LuaUI)
local super = EquipRune.__super

function EquipRuneDetail:init(uniqueid,templateid)
	if not super.init(self) then return false end
	if not self:initRootWidget('fuwen_detail.json', true) then return false end
	
	self.runeitem ,self.where = g_Player:GetRuneItem(uniqueid)
	self.templateid = templateid
	self:addLuaHandler('btn_close', function () self:close() end)
	self:addLuaHandler('btn_help', function () self:close() end)
	
	self:seekWidgetByName('btn_change'):setEnabled(false)
	self:seekWidgetByName('btn_eat'):setEnabled(false)
	self:seekWidgetByName('btn_sell'):setEnabled(false)
	self:seekWidgetByName('btn_lock'):setEnabled(false)
	
	if self.runeitem then
	    self:seekWidgetByName('btn_eat'):setEnabled(true)
		self:seekWidgetByName('btn_lock'):setEnabled(true)
		self:addLuaHandler('btn_lock', 
			function () 
				local msg = proto.C2S_UseLuckItem.new()
				msg.targetItemId = self.runeitem.uniqueId
				g_SendMsg(msg)
				
			end)
			
		self:addLuaHandler('btn_eat', 
			function () 
				local runelv,runexp = self.runeitem:Level()
				if runelv>= #g_Player.runeexp then
					LShowMessage(TDGETSTRCS('SD_RUNE_LV_MAX'))
					return
				end
				local rootLayer = self:GetRootLayer()
				self:close() 
				EquipRuneEate:Show(rootLayer,self.runeitem.uniqueId)
			end)
			
		if self.where == proto.PACKAGE_TYPE_RUNEINVENTORY then
			self:seekWidgetByName('btn_change'):setEnabled(true)
			self:seekWidgetByName('btn_sell'):setEnabled(true)
			
			self:addLuaHandler('btn_change', 
			function () 
				local rootLayer = self:GetRootLayer()
				self:close() 
				EquipRuneSelect:Show(rootLayer,g_Player:GetRuneItemSlot(self.runeitem.uniqueId))
			end)
			self:addLuaHandler('btn_sell', function () 
				local msg = proto.C2S_TakeOffRune.new()
				msg.slot = g_Player:GetRuneItemSlot(self.runeitem.uniqueId)
				g_SendMsg(msg)
				self:close() 
			end)
		end
	end
	self:OutClickClose()
	self:UpdateDetail()
	return true
end

function EquipRuneDetail:UpdateLock()
	if not self.runeitem then return end
	local btn_lock = self:seekWidgetByName('btn_lock')
	if self.runeitem:bind() then
		btn_lock:loadTextureDisabled("btn_fwjs.png", UI_TEX_TYPE_PLIST)
		btn_lock:loadTextureNormal("btn_fwjs.png", UI_TEX_TYPE_PLIST)
		btn_lock:loadTexturePressed("btn_fwjs.png", UI_TEX_TYPE_PLIST)
	else
		btn_lock:loadTextureDisabled("btn_fwlock.png", UI_TEX_TYPE_PLIST)
		btn_lock:loadTextureNormal("btn_fwlock.png", UI_TEX_TYPE_PLIST)
		btn_lock:loadTexturePressed("btn_fwlock.png", UI_TEX_TYPE_PLIST)
	end
end
function EquipRuneDetail:UpdateDetail()
	local _itemCfg = itemCfg[self.templateid]
	local _runeCfg = runeCfg[self.templateid]
	local _runeSkillCfg = runeSkillCfg[_runeCfg.runeskillid]
    local runename = ''
	local runelv = 1
	if self.runeitem then 
		runename =  self.runeitem:LevelStr() 
		runelv = self.runeitem:Level()
	end
	--ͼƬ
	local item_img = self:seekWidgetByName('item_img:item')
	item_img:removeAllChildren()
	local w = RuneBag.MakeBagItemIcon(nil,{templateId = self.templateid,uniqueId =0},TLT_Null)
	if w then item_img:addChild(w) end
	--
	local lbl_fwname = self:seekWidgetByName('item_img:lbl_fwname')
	lbl_fwname:setText(SSFmt('%s %s',_itemCfg.name,runename))
	--ϸϢ
	local pnl_fuwen_props = self:seekWidgetByName('pnl_fuwen_props')
	pnl_fuwen_props:removeAllChildren()
	
	local space = ''
	local detailStr = TDGETSTRCS('SD_RUNE_DETAILS')
	local runeAbilstr = ''--
	local runecmb = ''--
	local runeskill = string.format('%s \n%s',_runeSkillCfg.name,_runeSkillCfg.des)--
	if _runeCfg.abitype == 1 then
		runeAbilstr = space..Player.getAbilityStr(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	elseif _runeCfg.abitype == 2 then
		runeAbilstr = space..Player.getSq2Str(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	end
	--
	local cmbLen = #_runeCfg.cmbskill
	for k=1, cmbLen do
		local _runeid = _runeCfg.cmbskill[k]
		local _itemCmbCfg = itemCfg[_runeid]
		if _itemCmbCfg then
			if k < cmbLen then
				runecmb = runecmb..space.._itemCmbCfg.name..'\n'
			else
				runecmb = runecmb..space.._itemCmbCfg.name
			end
		end
	end
	--
	detailStr = string.format(detailStr,runeAbilstr, runecmb , runeskill)
	local detali = UIStaticRichText:createWithString(detailStr,pnl_fuwen_props:getContentSize().width, 10)
	detali:setAnchorPoint(ccp(0, 1));
	detali:setPositionY(pnl_fuwen_props:getContentSize().height);
	detali:setPositionX(0);
	pnl_fuwen_props:addChild(detali)
	
	self:UpdateLock()
end

function EquipRuneDetail:OnRuneItemUpdate(_type, where, uniqueId, item, prevItem ,source )	
	if not self.runeitem then return end
	if  uniqueId == self.runeitem.uniqueId then
		self.runeitem = g_Player:GetRuneItem(uniqueId)
		self:UpdateDetail()
	end
end