local proto = require'protocol'
local runeCfg = require'config.rune'
local itemCfg = require'config.item'
local runeSkillCfg = require'config.runeskill'
--local skillCfg = require'config.skill'
--local tcast = tolua.cast

EquipRuneEate = class('EquipRuneEate', LuaUI)
local super = EquipRuneEate.__super

function EquipRuneEate:init(uniqueid)
	if not super.init(self) then return false end
	if not self:initRootWidget('fuwen_tunshi.json', true) then return false end
	
	self.runeitem ,self.where = g_Player:GetRuneItem(uniqueid)
	self.templateid = self.runeitem.templateId
	self:addLuaHandler('btn_close', function () self:close() end)
	self:addLuaHandler('btn_help', function () self:close() end)
	self:addLuaHandler('btn_auto_select',function () self:AutoSelect() end)
	
	self:addLuaHandler('btn_do',
	function () 
		local eatlist = {}
		for k = 1, #self.idlist do
			local id = self.idlist[k]
			if id~=0 then eatlist[#eatlist + 1] = id end
		end
		
		if #eatlist==0 then return end
		-- print_t(eatlist)
		local msg = proto.C2S_EatRune.new()
		msg.targetId = self.runeitem.uniqueId
		msg.uniqueIds = eatlist
		g_SendMsg(msg)
	end)
	
	self:OutClickClose()
	self:UpdateItem()
	
	self.idlist ={0,0,0,0,0,0}
	
	for k = 1, 6 do
		self:addLuaHandler(string.format('icon_fwimg_%d',k),
		function () self:SelectItemClick() end)
	end
	
	return true
end

function EquipRuneEate:SelectItemClick()
	EquipRuneEatSelect:Show(self:GetRootLayer(), self.idlist,self.runeitem.uniqueId,
		function (idlist)
			for k=1, #idlist do 
				local uid = idlist[k]
				if uid==0 then
					self:SetSlotItem(nil,k)
				else
					self:SetSlotItem(g_Player:GetRuneItem(idlist[k]),k)
				end
				
			end
		end)
end

function EquipRuneEate:SetSlotItem(item,slot)
	local img_icon = self:seekWidgetByName(string.format('icon_fwimg_%d',slot))
	img_icon:removeAllChildren()
	self.idlist[slot] = 0
	if item then
		local w = RuneBag.MakeBagItemIcon(nil,item,TLT_Null)
		if w then img_icon:addChild(w) end
		self.idlist[slot] = item.uniqueId
	end
end

function EquipRuneEate:AutoSelect()
	self:Clear()
	local count=0
	for k=1, #g_Player.runebackpackSort do 
		local v = g_Player:GetRuneItem(g_Player.runebackpackSort[k])
		if v then 
			if not v:bind() and v.uniqueId ~=self.runeitem.uniqueId then 
				count = count + 1
				self:SetSlotItem(v,count)
				if count >=6 then break end
			end
		end
	end
end

function EquipRuneEate:Clear()
	for i=1,6 do self:SetSlotItem(nil,i)end
end

function EquipRuneEate:UpdateItem()
	if not self.runeitem then return end
	local _itemCfg = itemCfg[self.templateid]
	local _runeCfg = runeCfg[self.templateid]
    local runename = self.runeitem:LevelStr() 
	local runelv,runexp = self.runeitem:Level()

	
	--ͼƬ
	local icon_fwimg_main = self:seekWidgetByName('icon_fwimg_main')
	icon_fwimg_main:removeAllChildren()
	local w = RuneBag.MakeBagItemIcon(nil,{templateId = self.templateid,uniqueId =0},TLT_Null)
	if w then icon_fwimg_main:addChild(w) end
	
	--
	local lbl_adv_sw = self:seekWidgetByName('lbl_adv_sw')
	lbl_adv_sw:setText(SSFmt('%s %s',_itemCfg.name,runename))
	
	--ȼ
	local fw_lv = self:seekWidgetByName('fw_lv')
	fw_lv:setText(SSFmt(TDGETSTRCS('SD_RUNE_LV_FORMAT'),runelv))
	
	--
	local fw_exp = self:seekWidgetByName('fw_exp')
	fw_exp:setText(SSFmt(TDGETSTRCS('STAR_REMAKE_TIPS_EXP'),runexp))
	
	--
	local fw_expbar = self:seekWidgetByName('fw_expbar')
	if runelv > #g_Player.runeexp - 1 then
		fw_expbar:setPercent(100)
	else
		fw_expbar:setPercent(runexp / g_Player.runeexp[runelv+1] * 100)
	end
end

function EquipRuneEate:OnRuneItemUpdate(_type, where, uniqueId, item, prevItem,source)
	if  uniqueId == self.runeitem.uniqueId then
		self.runeitem ,self.where = g_Player:GetRuneItem(uniqueId)
		self:UpdateItem()
	end
	if  proto.PACKAGE_TYPE_RUNEBACKPACK == where then
		if _type==IUEVENT_REMOVE then
			for i=1,6 do 
				local img_icon = self:seekWidgetByName(string.format('icon_fwimg_%d',i))
				local vii = img_icon:getChildByName('itemView')
				if vii and vii:GetUserData() ==  uniqueId then
					img_icon:removeAllChildren()
					break
				end
			end
		end
	end
end