local proto = require'protocol'
local runeCfg = require'config.rune'
local itemCfg = require'config.item'
local runeSkillCfg = require'config.runeskill'
--local skillCfg = require'config.skill'
--local tcast = tolua.cast

EquipRuneEatSelect = class('EquipRuneSelect', LuaUI)
local super = EquipRuneEatSelect.__super

function EquipRuneEatSelect:init(idlist,taguniqueId,callbackfun)
	if not super.init(self) then return false end
	if not self:initRootWidget('fuwen_tunshi_list.json', true) then return false end
	self:addLuaHandler('btn_close', function () self:close() end)
	self:addLuaHandler('btn_saves', 
		function () 
			local count = 1
			local saveList = {0,0,0,0,0,0}
			for k=1, #self.allCheckBox do
				local v = self.allCheckBox[k]
				if v:getSelectedState() then
					saveList[count] = self.allRuneID[k]
					count = count + 1
				end
			end
			self:close()
			self.callbackfun(saveList) 
		end)
	self.callbackfun = callbackfun
	self.taguniqueId = taguniqueId
	self:OutClickClose()
	self:UpdateUi(idlist)
	return true
end


function EquipRuneEatSelect:UpdateUi(idlist)
	self.allCheckBox = {}
	self.allRuneID = {}
	self.curSelectCount = 0
	local fuwen_list = self:seekWidgetByName('skill_list')
	--
	while (fuwen_list:getItems():count() > 0) do
		fuwen_list:removeLastItem()
	end
	local widgetTemplate = LOADWIDGET("fuwen_tunshi_item.json")	
	--ѭжϷı
	for k=1, #g_Player.runebackpackSort do 
		local v = g_Player:GetRuneItem(g_Player.runebackpackSort[k])
		if v then
		--δ󶨵
			if not v:bind() and v.uniqueId ~=self.taguniqueId then
				local wgtclone = widgetTemplate:clone()
				if self:InitSelectItem(wgtclone,v,idlist) then
					fuwen_list:insertCustomItem(wgtclone,1)
				else
					fuwen_list:pushBackCustomItem(wgtclone)
				end
			end
		end
	end
end

function EquipRuneEatSelect:InitSelectItem(wgtclone,runeitem,idlist)
	local chk_box = UIHO:seekWidgetByName(wgtclone,'chk_box')
	--жǷѡ
	local checkSelectFun = function (id)
							for k=1,#idlist do 
								if idlist[k] == id then return true end
							end
								return false
						   end
						   
	local selected = checkSelectFun(runeitem.uniqueId)
	if selected then self.curSelectCount = self.curSelectCount + 1 end
	chk_box:setTouchEnabled(false)
	chk_box:setSelectedState(selected)--Ƿѡ
	self.allCheckBox[#self.allCheckBox + 1] = chk_box
	
	self.allRuneID[#self.allRuneID + 1] = runeitem.uniqueId
	
	--¼
	self:addLuaHandler(wgtclone, 
	function () 
		if chk_box:isEnabled() then
			local chk = not chk_box:getSelectedState()
			chk_box:setSelectedState(chk)
			if chk then self.curSelectCount = self.curSelectCount + 1
			else self.curSelectCount = self.curSelectCount - 1 end
			for k, v in ipairs(self.allCheckBox) do
				v:setEnabled(self.curSelectCount < 6 or v:getSelectedState())
			end
		end
	end)
	
	--ͼ
	local img_icon = UIHO:seekWidgetByName(wgtclone,'img_icon')
	img_icon:removeAllChildren()
	local w = RuneBag.MakeBagItemIcon(nil,runeitem ,TLT_Null)
	if w then img_icon:addChild(w) end
	
	--˵
	local _itemCfg = itemCfg[runeitem.templateId]
	local _runeCfg = runeCfg[runeitem.templateId]
	local _runeSkillCfg = runeSkillCfg[_runeCfg.runeskillid]
	local runeAbilstr = ''
	local runelv = runeitem:Level()
	local runelvStr = runeitem:LevelStr() 
	if _runeCfg.abitype == 1 then
		runeAbilstr = Player.getAbilityStr(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	elseif _runeCfg.abitype == 2 then
		runeAbilstr = Player.getSq2Str(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	end
	
	local detailStr = TDGETSTRCS('SD_RUNE_DETAILS_MINI')
	local panl_fwstr = UIHO:seekWidgetByName(wgtclone,'panl_fwstr')
	panl_fwstr:removeAllChildren()
	
	detailStr = string.format(detailStr,string.format('%s %s',_itemCfg.name,runelvStr), runeAbilstr , _runeSkillCfg.name)
	
	local detali = UIStaticRichText:createWithString(detailStr,panl_fwstr:getContentSize().width,3)
	detali:setAnchorPoint(ccp(0, 1));
	detali:setPositionY(panl_fwstr:getContentSize().height);
	detali:setPositionX(0);
	panl_fwstr:addChild(detali)
	
	return selected
end

