local proto = require'protocol'
local runeCfg = require'config.rune'
local itemCfg = require'config.item'
local runeSkillCfg = require'config.runeskill'

EquipRuneSkill = class('EquipRuneSkill', LuaUI)
local super = EquipRuneSkill.__super

function EquipRuneSkill:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('fuwen_skill.json', true) then return false end
	self:addLuaHandler('btn_close', function () self:close() end)
	self:OutClickClose()
	self:initSkillList()
	return true
end


function EquipRuneSkill:initSkillList()
	local widgetTemplate = LOADWIDGET("fuwen_skillitem.json")	
	local skill_list = self:seekWidgetByName('skill_list')
	--
	while (skill_list:getItems():count() > 0) do
		skill_list:removeLastItem()
	end
	local skillHave = function(id)
		for i=1,#g_Player.runeskill do
			if g_Player.runeskill[i].skillid ==id then return true end
		end
		return false
	end
	--ѭ
	for k, v in pairs(runeSkillCfg) do 
		local actv = skillHave(k)
		local wgtclone = widgetTemplate:clone()
		
		local pnl_fuwen_props = UIHO:seekWidgetByName(wgtclone,'pnl_fuwen_props')
		local detailStr = TDGETSTRCS('SD_RUNE_SKILL_DES') --ȡʽַ
		local actStr = ''--ַ
		local rueStr =''
		local raceStr = TDGETSTRCS('SD_RACE_MAX')
		if actv then
			actStr = TDGETSTRCS('SQ_ACTIVATED') 
			skill_list:insertCustomItem(wgtclone,1)
		else
			actStr = TDGETSTRCS('SQ_ACTIVATED_NOT') 
			skill_list:pushBackCustomItem(wgtclone)
		end
		--ͼƬ
		local img_fwskill = UIHO:seekWidgetByName(wgtclone,'img_fwskill')
		img_fwskill:loadTexture(v.icon, UI_TEX_TYPE_PLIST);
		--ְҵ
		if v.race == 0 then
			raceStr = TDGETSTRCS('SD_Warrior')
		elseif v.race==1 then
			raceStr = TDGETSTRCS('SD_Mage')
		elseif v.race==2 then
			raceStr = TDGETSTRCS('SD_Priest')
		end
		--Ҫ
		--print_t(v.runes)
		for i=1,#v.runes do
			local runeid = v.runes[i]
			local _itemCfg = itemCfg[runeid]
			if _itemCfg then
				rueStr = rueStr..' '.._itemCfg.name
			end
		end

		--˵
		local detali = UIStaticRichText:createWithString(string.format(detailStr,v.name,actStr,raceStr,rueStr,v.des),pnl_fuwen_props:getContentSize().width, 5)
		detali:setAnchorPoint(ccp(0, 1));
		detali:setPositionY(pnl_fuwen_props:getContentSize().height);
		detali:setPositionX(0);
		pnl_fuwen_props:addChild(detali)
	end
end


--------------

EquipRune = class('EquipRune', LuaUI)
local super = EquipRune.__super

function EquipRune:init()
	if not super.init(self) then return false end
	if not self:initRootWidget('equip_fuwen.json', true) then return false end
	
	self:addLuaHandler('btn_fwbag', function () RuneBag:Show(self:GetRootLayer()) end)
	self:addLuaHandler('btn_close', function () self:close() end)
	self:addLuaHandler('btn_lookskill', function () EquipRuneSkill:Show(self:GetRootLayer()) end)
	self:addLuaHandler('btn_rule', function ()
		LShowMessage(getString('EQUIP_RUNE_HELP'), nil, nil, MBT_OK, self._nil, self._nil, self._nil)
	end)
	
	for i=1,6 do
	  self:addLuaHandler(string.format('img_icon%d',i), function () self:OnClickSlot(i) end)
	end
	self:OutClickClose()
	self:UpdateRune()
	return true
end

function EquipRune:UpdateRune() 
	for i=1,#g_Player.runeinventory_pos do
		self:UpdateSlot(i)
	end
	self:UpDataPalAttr()
	self:UpDataPalSkill()
end

function EquipRune:OnClickSlot(slot)
	EquipRuneSelect:Show(self:GetRootLayer(),slot)
end

function EquipRune:UpDataPalAttr()
	local runeAbilstr = ''--ȡ
	for i=1,#g_Player.runeinventory_pos do
	  local uid = g_Player.runeinventory_pos[i]
	  local runeitem ,where = g_Player:GetRuneItem(uid)
	  if runeitem and where == proto.PACKAGE_TYPE_RUNEINVENTORY then
		--ȡ
		local runelv = runeitem:Level()
		local _runeCfg = runeCfg[runeitem.templateId]
		if _runeCfg.abitype == 1 then
			runeAbilstr = runeAbilstr..Player.getAbilityStr(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')..'\n'
		elseif _runeCfg.abitype == 2 then
			runeAbilstr = runeAbilstr..Player.getSq2Str(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')..'\n'
		end
	  end
	end
	--
	local pal_attr = self:seekWidgetByName('pal_attr')
	pal_attr:removeAllChildren()
	
	local detali = UIStaticRichText:createWithString(runeAbilstr,pal_attr:getContentSize().width*1.2,1)
	detali:setScale(0.85)
	detali:setAnchorPoint(ccp(0, 1));
	detali:setPositionY(pal_attr:getContentSize().height - 5);
	detali:setPositionX(10);
	pal_attr:addChild(detali)
end

function EquipRune:UpDataPalSkill()
	local runeAbilstr = ''--ȡ
	for i=1,#g_Player.runeskill do
		local skill =g_Player.runeskill[i]
		local cfg = runeSkillCfg[skill.skillid]
		if cfg then
			--
			runeAbilstr = runeAbilstr..string.format('%s Lv%d',cfg.name,skill.level)..'\n'
			--
			local deslv = string.format('des_lv%d',skill.level)
			local srate = string.format('rate%d',skill.level)
			srate = string.format(getString('RUNE_RATE_DES'),cfg[srate]/100)
			runeAbilstr = runeAbilstr..string.format('<c=ff0000><s=20>%s,%s</></>' ,cfg[deslv] ,srate)..'\n'
		end
	end
	--
	local pal_attr = self:seekWidgetByName('pal_attr_0')
	pal_attr:removeAllChildren()
	
	local detali = UIStaticRichText:createWithString(runeAbilstr,pal_attr:getContentSize().width*1.2,1)
	detali:setScale(0.85)
	detali:setAnchorPoint(ccp(0, 1));
	detali:setPositionY(pal_attr:getContentSize().height - 5);
	detali:setPositionX(10);
	pal_attr:addChild(detali)
	
end

function EquipRune:UpdateSlot(i)
	--ͼƬ
	  local img_icon = self:seekWidgetByName(string.format('img_icon%d',i))
	  img_icon:removeAllChildren()
	  img_icon:setTouchEnabled(true)
	  local uid = g_Player.runeinventory_pos[i]
	  local runeitem, where = g_Player:GetRuneItem(uid)
	  if runeitem and where == proto.PACKAGE_TYPE_RUNEINVENTORY then
	  	local w = RuneBag.MakeBagItemIconEx(nil,runeitem,TLT_BAG,2)
		if w then 
			img_icon:addChild(w)
			img_icon:setTouchEnabled(false)
		end
	  end
end

function EquipRune:OnRuneItemUpdate(_type, where, uniqueId, item, prevItem ,source )	
	--װôsourceʾλ
	if  proto.PACKAGE_TYPE_RUNEINVENTORY == where then
		self:UpdateSlot(source)
		self:UpDataPalAttr()
		self:UpDataPalSkill()
	end
end