local proto = require'protocol'
local runeCfg = require'config.rune'
local itemCfg = require'config.item'
local runeSkillCfg = require'config.runeskill'
--local skillCfg = require'config.skill'
--local tcast = tolua.cast

EquipRuneSelect = class('EquipRuneSelect', LuaUI)
local super = EquipRune.__super

function EquipRuneSelect:init(slot)
	if not super.init(self) then return false end
	if not self:initRootWidget('fuwen_select.json', true) then return false end
	self.runeitem = g_Player:GetRuneInvertorySlotItem(slot)--ȡõǰλõ
	self.slot = slot
	self:addLuaHandler('btn_close', function () self:close() end)
	self:OutClickClose()
	self:UpdateUi()
	return true
end

function EquipRuneSelect:InitSelectItem(wgtclone,runeitem,isbag)
	local btn_fwxq = UIHO:seekWidgetByName(wgtclone,'btn_fwxq')
	if isbag then
		self:addLuaHandler(btn_fwxq, 
		function () 
			local msg = proto.C2S_PutOnRune.new()
			msg.uniqueId = runeitem.uniqueId
			msg.slot = self.slot
			g_SendMsg(msg)
			self:close() 
		end)
	else
		btn_fwxq:setEnabled(false)
	end
	--ͼ
	local img_icon = UIHO:seekWidgetByName(wgtclone,'img_icon')
	img_icon:removeAllChildren()
	local w = RuneBag.MakeBagItemIcon(nil,runeitem ,TLT_Null)
	if w then img_icon:addChild(w) end
	--˵
	local _itemCfg = itemCfg[runeitem.templateId]
	local _runeCfg = runeCfg[runeitem.templateId]
	local _runeSkillCfg = runeSkillCfg[_runeCfg.runeskillid]
	local runeAbilstr = ''
	local runelv = runeitem:Level()
	local runelvStr = runeitem:LevelStr() 
	if _runeCfg.abitype == 1 then
		runeAbilstr = Player.getAbilityStr(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	elseif _runeCfg.abitype == 2 then
		runeAbilstr = Player.getSq2Str(nil,_runeCfg.valueindex,_runeCfg[string.format('value%d',runelv)],'+')
	end
	
	local detailStr = TDGETSTRCS('SD_RUNE_DETAILS_MINI')
	local panl_fwstr = UIHO:seekWidgetByName(wgtclone,'panl_fwstr')
	panl_fwstr:removeAllChildren()
	

	
	detailStr = string.format(detailStr,string.format('%s %s',_itemCfg.name,runelvStr), runeAbilstr , _runeSkillCfg.name)
	
	local detali = UIStaticRichText:createWithString(detailStr,panl_fwstr:getContentSize().width,3)
	detali:setAnchorPoint(ccp(0, 1));
	detali:setPositionY(panl_fwstr:getContentSize().height);
	detali:setPositionX(0);
	panl_fwstr:addChild(detali)
end

function EquipRuneSelect:UpdateUi()
	local templateid = 0
	if self.runeitem then
		templateid = self.runeitem.templateId
	end

	local widgetTemplate = LOADWIDGET("fuwen_select_item.json")	
	local pnl_fw_head = self:seekWidgetByName('pnl_fw_head')
	pnl_fw_head:removeAllChildren()
	
	--ǰװ
	if self.runeitem then
		local wgtclone = widgetTemplate:clone()
		self:InitSelectItem(wgtclone,self.runeitem, false)
		pnl_fw_head:addChild(wgtclone)
	end
	
	
	local fuwen_list = self:seekWidgetByName('pnl_body:fuwen_list')
	
	--
	while (fuwen_list:getItems():count() > 0) do
		fuwen_list:removeLastItem()
	end
	
	--ѭжϷı
	for k=1, #g_Player.runebackpackSort do 
		--ûеķĲʾ
		local v = g_Player:GetRuneItem(g_Player.runebackpackSort[k])
		if v then
			if not g_Player:CheckRuneInventoryHave(v.templateId) then
				local wgtclone = widgetTemplate:clone()
				self:InitSelectItem(wgtclone,v, true)
				fuwen_list:pushBackCustomItem(wgtclone)
			end
		end
	end
	
	--ʾϢ
	self:seekWidgetByName('lbl_message'):setVisible(fuwen_list:getItems():count() == 0)
end

