local itemConfig = require'config.item'
local json = require'json'
require'uifunc'
local actionMgr = require'action'

ScratchActivity = class('ScratchActivity', LuaUI)
local super = ScratchActivity.__super

local ScratchActivity_des = ""

function ScratchActivity:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('activity_card.json', true) then return false end
	
	self:OutClickClose()
	self:addLuaHandler('btn_gzsm', function ()
		LShowMessage(ScratchActivity_des, nil, nil,MBT_OK,self._nil,self._nil,self._nil)
	end)
	
	self:addLuaHandler('btn_charge', function ()
		local layer = self:GetRootLayer()
		self:close()
		Charge:Show(layer)
	end)
	
	g_SendMsg({ptype = 'scratch_list',})
	
	return true
end

function ScratchActivity:onEnter()
	self:regJMsgHandler('scratch_list', self.UpdateUI)
	self:regJMsgHandler('scratch_get', self.UpdateUI_Get)
	self:regJMsgHandler('scratch_err', self.UpdateUI_Err)
end
local colorStr = {'888888', '88ff88', '8888ff', 'ff88ff', 'ff8800', 'ff0000'}
local function getColorName(id, color)
	local cfg = itemConfig[id]
	if not cfg then return 'null' end
	
	if cfg.itemClass ~= ITEM_CLASS_EQUIPMENT then
		return SSFmt(TDGETSTRCS("SD02_MAIL_AWARD_ITEM"), cfg.name, color)
	end
	
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then color = 8 end
	
	local nameEx = ''
	if star > 0 then
		nameEx = nameEx..SSFmt(TDGETSTRCS('EQUIP_STAR_NAME'), star)
	end
	if color >= 6 and color <= 8 then
		nameEx = nameEx..TDGETSTRCS('EQUIP_SQ_NAME_'..color)
	end
	if nameEx ~= '' then nameEx = '['..nameEx..']' end
	
	if color > 6 then color = 6 end
	return SSFmt('<c=%s>%s%s</>', colorStr[color], cfg.name, nameEx)
end
local function getColor(color)
	local star = math.floor(color / 100)
	local color = color % 100 + 1
	if color > 8 then return 8 end
	
	if color >= 6 and color <= 8 then return color end
	
	return color
end
local nameWord = {[1] = "wo.jpg",[2] = "ai.jpg",[3] = "dao.jpg",[4] = "ta.jpg",[5] = "gua.jpg",[6] = "ji.jpg",}
function ScratchActivity:AddEffect(img, value)
	local star = math.floor(value / 100)
	AddStarLevel(img, star, 9, -9874)
	
	local itemcolor = getColor(value)
	if itemcolor == 6 then
		local spr = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr, 999, -9875)
	elseif itemcolor == 7 then
		local spr = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr, 999, -9876)
	elseif itemcolor == 8 then
		local spr1 = CreateAnimation('sq_%03u.png', 'main-equip.plist', 0.2, 14)
		img:addNode(spr1, 998, -9875)
		local spr2 = CreateAnimation('k_%03u.png', 'main-equip.plist', 0.15, 15)
		img:addNode(spr2, 999, -9876)
	end
end
function ScratchActivity:setItemImgCard(wgtclone, index, _item)

	if wgtclone ~= nil then
		if type(_item) ~= 'nil' then
			
			local itemImg = UIHO:seekWidgetByName(wgtclone, "itemImg")
			if itemImg ~= nil then
				if _item.tp == 1 then --金币
					itemImg:loadTexture('img_bg_money.png', UI_TEX_TYPE_PLIST)
					local label = UIStaticRichText:createWithString(tostring(_item.p1), itemImg:getSize().width*2, 1)
					label:setPositionY(-40)
					itemImg:addChild(label, 995, 9527)
				elseif _item.tp == 2 then --钻石
					itemImg:loadTexture('img_bg_zs.png', UI_TEX_TYPE_PLIST)
					local label = UIStaticRichText:createWithString(tostring(_item.p1), itemImg:getSize().width*2, 1)
					itemImg:addChild(label, 995, 9527)
					label:setPositionY(-40)
				elseif _item.tp == 3 then --道具
					local cfg = itemConfig[_item.p1]
					if not cfg then return 'null' end
					if cfg.itemClass ~= ITEM_CLASS_EQUIPMENT then
						itemImg:loadTexture(cfg.texture, UI_TEX_TYPE_PLIST)
						local label = UIStaticRichText:createWithString(tostring(_item.p2), itemImg:getSize().width*2, 1)
						itemImg:addChild(label, 995, 9527)
						itemImg:setScale(0.8)
						label:setPositionY(-50)
						label:setScale(1.25)
					end
				elseif _item.tp == 4 then --装备
					local cfg = itemConfig[_item.p1]
					if not cfg then return 'null' end
					if cfg.itemClass == ITEM_CLASS_EQUIPMENT then
						itemImg:loadTexture(cfg.texture, UI_TEX_TYPE_PLIST)
						itemImg:setScale(0.8)
						self:AddEffect(itemImg,_item.p2)
					end
				elseif _item.tp == 5 then --字
					itemImg:loadTexture(nameWord[_item.p1+1], UI_TEX_TYPE_PLIST)
				end
				
				local itemImg_bg = UIHO:seekWidgetByName(wgtclone, "itemImg_bg")
				itemImg_bg:setVisible(true)
				itemImg_bg:setZOrder(1)
				itemImg_bg:setScaleX(0)
				itemImg_bg:runAction(actionMgr.create(
					'Sequence',
					{'ScaleTo', 0.3, 1, 1},
					{'CallFunc', function () 
					--	img:loadTexture('img_bg_zs.png', UI_TEX_TYPE_PLIST) 
					end}
				--	{'ScaleTo', 0.3, 1, 1}
				))
				
				local btn_card = UIHO:seekWidgetByName(wgtclone, "btn_card")
				btn_card:setVisible(false)
				btn_card:setTouchEnabled(false)
			end
		else
			local itemImg_bg = UIHO:seekWidgetByName(wgtclone, "itemImg_bg")
			itemImg_bg:setVisible(false)
			local btn_card = UIHO:seekWidgetByName(wgtclone, "btn_card")
			btn_card:setTouchEnabled(true)
			btn_card:setVisible(true)
			btn_card:setScaleX(1)
			btn_card:addTouchEventListener(function (s, e)
				if e == TOUCH_EVENT_ENDED then
					btn_card:setTouchEnabled(false)
					btn_card:runAction(actionMgr.create(
						'Sequence',
						{'ScaleTo', 0.2, 0, 1},
						{'CallFunc', function () 
							btn_card:setZOrder(0)
							g_SendMsg({
								ptype = 'scratch_get',
								_index = index,
							})
						end}
					--	{'ScaleTo', 0.3, 1, 1}
					))
				end
			end)
		end
	end
end

function ScratchActivity:setItemNeed(n_t,n_v)
	local lbl_need = self:seekWidgetByName('lbl_need')
	if n_t == 1 then
		lbl_need:setText(string.format(getString('SCRACH_NEED_MONEY'),n_v))
	elseif n_t == 2 then
		lbl_need:setText(string.format(getString('SCRACH_NEED_ZS'),n_v))
	else
		lbl_need:setText(string.format(getString('SCRACH_NEED_NONE'),n_v))
	end
end

function ScratchActivity:UpdateUI_Err(msg)

	local index = msg.index
	
	local img_card_bg = self:seekWidgetByName('img_card_bg')
	local wgtclone = UIHO:seekWidgetByName(img_card_bg, 'ImgItem_clone_'..index)
	local btn_card = UIHO:seekWidgetByName(wgtclone, "btn_card")
	btn_card:setTouchEnabled(true)
	btn_card:setVisible(true)
	btn_card:setScaleX(1)
end

function ScratchActivity:UpdateUI_Get(msg)

	local _item = msg._item
	local index = _item.id
	local n_t = msg.n_t
	local n_v = msg.n_v	
	
	local img_card_bg = self:seekWidgetByName('img_card_bg')
	local wgtclone = UIHO:seekWidgetByName(img_card_bg, 'ImgItem_clone_'..index)
	
	self:setItemImgCard(wgtclone,index,_item)
	self:setItemNeed(n_t,n_v)
end
function ScratchActivity:getHaveGetItem(index,items)
	for k,v in ipairs(items) do
		if v.id == index then
			return v
		end
	end	
	return nil
end
function ScratchActivity:UpdateUI(msg)

	local data = msg
	local n_t = data.n_t
	local n_v = data.n_v	
	self:setItemNeed(n_t,n_v)
	ScratchActivity_des = data.des
	local img_card_bg = self:seekWidgetByName('img_card_bg')
	local widgetTemplate = self:seekWidgetByName('ImgItem_clone')
	for index=0,29 do
		local wgtclone = widgetTemplate:clone()
		wgtclone:setTag(index)
		wgtclone:setName('ImgItem_clone_'..index)
		local _x = (index%6) * 98 - 245
		local _y = math.floor(index/6) * 120 - 240
		wgtclone:setPosition(ccp(_x, _y))
		
		--注册按钮事件，还是显示已领取
		local _item = self:getHaveGetItem(index,data.items)
		self:setItemImgCard(wgtclone,index,_item)
		
		img_card_bg:addChild(wgtclone)
	end
	
--倒计时
	local bt = msg.bt
	local et = msg.et
	local nt = msg.nt
	self:updateTime(bt, et, nt)
	schedule(self, function ()
		nt = nt + 1
		self:updateTime(bt, et, nt)
	end, 1)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function ScratchActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function ScratchActivity:_nil()
end