local json = require'json'
require'uifunc'

local SSFmt = string.format

SellItemActivity = class('SellItemActivity', LuaUI)
local super = SellItemActivity.__super

local g_sitem_version = 0 --版本
local g_sitem_index = 0 --索引
local g_curr_sel = -1 --当前选择的那个
local g_havemore = false --是否有还要
local g_mytype = -1 --我购买的类型
local g_isopen = false --是否开启活动
local g_isloaditem = false --是否正在加载数据
local g_btnType =
{
	{name ='btn_ptlc',id=0, img= 'btn_ptlc01.png',light ='btn_ptlc02.png'},
	{name ='btn_gjlc',id=1, img= 'btn_gjlc01.png',light ='btn_gjlc02.png'},
	{name ='btn_hhlc',id=2, img= 'btn_hhlc01.png',light ='btn_hhlc02.png'}
} 

local g_price_lab={"btn_ptlc:lab_price","btn_gjlc:lab_price","btn_hhlc:lab_price"}

local g_price = nil

local g_totalDays = 0 --总共天数
local g_totalRice = 0 --总共获得钻石数量

local g_select = true

function SellItemActivity:init()
	if not super.init(self) then
		return false
	end
	if not self:initRootWidget('activity_zslc01.json', true) then
		return false
	end
	
	self:OutClickClose()
	
	self:addLuaHandler('btn_close', function ()
		self:close()
	end)
	
	self:addLuaHandler('btn_ptlc', function ()
		if g_curr_sel ~= 0 then
			g_SendMsg({
				ptype = 'siact',
				gtype = 0,
				flag = g_sitem_version,
				idx = 0,
			})
		else
			self:ShowInfo('SD_SELLITEM_ACTGIFT0')
		end
		g_select = false
	end)
	
	self:addLuaHandler('btn_gjlc', function ()
		if g_curr_sel ~= 1 then
			g_SendMsg({
				ptype = 'siact',
				gtype = 1,
				flag = g_sitem_version,
				idx = 0,
			})
		else
			self:ShowInfo('SD_SELLITEM_ACTGIFT1')
		end
		g_select = false
	end)
	
	self:addLuaHandler('btn_hhlc', function ()
		if g_curr_sel ~= 2 then
			g_SendMsg({
				ptype = 'siact',
				gtype = 2,
				flag = g_sitem_version,
				idx = 0,
			})
		else
			self:ShowInfo('SD_SELLITEM_ACTGIFT2')
		end
		g_select = false
	end)
	
	self:addLuaHandler('btn_lcgz', function ()
		LShowMessage(getString('SD_SELLITEM_HELP'),getString('SD_SELLITEM_TITLE'), nil,MBT_OK)
	end)
	
	self:addLuaHandler('btn_mslc', function ()
			if g_price == nil or g_mytype>=0 or g_curr_sel <0 then return end
			local price = g_price[g_curr_sel + 1] --价格
			local itemname = getString(string.format('SD_SELLITEM_ACTGIFT%d',g_curr_sel))--名称
			local cristal = getPlayerData(1)
			if cristal < price then
				local tip = string.format(getString('SD_SELLITEM_CHARGE'),itemname,price)
				LShowMessage(tip ,nil, nil,MBT_CHARGE_GIFT)
				return
			end
			local tip = string.format(getString('SD_SELLITEM_BUY'),price,itemname)
			LShowMessage(tip,nil, nil,MBT_OKCANCEL,self.BuyItem)
		end
	)
	
	
	g_SendMsg({
			ptype = 'siact',
			gtype = -1,
			flag = g_sitem_version,
			idx = 0,
		})
		
	local listitem = self:seekWidgetByName('listitem')
	
	listitem:addEventListenerScrollView(
	function (sender,event)
		if event == SCROLLVIEW_EVENT_SCROLL_TO_BOTTOM then 
			--CCMessageBox("daodile","daodile")
			if g_havemore and (g_isloaditem==false) then
				g_isloaditem = true
				g_SendMsg({
					ptype = 'siact',
					gtype = g_curr_sel,
					flag = g_sitem_version,
					idx = g_sitem_index,
				})
			end
		end
	end)	
	return true
end

function SellItemActivity:ShowInfo(lc_type)
	LShowMessage(SSFmt(TDGETSTRCS('SD_SELLITEM_ACTIVITY_AWARD'), getString(lc_type), g_totalDays, g_totalRice), 
		getString(lc_type), nil, MBT_OK)
end

function SellItemActivity:BuyItem()
	g_SendMsg({
				ptype = 'buysiact',
				gtype = g_curr_sel
			})
end

function SellItemActivity:onEnter()
	self:regJMsgHandler('siact', self.UpdateUI)
	self:regJMsgHandler('siactdel', self.Delete)
end

function SellItemActivity:Delete(data)
	local deltag = data.index
	local listitem = self:seekWidgetByName('listitem')
	local items = listitem:getItems()
	for k = 1, items:count() do
		local obj = items:objectAtIndex(k)
		obj = tolua.cast(obj, "CCNode")
		local tag = obj:getTag()
		if tag == deltag then
			listitem:removeItem(k);
			break
		end
	end
	
end

function SellItemActivity:UpdateMyType()
	local lab_changdays = self:seekWidgetByName('lab_changdays')
	if g_mytype >= 0 then
		lab_changdays:setText(string.format('%s%s',getString('SD_SELLITEM_ACTGIFTYES'),getString(string.format('SD_SELLITEM_ACTGIFT%d',g_mytype ))));
	else
		lab_changdays:setText(getString('SD_SELLITEM_ACTGIFTNO'));
	end
end

function SellItemActivity:UpdateUI(data)
	local widgetTemplate = LOADWIDGET("activity_item.json")
	
	local listitem = self:seekWidgetByName('listitem')
	--如果新的类型，那么删除以前的
	if data.gtype ~= g_curr_sel or data.reset then
		listitem:scrollToTop(0.1, false);
		while (listitem:getItems():count() > 0) do
			listitem:removeLastItem();
		end	
		
	end
	
	g_havemore = data.more
	g_sitem_version =data.flag
	g_sitem_index = data.idx
	g_curr_sel = data.gtype
	g_mytype = data.mytype
	g_isopen = data.isopen
	g_isloaditem = false
	g_totalDays = data.totalday
	g_totalRice = data.totalrice
	
	local selecttype = 'SD_SELLITEM_ACTGIFT'..g_curr_sel
	if not g_select then 
		self:ShowInfo(selecttype) 
		g_select = true
	end
	
	--设置价格
	if data.prices then
		g_price = data.prices
		for k,price in ipairs(g_price) do
			local labprice = self:seekWidgetByName(g_price_lab[k])
			labprice:setText(string.format(getString('LOTTERY_ACTIVITY_NEED'), price))
		end
	end
	
	--更新
	self:UpdateMyType()
	
	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()		
		local canGet = _item.canGet --能否领取
		local chargeDay =_item.chargeDay --第几天
		local idx =_item.idx --所在索引
		
		wgtclone:setTag(idx)
		
		--标题
		local ImageTitle = UIHO:seekWidgetByName(wgtclone, 'ImageTitle')
		ImageTitle:setText(string.format(getString('SD_SELLITEM_AWARD'),chargeDay));
		--取奖励
		local j = 1
		for v,award in  ipairs(_item.itemList) do	
			local image = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:itemImg', j))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:lab_dec', j))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(award.type,award.value, award.parm, image);
				lab_dec:setText(dec);
			end
			j =j+1
		end
		
		--隐藏其他的
		for n=j,3 do 
			local itemAward = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d',n))
			if itemAward ~= nil then
				itemAward:setEnabled(false);
			end
		end
		
		--设置按钮
		local btn_click = UIHO:seekWidgetByName(wgtclone, 'btn_click')
		
		--如果当前这个是我买的，那么就给
		if g_curr_sel==g_mytype then 
			self:addLuaHandler(btn_click, function ()
					g_SendMsg({
						ptype = 'siactaward',
						gtype = g_mytype,
						index = idx,
					})
				end)
		end	
		
		btn_click:setTouchEnabled(canGet == 1);
		if (canGet == 1) then
			btn_click:loadTextureDisabled("btn_lqjl_1.png", UI_TEX_TYPE_PLIST);
			btn_click:loadTextureNormal("btn_lqjl_1.png", UI_TEX_TYPE_PLIST);
			btn_click:loadTexturePressed("btn_lqjl_1.png", UI_TEX_TYPE_PLIST);
		else
			btn_click:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST);
			btn_click:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST);
			btn_click:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST);
		end
			
		listitem:pushBackCustomItem(wgtclone);
	end
	
	local reset = data.reset
	if reset then
		--倒计时
		local bt = data.bt
		local et = data.et
		local nt = data.nt
		self:updateTime(bt, et, nt)
		schedule(self, function ()
			nt = nt + 1
			self:updateTime(bt, et, nt)
		end, 1)
	end
	--更新按钮选择状态
	--btn_ptlc01 btn_ptlc02
	for k,_btn in ipairs(g_btnType) do
		local btn = self:seekWidgetByName(_btn.name)
		if _btn.id == g_curr_sel then
			btn:loadTextureNormal(_btn.light, UI_TEX_TYPE_PLIST);
			btn:loadTexturePressed(_btn.light, UI_TEX_TYPE_PLIST);
		else
			btn:loadTextureNormal(_btn.img, UI_TEX_TYPE_PLIST);
			btn:loadTexturePressed(_btn.img, UI_TEX_TYPE_PLIST);
		end
	end
	
	local btn_mslc = self:seekWidgetByName('btn_mslc')
	btn_mslc:setTouchEnabled(g_mytype <0);
	btn_mslc:setEnabled(g_mytype <0)
end

local function getTime(tm)
	local d = math.floor(tm / 86400)
	tm = tm % 86400
	local h = math.floor(tm / 3600)
	tm = tm % 3600
	local m = math.floor(tm / 60)
	tm = tm % 60
	return d, h, m, tm
end

function SellItemActivity:updateTime(bt, et, nt)
	local txt = self:seekWidgetByName('lab_endTime')
	local tip1
	if nt < bt then
		tip1 = string.format(getString('SD_ACTIVITY_BEGIN'),
			getTime(bt - nt))
	elseif nt > et then
		tip1 = (getString('SD_ACTIVITY_END'))
	else
		tip1 = string.format(getString('SD_ACTIVITY_ING'),
			getTime(et - nt))
	end
	txt:setText(string.format('%s\n', tip1))
end

function SellItemActivity:_nil()
end