VipDialogGift = class('VipDialogGift', LuaUI)
local super = VipDialogGift.__super
function VipDialogGift:init()
	if not super.init(self) then return false end
	
	if not self:initRootWidget('vip_dialog_gift.json', true) then return false end
	
	self:addLuaHandler('btn_close', function() self:close() end)
	self:OutClickClose()
	
	g_SendMsg({ptype = 'vipdialog_list'})
	
	return true
end

function VipDialogGift:onEnter()
	self:regJMsgHandler('vipdialog_list', self.UpdateUI)
	self:regJMsgHandler('vipdialog_award', self.Delete)
end

function VipDialogGift:Delete(data)
	local id = data
	local btn_list = self:seekWidgetByName('listitem')	
	local items = btn_list:getItems()
	for k = 1, items:count() do
		local obj = items:objectAtIndex(k)
		obj = tolua.cast(obj, "CCNode")
		local tag = obj:getTag()
		if tag == id then
			local lab_ylq = UIHO:seekWidgetByName(obj, 'lab_ylq')
			if lab_ylq ~= nil then lab_ylq:setVisible(true) end
			local btn_click = UIHO:seekWidgetByName(obj, 'btn_click')
			if btn_click ~= nil then 
				btn_click:setVisible(false)
				btn_click:setTouchEnabled(false)
			end
			break
		end
	end
end

function VipDialogGift:UpdateUI(data)
	local btn_list = self:seekWidgetByName('listitem')
	while (btn_list:getItems():count() > 0) do
		btn_list:removeLastItem()
	end

	local widgetTemplate = LOADWIDGET("activity_item.json")
	for k,_item in ipairs(data.items) do
		local wgtclone = widgetTemplate:clone()
		local canGet = _item.canGet
		local chargeDay =_item.chargeDay
		wgtclone:setTag(chargeDay)
		--标题
		local ImageTitle = UIHO:seekWidgetByName(wgtclone, 'ImageTitle')
		ImageTitle:setText(string.format(getString('VIPDIALOG_GIFT'), chargeDay))
		
		--取奖励
		local j = 1
		for v, award in  ipairs(_item.itemList) do	
			local image = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:itemImg', j))
			local lab_dec = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d:lab_dec', j))
			if image ~= nil and lab_dec ~= nil then 
				local dec = LoadAwardImage(award.type, award.value, award.parm, image)
				lab_dec:setText(dec)
			end
			j =j+1
		end
		
		--隐藏其他的
		for n=j,3 do 
			local itemAward = UIHO:seekWidgetByName(wgtclone, string.format('ImgItem_%d',n))
			if itemAward ~= nil then itemAward:setEnabled(false) end
		end
		
		--设置按钮
		local btn_click = UIHO:seekWidgetByName(wgtclone, 'btn_click')
		btn_click:setTouchEnabled(canGet == 1)
		if (canGet == 1) then
			self:addLuaHandler(btn_click, function ()
				g_SendMsg({ptype = 'vipdialog_award', data = chargeDay,})
			end)
		elseif (canGet == -1) then
			btn_click:setVisible(false)
			local btn_click = UIHO:seekWidgetByName(wgtclone, 'lab_ylq')
			if btn_click ~= nil then btn_click:setVisible(true) end
		else
			btn_click:loadTextureDisabled("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTextureNormal("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
			btn_click:loadTexturePressed("btn_lqjl_2.png", UI_TEX_TYPE_PLIST)
		end

		btn_list:pushBackCustomItem(wgtclone)
	end
	
end

function VipDialogGift:_nil()
end