local instance = FuncAssemble:singleton()
UIHO = UIHelperOverlayer

TDGETSTRCS = getString
SSFmt = string.format

MAIN_PLAYER = DPlayerData:GetInstance()
MAIN_PLAYER_DATA = MAIN_PLAYER.m_PlayerData
PLAYER_BASE_DATA = MAIN_PLAYER_DATA.playerFullData.playerBaseData
PLAYER_PACKAGE_DATA = MAIN_PLAYER_DATA.playerFullData.playerPackage
PLAYER_STATUS_DATA = MAIN_PLAYER_DATA.playerStatus
function PLAYER_EQUIP(slot) return MAIN_PLAYER.GetEquipmentData(slot) end
function PLAYER_HARNESS(slot) return MAIN_PLAYER.GetHarnessData(slot) end
PLAYER_MERCENARY = MAIN_PLAYER_DATA.mercenaryList.mercenaries
PLAYER_ABI4FIX = MAIN_PLAYER.m_ability4Fix

function LOADWIDGET(...)
	return instance:LoadWidgetFromJsonFile(...)
end

function SETUSERDATA(...)
	return instance:SetUserData(...)
end

function GetSplitTableByString(msg)
	local tab = {}
	if type(msg) ~= "string" then
		return nil
	end
	
	local temp = ""
	local tabIndex = 1
	local currIndex = string.find(msg,',')
	while currIndex ~= nil	do
		temp = string.sub(msg,1,currIndex - 1)
		msg = string.sub(msg,currIndex+1)
		tab[tabIndex] = tonumber(temp)
		tabIndex = 1 + tabIndex
		currIndex = string.find(msg,',')
	end
	--最后一个
	tab[tabIndex] = tonumber(msg)
	 
    -- for k,v in ipairs(tab) do
       -- print(v)
    -- end
	return tab
end

function addStarAnim(widget, aniname, tag, sc, frameNum)
	local effectSpr = CreateAnimation(aniname, 'main_effects.plist', 0.2, frameNum)
	if effectSpr ~= nil then
		effectSpr:setScale(sc)
		effectSpr:setOpacity(200)
		widget:addNode(effectSpr, 10, tag)
	end
end

function AddStarLevel(iiv, starNum, zOrder, tag)
	local sun = math.floor(starNum / 18)
	local moon = math.floor(starNum % 18 / 6)
	local star = starNum % 6
	
	local w = 18
	local ox = -((sun + moon + star - 1) * w / 2)
	for k = 1, star do
		local spr = CPSprite:createWithSpriteFrameName('star.png')
		spr:setPosition(60, ox + (k - 1) * w)
		iiv:addNode(spr, zOrder, tag)
	end
	
	for k = 1, moon do
		local spr = CPSprite:createWithSpriteFrameName('moon.png')
		spr:setPosition(60, ox + (k + star - 1) * w)
		iiv:addNode(spr, zOrder, tag)
	end
	
	for k = 1, sun do
		local spr = CPSprite:createWithSpriteFrameName('sun.png')
		spr:setPosition(60, ox + (k + star + moon - 1) * w)
		iiv:addNode(spr, zOrder, tag)
	end
	
	if starNum > 5 then
		addStarAnim(iiv, starNum >= 18 and 'sun%u.png' or 'moon%u.png', -100, 2.0, 8)
	end
end

function UpdateItemImageView(iiv)
	local item = iiv:GetDummyItem()
	local typeID = item:GetTypeId()
	local tipsType = iiv:GetTipsType()
	if typeID == ITEM_CLASS_EQUIPMENT then
		local starNum = item:GetStarNum()
		while true do
			local node = iiv:getNodeByTag(-10)
			if not node then break end
			iiv:removeNode(node)
		end
		AddStarLevel(iiv, starNum, 9, -10)
	elseif typeID == ITEM_CLASS_SUPPLEMENT then --符文
		if tipsType == TLT_BAG or TLT_EmbedSelect == tipsType then
			while true do
				local node = iiv:getChildByTag(-851024)
				if not node then break end
				node:removeFromParent()
			end
			local runename = ''
			local uid = iiv:GetUserData()
			local runeitem = g_Player:GetRuneItem(uid)
			if runeitem then
				runename = runeitem:getRuneColorName()
				if runeitem:bind() then
					local lockstr = UIStaticRichText:createWithString(TDGETSTRCS("SD_LOCK_TEXT"));
					lockstr:setPositionY(35)
					lockstr:setPositionX(-35)
					iiv:addChild(lockstr, 10, -851024)
				end
			end
			
			local name_ = UIStaticRichText:createWithString(runename)
			name_:setScale(0.9)
			name_:setPositionY(-iiv:getContentSize().height/3)
			name_:setPositionX(3)
			iiv:addChild(name_, 10, -851024)
		end
	end
end